/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: outline_stub1.cpp,v 1.2 2004/01/26 00:56:48 takagi-n Exp $
 */
#include <toppers/outline_stub.hpp>
#include <toppers/raw_stub.hpp>
#include <toppers/kernel.hpp>

#define	TOPPERS_SVC(svc)	raw_stub<has_svc<tfn_##svc>::value>::stub_##svc

namespace toppers
{

	ER outline_stub::call_act_tsk(ID tskid) throw()
	{
		return TOPPERS_SVC(act_tsk)(tskid);
	}
	ER_UINT outline_stub::call_can_act(ID tskid) throw()
	{
		return TOPPERS_SVC(can_act)(tskid);
	}
	void outline_stub::call_ext_tsk() throw()
	{
		TOPPERS_SVC(ext_tsk)();
	}
	ER outline_stub::call_ter_tsk(ID tskid) throw()
	{
		return TOPPERS_SVC(ter_tsk)(tskid);
	}
	ER outline_stub::call_chg_pri(ID tskid, PRI tskpri) throw()
	{
		return TOPPERS_SVC(chg_pri)(tskid, tskpri);
	}
	ER outline_stub::call_get_pri(ID tskid, PRI* p_tskpri) throw()
	{
		return TOPPERS_SVC(get_pri)(tskid, p_tskpri);
	}
	ER outline_stub::call_slp_tsk() throw()
	{
		return TOPPERS_SVC(slp_tsk)();
	}
	ER outline_stub::call_tslp_tsk(TMO tmout) throw()
	{
		return TOPPERS_SVC(tslp_tsk)(tmout);
	}
	ER outline_stub::call_wup_tsk(ID tskid) throw()
	{
		return TOPPERS_SVC(wup_tsk)(tskid);
	}
	ER_UINT outline_stub::call_can_wup(ID tskid) throw()
	{
		return TOPPERS_SVC(can_wup)(tskid);
	}
	ER outline_stub::call_rel_wai(ID tskid) throw()
	{
		return TOPPERS_SVC(rel_wai)(tskid);
	}
	ER outline_stub::call_sus_tsk(ID tskid) throw()
	{
		return TOPPERS_SVC(sus_tsk)(tskid);
	}
	ER outline_stub::call_rsm_tsk(ID tskid) throw()
	{
		return TOPPERS_SVC(rsm_tsk)(tskid);
	}
	ER outline_stub::call_frsm_tsk(ID tskid) throw()
	{
		return TOPPERS_SVC(frsm_tsk)(tskid);
	}
	ER outline_stub::call_dly_tsk(RELTIM dlytim) throw()
	{
		return TOPPERS_SVC(dly_tsk)(dlytim);
	}

}

