/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: outline_stub24.cpp,v 1.2 2004/01/26 00:56:48 takagi-n Exp $
 */
#include <toppers/outline_stub.hpp>
#include <toppers/raw_stub.hpp>
#include <toppers/kernel.hpp>

#define	TOPPERS_SVC(svc)	raw_stub<has_svc<tfn_##svc>::value>::stub_##svc

namespace toppers
{

	ER outline_stub::call_iact_tsk(ID tskid) throw()
	{
		return TOPPERS_SVC(iact_tsk)(tskid);
	}
	ER outline_stub::call_iwup_tsk(ID tskid) throw()
	{
		return TOPPERS_SVC(iwup_tsk)(tskid);
	}
	ER outline_stub::call_irel_wai(ID tskid) throw()
	{
		return TOPPERS_SVC(irel_wai)(tskid);
	}
	ER outline_stub::call_iras_tex(ID tskid, TEXPTN rasptn) throw()
	{
		return TOPPERS_SVC(iras_tex)(tskid, rasptn);
	}
	ER outline_stub::call_isig_sem(ID semid) throw()
	{
		return TOPPERS_SVC(isig_sem)(semid);
	}
	ER outline_stub::call_iset_flg(ID flgid, FLGPTN setptn) throw()
	{
		return TOPPERS_SVC(iset_flg)(flgid, setptn);
	}
	ER outline_stub::call_ipsnd_dtq(ID dtqid, VP_INT data) throw()
	{
		return TOPPERS_SVC(ipsnd_dtq)(dtqid, data);
	}
	ER outline_stub::call_ifsnd_dtq(ID dtqid, VP_INT data) throw()
	{
		return TOPPERS_SVC(ifsnd_dtq)(dtqid, data);
	}
	ER outline_stub::call_irot_rdq(PRI tskpri) throw()
	{
		return TOPPERS_SVC(irot_rdq)(tskpri);
	}
	ER outline_stub::call_iget_tid(ID* p_tskid) throw()
	{
		return TOPPERS_SVC(iget_tid)(p_tskid);
	}
	ER outline_stub::call_iloc_cpu() throw()
	{
		return TOPPERS_SVC(iloc_cpu)();
	}
	ER outline_stub::call_iunl_cpu() throw()
	{
		return TOPPERS_SVC(iunl_cpu)();
	}
	ER outline_stub::call_isig_tim() throw()
	{
		return TOPPERS_SVC(isig_tim)();
	}

}

