/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: outline_stub25.cpp,v 1.2 2004/01/26 00:56:48 takagi-n Exp $
 */
#include <toppers/outline_stub.hpp>
#include <toppers/raw_stub.hpp>
#include <toppers/kernel.hpp>

#define	TOPPERS_SVC(svc)	raw_stub<has_svc<tfn_##svc>::value>::stub_##svc

namespace toppers
{

	ER outline_stub::call_cre_mtx(ID mtxid, t_cmtx* pk_cmtx) throw()
	{
		return TOPPERS_SVC(cre_mtx)(mtxid, pk_cmtx);
	}
	ER outline_stub::call_cre_mtx(ID mtxid, const t_cmtx* pk_cmtx) throw()
	{
		return TOPPERS_SVC(cre_mtx)(mtxid, pk_cmtx);
	}
	ER outline_stub::call_del_mtx(ID mtxid) throw()
	{
		return TOPPERS_SVC(del_mtx)(mtxid);
	}
	ER outline_stub::call_unl_mtx(ID mtxid) throw()
	{
		return TOPPERS_SVC(unl_mtx)(mtxid);
	}
	ER outline_stub::call_loc_mtx(ID mtxid) throw()
	{
		return TOPPERS_SVC(loc_mtx)(mtxid);
	}
	ER outline_stub::call_ploc_mtx(ID mtxid) throw()
	{
		return TOPPERS_SVC(ploc_mtx)(mtxid);
	}
	ER outline_stub::call_tloc_mtx(ID mtxid, TMO tmout) throw()
	{
		return TOPPERS_SVC(tloc_mtx)(mtxid, tmout);
	}
	ER outline_stub::call_ref_mtx(ID mtxid, t_rmtx* pk_rmtx) throw()
	{
		return TOPPERS_SVC(ref_mtx)(mtxid, pk_rmtx);
	}
	ER_ID outline_stub::call_acre_mtx(t_cmtx* pk_cmtx) throw()
	{
		return TOPPERS_SVC(acre_mtx)(pk_cmtx);
	}
	ER_ID outline_stub::call_acre_mtx(const t_cmtx* pk_cmtx) throw()
	{
		return TOPPERS_SVC(acre_mtx)(pk_cmtx);
	}

}

