/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: outline_stub26.cpp,v 1.2 2004/01/26 00:56:48 takagi-n Exp $
 */
#include <toppers/outline_stub.hpp>
#include <toppers/raw_stub.hpp>
#include <toppers/kernel.hpp>

#define	TOPPERS_SVC(svc)	raw_stub<has_svc<tfn_##svc>::value>::stub_##svc

namespace toppers
{

	ER outline_stub::call_cre_mbf(ID mbfid, t_cmbf* pk_cmbf) throw()
	{
		return TOPPERS_SVC(cre_mbf)(mbfid, pk_cmbf);
	}
	ER outline_stub::call_cre_mbf(ID mbfid, const t_cmbf* pk_cmbf) throw()
	{
		return TOPPERS_SVC(cre_mbf)(mbfid, pk_cmbf);
	}
	ER outline_stub::call_del_mbf(ID mbfid) throw()
	{
		return TOPPERS_SVC(del_mbf)(mbfid);
	}
	ER outline_stub::call_snd_mbf(ID mbfid, const void* msg, UINT msgsz) throw()
	{
		return TOPPERS_SVC(snd_mbf)(mbfid, msg, msgsz);
	}
	ER outline_stub::call_psnd_mbf(ID mbfid, const void* msg, UINT msgsz) throw()
	{
		return TOPPERS_SVC(psnd_mbf)(mbfid, msg, msgsz);
	}
	ER outline_stub::call_tsnd_mbf(ID mbfid, const void* msg, UINT msgsz, TMO tmout) throw()
	{
		return TOPPERS_SVC(tsnd_mbf)(mbfid, msg, msgsz, tmout);
	}
	ER_UINT outline_stub::call_rcv_mbf(ID mbfid, void* msg) throw()
	{
		return TOPPERS_SVC(rcv_mbf)(mbfid, msg);
	}
	ER_UINT outline_stub::call_prcv_mbf(ID mbfid, void* msg) throw()
	{
		return TOPPERS_SVC(prcv_mbf)(mbfid, msg);
	}
	ER_UINT outline_stub::call_trcv_mbf(ID mbfid, void* msg, TMO tmout) throw()
	{
		return TOPPERS_SVC(trcv_mbf)(mbfid, msg, tmout);
	}
	ER outline_stub::call_ref_mbf(ID mbfid, t_rmbf* pk_rmbf) throw()
	{
		return TOPPERS_SVC(ref_mbf)(mbfid, pk_rmbf);
	}
	ER_ID outline_stub::call_acre_mbf(t_cmbf* pk_cmbf) throw()
	{
		return TOPPERS_SVC(acre_mbf)(pk_cmbf);
	}
	ER_ID outline_stub::call_acre_mbf(const t_cmbf* pk_cmbf) throw()
	{
		return TOPPERS_SVC(acre_mbf)(pk_cmbf);
	}

}

