/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: outline_stub27.cpp,v 1.2 2004/01/26 00:56:48 takagi-n Exp $
 */
#include <toppers/outline_stub.hpp>
#include <toppers/raw_stub.hpp>
#include <toppers/kernel.hpp>

#define	TOPPERS_SVC(svc)	raw_stub<has_svc<tfn_##svc>::value>::stub_##svc

namespace toppers
{

	ER outline_stub::call_cre_por(ID porid, t_cpor* pk_cpor) throw()
	{
		return TOPPERS_SVC(cre_por)(porid, pk_cpor);
	}
	ER outline_stub::call_cre_por(ID porid, const t_cpor* pk_cpor) throw()
	{
		return TOPPERS_SVC(cre_por)(porid, pk_cpor);
	}
	ER outline_stub::call_del_por(ID porid) throw()
	{
		return TOPPERS_SVC(del_por)(porid);
	}
	ER_UINT outline_stub::call_cal_por(ID porid, RDVPTN calptn, void* msg, UINT cmsgsz) throw()
	{
		return TOPPERS_SVC(cal_por)(porid, calptn, msg, cmsgsz);
	}
	ER_UINT outline_stub::call_tcal_por(ID porid, RDVPTN calptn, void* msg, UINT cmsgsz, TMO tmout) throw()
	{
		return TOPPERS_SVC(tcal_por)(porid, calptn, msg, cmsgsz, tmout);
	}
	ER_UINT outline_stub::call_acp_por(ID porid, RDVPTN acpptn, RDVNO* p_rdvno, void* msg) throw()
	{
		return TOPPERS_SVC(acp_por)(porid, acpptn, p_rdvno, msg);
	}
	ER_UINT outline_stub::call_pacp_por(ID porid, RDVPTN acpptn, RDVNO* p_rdvno, void* msg) throw()
	{
		return TOPPERS_SVC(pacp_por)(porid, acpptn, p_rdvno, msg);
	}
	ER_UINT outline_stub::call_tacp_por(ID porid, RDVPTN acpptn, RDVNO* p_rdvno, void* msg, TMO tmout) throw()
	{
		return TOPPERS_SVC(tacp_por)(porid, acpptn, p_rdvno, msg, tmout);
	}
	ER outline_stub::call_fwd_por(ID porid, RDVPTN acpptn, RDVNO rdvno, const void* msg, UINT cmsgsz) throw()
	{
		return TOPPERS_SVC(fwd_por)(porid, acpptn, rdvno, msg, cmsgsz);
	}
	ER outline_stub::call_rpl_rdv(RDVNO rdvno, const void* msg, UINT rmsgsz) throw()
	{
		return TOPPERS_SVC(rpl_rdv)(rdvno, msg, rmsgsz);
	}
	ER outline_stub::call_ref_por(ID porid, t_rpor* pk_rpor) throw()
	{
		return TOPPERS_SVC(ref_por)(porid, pk_rpor);
	}
	ER outline_stub::call_ref_rdv(RDVNO rdvid, t_rrdv* pk_rrdv) throw()
	{
		return TOPPERS_SVC(ref_rdv)(rdvid, pk_rrdv);
	}
	ER_ID outline_stub::call_acre_por(t_cpor* pk_cpor) throw()
	{
		return TOPPERS_SVC(acre_por)(pk_cpor);
	}
	ER_ID outline_stub::call_acre_por(const t_cpor* pk_cpor) throw()
	{
		return TOPPERS_SVC(acre_por)(pk_cpor);
	}

}

