/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: outline_stub7.cpp,v 1.2 2004/01/26 00:56:48 takagi-n Exp $
 */
#include <toppers/outline_stub.hpp>
#include <toppers/raw_stub.hpp>
#include <toppers/kernel.hpp>

#define	TOPPERS_SVC(svc)	raw_stub<has_svc<tfn_##svc>::value>::stub_##svc

namespace toppers
{

	ER outline_stub::call_set_flg(ID flgid, FLGPTN setptn) throw()
	{
		return TOPPERS_SVC(set_flg)(flgid, setptn);
	}
	ER outline_stub::call_clr_flg(ID flgid, FLGPTN clrptn) throw()
	{
		return TOPPERS_SVC(clr_flg)(flgid, clrptn);
	}
	ER outline_stub::call_wai_flg(ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN* p_flgptn) throw()
	{
		return TOPPERS_SVC(wai_flg)(flgid, waiptn, wfmode, p_flgptn);
	}
	ER outline_stub::call_pol_flg(ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN* p_flgptn) throw()
	{
		return TOPPERS_SVC(pol_flg)(flgid, waiptn, wfmode, p_flgptn);
	}
	ER outline_stub::call_twai_flg(ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN* p_flgptn, TMO tmout) throw()
	{
		return TOPPERS_SVC(twai_flg)(flgid, waiptn, wfmode, p_flgptn, tmout);
	}

}

