/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: test.cpp,v 1.3 2004/01/26 00:53:45 takagi-n Exp $
 */
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "test.hpp"

void test_alm();
void test_cyc();
void test_dtq();
void test_exc();
void test_flg();
void test_int();
void test_knl();
void test_mbf();
void test_mbx();
void test_mpf();
void test_mpl();
void test_mtx();
void test_ovr();
void test_por();
void test_stub();
void test_sem();
void test_tex();
void test_tsk();
void test_trace();
void test_alloc();
void test_sync();

int main(int argc, char* argv[])
{
	const char* filename = "nul";
	if (argc > 1)
	{
		filename = argv[1];
	}

	FILE* file = freopen(filename, "w", stdout);
	if (file == 0)
	{
		perror("Error");
		return EXIT_FAILURE;
	}

	init_cxxrt();

	test_stub();
	test_alm();
	test_cyc();
	test_dtq();
	test_exc();
	test_flg();
	test_int();
	test_knl();
	test_mbf();
	test_mbx();
	test_mpf();
	test_mpl();
	test_mtx();
	test_ovr();
	test_por();
	test_sem();
	test_tex();
	test_tsk();
	test_trace();
	test_alloc();
	test_sync();
	fprintf(stderr, "\n===== test end =====\n");
	return 0;
}

void verify(const char *file, int line, const char* log)
{
	if (strcmp(log, (const char*)test_params[0]) == 0)
		return;

	fflush(stdout);
	fprintf(stderr, "\a\nError: %s:%d verify error \"%s\"\n", file, line, (const char*)test_params[0]);
	exit(3);
}

void verify(const char *file, int line, const char* syscall_name, int arity, VP_INT par1, VP_INT par2, VP_INT par3, VP_INT par4, VP_INT par5, VP_INT par6)
{
	const char* cause = "";
	const char* cause2 = "";
	if (strcmp(syscall_name, ::syscall_name) != 0)
	{
		cause = "syscall name is not match: ";
		cause2 = ::syscall_name;
		goto error;
	}
	if (arity != ::arity)
	{
		cause = "arity is not match";
		goto error;
	}
	if (arity >= 1 && par1 != test_params[0])
	{
		cause = "parameter1 is not match";
		goto error;
	}
	if (arity >= 2 && par2 != test_params[1])
	{
		cause = "parameter2 is not match";
		goto error;
	}
	if (arity >= 3 && par3 != test_params[2])
	{
		cause = "parameter3 is not match";
		goto error;
	}
	if (arity >= 4 && par4 != test_params[3])
	{
		cause = "parameter4 is not match";
		goto error;
	}
	if (arity >= 5 && par5 != test_params[4])
	{
		cause = "parameter5 is not match";
		goto error;
	}
	if (arity >= 6 && par6 != test_params[5])
	{
		cause = "parameter6 is not match";
		goto error;
	}
	return;
error:
	fflush(stdout);
	fprintf(stderr, "\a\nError: %s:%d %s %s\n", file, line, cause, cause2);
	exit(3);
}

