/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: test.hpp,v 1.3 2004/01/26 00:53:45 takagi-n Exp $
 */
#ifndef	TEST_HPP
#define	TEST_HPP

#include <itron.h>
#include <stdlib.h>
#include <stdio.h>

extern "C" {

extern const char *syscall_name;
extern VP_INT test_params[6];
extern int arity;

}

struct tracer
{
	tracer()
	{
		puts("tracer::tracer();");
	}
	~tracer()
	{
		puts("tracer::~tracer();");
	}
	tracer(const tracer& other)
	{
		puts("tracer::tracer(other);");
	}
	tracer& operator=(const tracer& other)
	{
		puts("tracer::operator=(other);");
	}
};

extern "C" {
	void set_test_context(BOOL ctx) throw();
	void init_cxxrt(void) throw();
}

void verify(const char* file, int line, const char* log);
void verify(const char* file, int line, const char* syscall_name, int arity, VP_INT par1 = 0, VP_INT par2 = 0, VP_INT par3 = 0, VP_INT par4 = 0, VP_INT par5 = 0, VP_INT par6 = 0);

#define	TEST_EXP(exp)	printf(#exp "\t:\t"); exp
#define	VERIFY(log)		verify(__FILE__, __LINE__, log)
#define	VERIFY0(syscall)	verify(__FILE__, __LINE__, syscall, 0)
#define	VERIFY1(syscall, par1)	verify(__FILE__, __LINE__, syscall, 1, (VP_INT)par1)
#define	VERIFY2(syscall, par1, par2)	verify(__FILE__, __LINE__, syscall, 2, (VP_INT)par1, (VP_INT)par2)
#define	VERIFY3(syscall, par1, par2, par3)	verify(__FILE__, __LINE__, syscall, 3, (VP_INT)par1, (VP_INT)par2, (VP_INT)par3)
#define	VERIFY4(syscall, par1, par2, par3, par4)	verify(__FILE__, __LINE__, syscall, 4, (VP_INT)par1, (VP_INT)par2, (VP_INT)par3, (VP_INT)par4)
#define	VERIFY5(syscall, par1, par2, par3, par4, par5)	verify(__FILE__, __LINE__, syscall, 5, (VP_INT)par1, (VP_INT)par2, (VP_INT)par3, (VP_INT)par4, (VP_INT)par5)
#define	VERIFY6(syscall, par1, par2, par3, par4, par5, par6)	verify(__FILE__, __LINE__, syscall, 6, (VP_INT)par1, (VP_INT)par2, (VP_INT)par3, (VP_INT)par4, (VP_INT)par5, (VP_INT)par6)

#define	ASSERT(exp)		do { if (!(exp)) { fprintf(stderr, "\n\aError: %s:%d [%s] is false\n", __FILE__, __LINE__, #exp); exit(3); } } while (0)

#endif	// ! TEST_HPP
