/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: test_alloc.cpp,v 1.3 2004/01/26 00:53:45 takagi-n Exp $
 */
#include <toppers/allocator.hpp>
#include <toppers/fmempool.hpp>
#include <toppers/vmempool.hpp>
#include "test.hpp"

namespace {

	class foo1 : public toppers::fixed_sized_new<foo1, toppers::fmempool<1> >
	{
	};

	class foo2 : public toppers::fixed_sized_new<foo2, toppers::vmempool<1> >
	{
	};

	class foo3 : public toppers::fixed_sized_new<foo3, toppers::fixed_simple_pool<32, 8> >
	{
		long data;
	public:
		foo3() : data(0) {}
	};

	class foo4 : public toppers::variable_sized_new<foo3, toppers::variable_simple_pool<> >
	{
		long data;
	public:
		foo4() : data(0) {}
	};

}

void test_alloc()
{
	fputs("----- test allocator -----\n", stderr);
	{
		fputs("[fixed_sized_new<\?, toppers::fmempool<1> >] ", stderr);
		foo1* p = new foo1;
		VERIFY2("get_mpf", 1, test_params[1]);
		ASSERT(p != 0);
		delete p;
		VERIFY2("rel_mpf", 1, p);
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[fixed_sized_new<\?, toppers::vmempool<1> >] ", stderr);
		foo2* p = new foo2;
		VERIFY3("get_mpl", 1, toppers::rounded_sizeof<foo2>::value, test_params[2]);
		ASSERT(p != 0);
		delete p;
		VERIFY2("rel_mpl", 1, p);
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[fixed_sized_new<\?, toppers::fixed_simple_pool<32, 8> >] ", stderr);
		foo3* p = new foo3;
		ASSERT(p != 0);
		delete p;
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[fixed_sized_new<\?, toppers::variable_simple_pool<> >] ", stderr);
		foo4* p = new foo4[4];
		ASSERT(p != 0);
		delete[] p;
		fputs("-- ok\n", stderr);
	}
}

