/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: test_alm.cpp,v 1.1 2004/01/16 01:38:28 takagi-n Exp $
 */
#include <toppers/alarmhandler.hpp>
#include "test.hpp"

namespace
{

	class body : public toppers::alarmhandler_body<>
	{
		typedef	toppers::alarmhandler_body<>	super;
	public:
		explicit body(VP_INT exinf) : super(exinf) {}
		void run()
		{
			tracer t;
			VP_INT exinf = get_extended_info();
			ASSERT(exinf == VP_INT(123));
			printf("exinf = %p\n", exinf);
		}
	};

}

void test_alm()
{
	fputs("----- test alarmhandler -----\n", stderr);
	{
		fputs("[alarmhandler<>] ", stderr);
		typedef	toppers::alarmhandler<>	alarmhandler;
		TEST_EXP(alarmhandler alm(10));
		ID almid = get_unsafe_id(alm);
		printf("almid = %d\n" , almid);
		TEST_EXP(alm.create<body>());
		VERIFY1("acre_alm", test_params[0]);
		almid = get_unsafe_id(alm);
		printf("almid = %d\n" , almid);
		alarmhandler::reference pk_ralm[1];
		TEST_EXP(alm.refer(pk_ralm));
		VERIFY2("ref_alm", almid, pk_ralm);
		TEST_EXP(alm.start(0x123));
		VERIFY2("sta_alm", almid, 0x123);
		TEST_EXP(alm.stop());
		VERIFY1("stp_alm", almid);
		TEST_EXP(alm.destroy());
		VERIFY1("del_alm", almid);
		printf("almid = %d\n" , get_unsafe_id(alm));
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[alarmhandler<1>] ", stderr);
		typedef	toppers::alarmhandler<1>	alarmhandler;
		TEST_EXP(alarmhandler alm);
		ID almid = get_unsafe_id(alm);
		printf("almid = %d\n" , almid);
		TEST_EXP(alm.create<body>());
		VERIFY2("cre_alm", 1, test_params[1]);
		almid = get_unsafe_id(alm);
		printf("almid = %d\n" , almid);
		alarmhandler::reference pk_ralm[1];
		TEST_EXP(alm.refer(pk_ralm));
		VERIFY2("ref_alm", almid, pk_ralm);
		TEST_EXP(alm.start(0x123));
		VERIFY2("sta_alm", almid, 0x123);
		TEST_EXP(alm.stop());
		VERIFY1("stp_alm", almid);
		TEST_EXP(alm.destroy());
		VERIFY1("del_alm", almid);
		printf("almid = %d\n" , get_unsafe_id(alm));
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[alarmhandler body] ", stderr);
		set_test_context(TRUE);
		toppers::alarmhandler_entry<body>((VP_INT)(123));
		fputs("-- ok\n", stderr);
	}
}

