/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: test_cyc.cpp,v 1.1 2004/01/16 01:38:28 takagi-n Exp $
 */
#include <toppers/cyclichandler.hpp>
#include "test.hpp"

namespace {

	class body : public toppers::cyclichandler_body<>
	{
		typedef	toppers::cyclichandler_body<>	super;
	public:
		explicit body(VP_INT exinf) : super(exinf) {}
		void run()
		{
			tracer t;
			VP_INT exinf = get_extended_info();
			ASSERT(exinf == VP_INT(123));
			printf("exinf = %p\n", exinf);
		}
	};

}

void test_cyc()
{
	fputs("----- test cyclichandler -----\n", stderr);
	{
		fputs("[cyclichandler<>] ", stderr);
		typedef	toppers::cyclichandler<>	cyclichandler;
		TEST_EXP(cyclichandler cyc(10));
		ID cycid = get_unsafe_id(cyc);
		printf("cycid = %d\n", cycid);
		TEST_EXP(cyc.create<body>());
		VERIFY1("acre_cyc", test_params[0]);
		cycid = get_unsafe_id(cyc);
		printf("cycid = %d\n", cycid);
		cyclichandler::reference pk_rcyc[1];
		TEST_EXP(cyc.refer(pk_rcyc));
		VERIFY2("ref_cyc", cycid, pk_rcyc);
		TEST_EXP(cyc.start());
		VERIFY1("sta_cyc", cycid);
		TEST_EXP(cyc.stop());
		VERIFY1("stp_cyc", cycid);
		TEST_EXP(cyc.destroy());
		VERIFY1("del_cyc", cycid);
		printf("cycid = %d\n" , get_unsafe_id(cyc));
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[cyclichandler<1>] ", stderr);
		typedef	toppers::cyclichandler<1>	cyclichandler;
		TEST_EXP(cyclichandler cyc);
		ID cycid = get_unsafe_id(cyc);
		printf("cycid = %d\n", cycid);
		TEST_EXP(cyc.create<body>());
		VERIFY2("cre_cyc", cycid, test_params[1]);
		cycid = get_unsafe_id(cyc);
		printf("cycid = %d\n", cycid);
		cyclichandler::reference pk_rcyc[1];
		TEST_EXP(cyc.refer(pk_rcyc));
		VERIFY2("ref_cyc", cycid, pk_rcyc);
		TEST_EXP(cyc.start());
		VERIFY1("sta_cyc", cycid);
		TEST_EXP(cyc.stop());
		VERIFY1("stp_cyc", cycid);
		TEST_EXP(cyc.destroy());
		VERIFY1("del_cyc", cycid);
		printf("cycid = %d\n" , get_unsafe_id(cyc));
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[cyclichandler body] ", stderr);
		set_test_context(TRUE);
		toppers::cyclichandler_entry<body>((VP_INT)(123));
		fputs("-- ok\n", stderr);
	}
}

