/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: test_dtq.cpp,v 1.1 2004/01/16 01:38:28 takagi-n Exp $
 */
#include <toppers/dataqueue.hpp>
#include "test.hpp"

void test_dtq()
{
	fputs("----- test dataqueue -----\n", stderr);
	{
		fputs("[dataqueue<>] ", stderr);
		typedef	toppers::dataqueue<>	dataqueue;
		TEST_EXP(dataqueue dtq(10));
		ID dtqid = get_unsafe_id(dtq);
		printf("dtqid = %d\n", dtqid);
		TEST_EXP(dtq.create(TA_TFIFO));
		VERIFY1("acre_dtq", test_params[0]);
		dtqid = get_unsafe_id(dtq);
		printf("dtqid = %d\n", dtqid);
		dataqueue::reference pk_rdtq[1];
		TEST_EXP(dtq.refer(pk_rdtq));
		VERIFY2("ref_dtq", dtqid, pk_rdtq);
		TEST_EXP(dtq.send(VP_INT(0x1234)));
		VERIFY2("snd_dtq", dtqid, 0x1234);
		TEST_EXP(dtq.send(VP_INT(0x1234), toppers::polling));
		VERIFY2("psnd_dtq", dtqid, 0x1234);
		TEST_EXP(dtq.send(VP_INT(0x1234), toppers::polling, toppers::non_task_context));
		VERIFY2("ipsnd_dtq", dtqid, 0x1234);
		set_test_context(TRUE);
		TEST_EXP(dtq.send(VP_INT(0x1234), toppers::polling, toppers::context_independent));
		VERIFY2("ipsnd_dtq", dtqid, 0x1234);
		set_test_context(FALSE);
		TEST_EXP(dtq.send(VP_INT(0x1234), toppers::polling, toppers::context_independent));
		VERIFY2("psnd_dtq", dtqid, 0x1234);
		TEST_EXP(dtq.send(VP_INT(0x1234), toppers::forced));
		VERIFY2("fsnd_dtq", dtqid, 0x1234);
		TEST_EXP(dtq.send(VP_INT(0x1234), 100));
		VERIFY3("tsnd_dtq", dtqid, 0x1234, 100);
		VP_INT data;
		TEST_EXP(dtq.receive(&data));
		VERIFY2("rcv_dtq", dtqid, &data);
		TEST_EXP(dtq.receive(&data, toppers::polling));
		VERIFY2("prcv_dtq", dtqid, &data);
		TEST_EXP(dtq.receive(&data, 100));
		VERIFY3("trcv_dtq", dtqid, &data, 100);
		printf("dtqid = %d\n" , get_unsafe_id(dtq));
		TEST_EXP(dtq.destroy());
		VERIFY1("del_dtq", dtqid);
		printf("dtqid = %d\n" , get_unsafe_id(dtq));
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[dataqueue<1>] ", stderr);
		typedef	toppers::dataqueue<1>	dataqueue;
		TEST_EXP(dataqueue dtq);
		ID dtqid = get_unsafe_id(dtq);
		printf("dtqid = %d\n", dtqid);
		TEST_EXP(dtq.create(TA_TFIFO));
		VERIFY2("cre_dtq", dtqid, test_params[1]);
		dtqid = get_unsafe_id(dtq);
		printf("dtqid = %d\n", dtqid);
		dataqueue::reference pk_rdtq[1];
		TEST_EXP(dtq.refer(pk_rdtq));
		VERIFY2("ref_dtq", dtqid, pk_rdtq);
		TEST_EXP(dtq.send(VP_INT(0x1234)));
		VERIFY2("snd_dtq", dtqid, 0x1234);
		TEST_EXP(dtq.send(VP_INT(0x1234), toppers::polling));
		VERIFY2("psnd_dtq", dtqid, 0x1234);
		TEST_EXP(dtq.send(VP_INT(0x1234), toppers::polling, toppers::non_task_context));
		VERIFY2("ipsnd_dtq", dtqid, 0x1234);
		set_test_context(TRUE);
		TEST_EXP(dtq.send(VP_INT(0x1234), toppers::polling, toppers::context_independent));
		VERIFY2("ipsnd_dtq", dtqid, 0x1234);
		set_test_context(FALSE);
		TEST_EXP(dtq.send(VP_INT(0x1234), toppers::polling, toppers::context_independent));
		VERIFY2("psnd_dtq", dtqid, 0x1234);
		TEST_EXP(dtq.send(VP_INT(0x1234), toppers::forced));
		VERIFY2("fsnd_dtq", dtqid, 0x1234);
		TEST_EXP(dtq.send(VP_INT(0x1234), 100));
		VERIFY3("tsnd_dtq", dtqid, 0x1234, 100);
		VP_INT data;
		TEST_EXP(dtq.receive(&data));
		VERIFY2("rcv_dtq", dtqid, &data);
		TEST_EXP(dtq.receive(&data, toppers::polling));
		VERIFY2("prcv_dtq", dtqid, &data);
		TEST_EXP(dtq.receive(&data, 100));
		VERIFY3("trcv_dtq", dtqid, &data, 100);
		printf("dtqid = %d\n" , get_unsafe_id(dtq));
		TEST_EXP(dtq.destroy());
		VERIFY1("del_dtq", dtqid);
		printf("dtqid = %d\n" , get_unsafe_id(dtq));
		fputs("-- ok\n", stderr);
	}
}

