/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: test_exc.cpp,v 1.1 2004/01/16 01:38:28 takagi-n Exp $
 */
#include <toppers/cpuexception.hpp>
#include "test.hpp"

namespace {

	class body : public toppers::cpuexception_body<>
	{
		typedef	toppers::cpuexception_body<>	super;
	public:
		explicit body(VP_INT exinf) : super(exinf) {}
		void run()
		{
			tracer t;
			VP_INT exinf = get_extended_info();
			ASSERT(exinf == VP_INT(123));
			printf("exinf = %p\n", exinf);
		}
	};

}

void test_exc()
{
	fputs("----- test cpuexception -----\n", stderr);
	{
		fputs("[cpuexception<>] ", stderr);
		typedef	toppers::cpuexception<>	cpuexception;
		TEST_EXP(cpuexception::define<body>(5));
		VERIFY2("def_exc", 5, test_params[1]);
		TEST_EXP(cpuexception::undefine(5));
		VERIFY2("def_exc", 5, 0);
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[cpuexception body] ", stderr);
		set_test_context(TRUE);
		toppers::cpuexception_entry<body>((VP_INT)(123));
		fputs("-- ok\n", stderr);
	}
}

