/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: test_flg.cpp,v 1.1 2004/01/16 01:38:28 takagi-n Exp $
 */
#include <toppers/eventflag.hpp>
#include "test.hpp"

void test_flg()
{
	fputs("----- test eventflag -----\n", stderr);
	{
		fputs("[eventflag<>] ", stderr);
		typedef	toppers::eventflag<>	eventflag;
		TEST_EXP(eventflag flg(10));
		ID flgid = get_unsafe_id(flg);
		printf("flgid = %d\n", flgid);
		TEST_EXP(flg.create());
		VERIFY1("acre_flg", test_params[0]);
		flgid = get_unsafe_id(flg);
		printf("flgid = %d\n", flgid);
		eventflag::reference pk_rflg[1];
		TEST_EXP(flg.refer(pk_rflg));
		VERIFY2("ref_flg", flgid, pk_rflg);
		TEST_EXP(flg.set(0x1111));
		VERIFY2("set_flg", flgid, 0x1111);
		TEST_EXP(flg.set(0x1111, toppers::non_task_context));
		VERIFY2("iset_flg", flgid, 0x1111);
		set_test_context(TRUE);
		TEST_EXP(flg.set(0x1111, toppers::context_independent));
		VERIFY2("iset_flg", flgid, 0x1111);
		set_test_context(FALSE);
		TEST_EXP(flg.set(0x1111, toppers::context_independent));
		VERIFY2("set_flg", flgid, 0x1111);
		TEST_EXP(flg.clear(0x1111));
		VERIFY2("clr_flg", flgid, 0x1111);
		FLGPTN	flgptn;
		TEST_EXP(flg.wait(0x1111, TWF_ANDW, &flgptn));
		VERIFY4("wai_flg", flgid, 0x1111, TWF_ANDW, &flgptn);
		TEST_EXP(flg.wait(0x1111, TWF_ANDW, &flgptn, toppers::polling));
		VERIFY4("pol_flg", flgid, 0x1111, TWF_ANDW, &flgptn);
		TEST_EXP(flg.wait(0x1111, TWF_ANDW, &flgptn, 100));
		VERIFY5("twai_flg", flgid, 0x1111, TWF_ANDW, &flgptn, 100);
		TEST_EXP(flg.destroy());
		VERIFY1("del_flg", flgid);
		printf("flgid = %d\n" , get_unsafe_id(flg));
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[eventflag<1>] ", stderr);
		typedef	toppers::eventflag<1>	eventflag;
		TEST_EXP(eventflag flg);
		ID flgid = get_unsafe_id(flg);
		printf("flgid = %d\n", flgid);
		TEST_EXP(flg.create());
		VERIFY2("cre_flg", flgid, test_params[1]);
		flgid = get_unsafe_id(flg);
		printf("flgid = %d\n", flgid);
		eventflag::reference pk_rflg[1];
		TEST_EXP(flg.refer(pk_rflg));
		VERIFY2("ref_flg", flgid, pk_rflg);
		TEST_EXP(flg.set(0x1111));
		VERIFY2("set_flg", flgid, 0x1111);
		TEST_EXP(flg.set(0x1111, toppers::non_task_context));
		VERIFY2("iset_flg", flgid, 0x1111);
		set_test_context(TRUE);
		TEST_EXP(flg.set(0x1111, toppers::context_independent));
		VERIFY2("iset_flg", flgid, 0x1111);
		set_test_context(FALSE);
		TEST_EXP(flg.set(0x1111, toppers::context_independent));
		VERIFY2("set_flg", flgid, 0x1111);
		TEST_EXP(flg.clear(0x1111));
		VERIFY2("clr_flg", flgid, 0x1111);
		FLGPTN	flgptn;
		TEST_EXP(flg.wait(0x1111, TWF_ANDW, &flgptn));
		VERIFY4("wai_flg", flgid, 0x1111, TWF_ANDW, &flgptn);
		TEST_EXP(flg.wait(0x1111, TWF_ANDW, &flgptn, toppers::polling));
		VERIFY4("pol_flg", flgid, 0x1111, TWF_ANDW, &flgptn);
		TEST_EXP(flg.wait(0x1111, TWF_ANDW, &flgptn, 100));
		VERIFY5("twai_flg", flgid, 0x1111, TWF_ANDW, &flgptn, 100);
		TEST_EXP(flg.destroy());
		VERIFY1("del_flg", flgid);
		printf("flgid = %d\n" , get_unsafe_id(flg));
		fputs("-- ok\n", stderr);
	}
}

