/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: test_int.cpp,v 1.1 2004/01/16 01:38:28 takagi-n Exp $
 */
#include <toppers/interrupt.hpp>
#include "test.hpp"

namespace {

	class inhbody : public toppers::interrupthandler_body<>
	{
		typedef	toppers::interrupthandler_body<>	super;
	public:
		void run()
		{
			tracer t;
		}
	};

	class isrbody : public toppers::isr_body<>
	{
		typedef	toppers::isr_body<>	super;
	public:
		explicit isrbody(VP_INT exinf) : super(exinf) {}
		void run()
		{
			tracer t;
			VP_INT exinf = get_extended_info();
			ASSERT(exinf == VP_INT(123));
			printf("exinf = %p\n", exinf);
		}
	};

}

void test_int()
{
	fputs("----- test interrupt -----\n", stderr);
	{
		fputs("[interrupthandler<>] ", stderr);
		typedef	toppers::interrupthandler<>	interrupthandler;
		typedef	toppers::interrupt<>	interrupt;
		interrupthandler::definition pk_dinh[1];
		TEST_EXP(interrupthandler::define(5, pk_dinh));
		VERIFY2("def_inh", 5, pk_dinh);
		TEST_EXP(interrupthandler::define(5, (const t_dinh*)pk_dinh));
		VERIFY2("def_inh", 5, pk_dinh);
		TEST_EXP(interrupthandler::define(5, 3, toppers::interrupthandler_entry<inhbody>));
		VERIFY2("def_inh", 5, test_params[1]);
		TEST_EXP(interrupthandler::define<inhbody>(5, 3));
		VERIFY2("def_inh", 5, test_params[1]);
		TEST_EXP(interrupthandler::undefine(5));
		VERIFY2("def_inh", 5, 0);
		TEST_EXP(interrupt::disable(5));
		VERIFY1("dis_int", 5);
		TEST_EXP(interrupt::enable(5));
		VERIFY1("ena_int", 5);
		TEST_EXP(interrupt::change_mask(0x1111));
		VERIFY1("chg_ipm", 0x1111);
		IMS p_ims[1];
		TEST_EXP(interrupt::get_mask(p_ims));
		VERIFY1("get_ipm", p_ims);
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[interrupthandler body] ", stderr);
		toppers::interrupthandler_entry<inhbody>();
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[isr<>] ", stderr);
		TEST_EXP(toppers::isr<> isr(10));
		toppers::isr<>::creation  pk_cisr[1];
		TEST_EXP(isr.create(pk_cisr));
		VERIFY1("acre_isr", pk_cisr);
		TEST_EXP(isr.create((const t_cisr*)pk_cisr));
		VERIFY1("acre_isr", pk_cisr);
		TEST_EXP(isr.create(0, 0, 0, toppers::isr_entry<isrbody>));
		VERIFY1("acre_isr", test_params[0]);
		ID isrid = get_unsafe_id(isr);
		printf("isrid = %d\n", isrid);
		toppers::isr<>::reference pk_risr[1];
		TEST_EXP(isr.refer(pk_risr));
		VERIFY2("ref_isr", isrid, pk_risr);
		TEST_EXP(isr.destroy());
		VERIFY1("del_isr", isrid);
		printf("isrid = %d\n", get_unsafe_id(isr));
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[isr<1>] ", stderr);
		TEST_EXP(toppers::isr<1> isr);
		toppers::isr<1>::creation  pk_cisr[1];
		TEST_EXP(isr.create(pk_cisr));
		VERIFY2("cre_isr", 1, pk_cisr);
		TEST_EXP(isr.create((const t_cisr*)pk_cisr));
		VERIFY2("cre_isr", 1, pk_cisr);
		TEST_EXP(isr.create(0, 0, 0, toppers::isr_entry<isrbody>));
		VERIFY2("cre_isr", 1, test_params[1]);
		ID isrid = get_unsafe_id(isr);
		printf("isrid = %d\n", isrid);
		toppers::isr<>::reference pk_risr[1];
		TEST_EXP(isr.refer(pk_risr));
		VERIFY2("ref_isr", isrid, pk_risr);
		TEST_EXP(isr.destroy());
		VERIFY1("del_isr", isrid);
		printf("isrid = %d\n", get_unsafe_id(isr));
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[isr body] ", stderr);
		toppers::isr_entry<isrbody>((VP_INT)123);
		fputs("-- ok\n", stderr);
	}
}

