/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: test_knl.cpp,v 1.1 2004/01/16 01:38:28 takagi-n Exp $
 */
#include <toppers/kernelstatus.hpp>
#include "test.hpp"

void test_knl()
{
	fputs("----- test kernelstatus -----\n", stderr);
	{
		fputs("[kernelstatus<>] ", stderr);
		typedef	toppers::kernelstatus<>	kernelstatus;
		TEST_EXP(kernelstatus::context::sense());
		VERIFY0("sns_ctx");
		kernelstatus::system_reference pk_rsys[1];
		TEST_EXP(kernelstatus::refer(pk_rsys));
		VERIFY1("ref_sys", pk_rsys);
		kernelstatus::version_reference pk_rver[1];
		TEST_EXP(kernelstatus::refer(pk_rver));
		VERIFY1("ref_ver", pk_rver);
		kernelstatus::configuration_reference pk_rcfg[1];
		TEST_EXP(kernelstatus::refer(pk_rcfg));
		VERIFY1("ref_cfg", pk_rcfg);
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[readyqueue<>] ", stderr);
		typedef	toppers::readyqueue<>	readyqueue;
		readyqueue::rotate(5);
		VERIFY1("rot_rdq", 5);
		readyqueue::rotate(5, toppers::non_task_context);
		VERIFY1("irot_rdq", 5);
		set_test_context(TRUE);
		readyqueue::rotate(5, toppers::context_independent);
		VERIFY1("irot_rdq", 5);
		set_test_context(FALSE);
		readyqueue::rotate(5, toppers::context_independent);
		VERIFY1("rot_rdq", 5);
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[cpulock<>] ", stderr);
		typedef	toppers::cpulock<>	cpulock;
		cpulock::sense();
		VERIFY0("sns_loc");
		cpulock::lock();
		VERIFY0("loc_cpu");
		cpulock::lock(toppers::non_task_context);
		VERIFY0("iloc_cpu");
		set_test_context(TRUE);
		cpulock::lock(toppers::context_independent);
		VERIFY0("iloc_cpu");
		set_test_context(FALSE);
		cpulock::lock(toppers::context_independent);
		VERIFY0("loc_cpu");
		cpulock::unlock();
		VERIFY0("unl_cpu");
		cpulock::unlock(toppers::non_task_context);
		VERIFY0("iunl_cpu");
		set_test_context(TRUE);
		cpulock::unlock(toppers::context_independent);
		VERIFY0("iunl_cpu");
		set_test_context(FALSE);
		cpulock::unlock(toppers::context_independent);
		VERIFY0("unl_cpu");
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[dispatcher<>] ", stderr);
		typedef	toppers::dispatcher<>	dispatcher;
		dispatcher::sense();
		VERIFY0("sns_dsp");
		dispatcher::disable();
		VERIFY0("dis_dsp");
		dispatcher::enable();
		VERIFY0("ena_dsp");
		fputs("-- ok\n", stderr);
	}
}

