/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: test_mbf.cpp,v 1.1 2004/01/16 01:38:28 takagi-n Exp $
 */
#include <toppers/messagebuffer.hpp>
#include "test.hpp"

void test_mbf()
{
	fputs("----- test messagebuffer -----\n", stderr);
	{
		fputs("[messagebuffer<>] ", stderr);
		typedef	toppers::messagebuffer<>	messagebuffer;
		TEST_EXP(messagebuffer mbf(10));
		ID mbfid = get_unsafe_id(mbf);
		printf("mbfid = %d\n", mbfid);
		TEST_EXP(mbf.create(TA_TFIFO));
		VERIFY1("acre_mbf", test_params[0]);
		mbfid = get_unsafe_id(mbf);
		printf("mbfid = %d\n", mbfid);
		messagebuffer::reference pk_rmbf[1];
		TEST_EXP(mbf.refer(pk_rmbf));
		VERIFY2("ref_mbf", mbfid, pk_rmbf);
		TEST_EXP(mbf.send("12345", 5));
		VERIFY3("snd_mbf", mbfid, "12345", 5);
		TEST_EXP(mbf.send("12345", 5, toppers::polling));
		VERIFY3("psnd_mbf", mbfid, "12345", 5);
		TEST_EXP(mbf.send("12345", 5, 100));
		VERIFY4("tsnd_mbf", mbfid, "12345", 5, 100);
		char data[100];
		TEST_EXP(mbf.receive(data));
		VERIFY2("rcv_mbf", mbfid, data);
		TEST_EXP(mbf.receive(data, toppers::polling));
		VERIFY2("prcv_mbf", mbfid, data);
		TEST_EXP(mbf.receive(data, 100));
		VERIFY3("trcv_mbf", mbfid, data, 100);
		printf("mbfid = %d\n" , get_unsafe_id(mbf));
		TEST_EXP(mbf.destroy());
		VERIFY1("del_mbf", mbfid);
		printf("mbfid = %d\n" , get_unsafe_id(mbf));
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[messagebuffer<1>] ", stderr);
		typedef	toppers::messagebuffer<1>	messagebuffer;
		TEST_EXP(messagebuffer mbf);
		ID mbfid = get_unsafe_id(mbf);
		printf("mbfid = %d\n", mbfid);
		TEST_EXP(mbf.create(TA_TFIFO));
		VERIFY2("cre_mbf", mbfid, test_params[1]);
		mbfid = get_unsafe_id(mbf);
		printf("mbfid = %d\n", mbfid);
		messagebuffer::reference pk_rmbf[1];
		TEST_EXP(mbf.refer(pk_rmbf));
		VERIFY2("ref_mbf", mbfid, pk_rmbf);
		TEST_EXP(mbf.send("12345", 5));
		VERIFY3("snd_mbf", mbfid, "12345", 5);
		TEST_EXP(mbf.send("12345", 5, toppers::polling));
		VERIFY3("psnd_mbf", mbfid, "12345", 5);
		TEST_EXP(mbf.send("12345", 5, 100));
		VERIFY4("tsnd_mbf", mbfid, "12345", 5, 100);
		char data[100];
		TEST_EXP(mbf.receive(data));
		VERIFY2("rcv_mbf", mbfid, data);
		TEST_EXP(mbf.receive(data, toppers::polling));
		VERIFY2("prcv_mbf", mbfid, data);
		TEST_EXP(mbf.receive(data, 100));
		VERIFY3("trcv_mbf", mbfid, data, 100);
		printf("mbfid = %d\n" , get_unsafe_id(mbf));
		TEST_EXP(mbf.destroy());
		VERIFY1("del_mbf", mbfid);
		printf("mbfid = %d\n" , get_unsafe_id(mbf));
		fputs("-- ok\n", stderr);
	}
}

