/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: test_mbx.cpp,v 1.1 2004/01/16 01:38:28 takagi-n Exp $
 */
#include <toppers/mailbox.hpp>
#include "test.hpp"

void test_mbx()
{
	fputs("----- test mailbox -----\n", stderr);
	{
		fputs("[mailbox<>] ", stderr);
		typedef	toppers::mailbox<>	mailbox;
		TEST_EXP(mailbox mbx(10));
		ID mbxid = get_unsafe_id(mbx);
		printf("mbxid = %d\n", mbxid);
		TEST_EXP(mbx.create(TA_TFIFO));
		VERIFY1("acre_mbx", test_params[0]);
		mbxid = get_unsafe_id(mbx);
		printf("mbxid = %d\n", mbxid);
		mailbox::reference pk_rmbx[1];
		TEST_EXP(mbx.refer(pk_rmbx));
		VERIFY2("ref_mbx", mbxid, pk_rmbx);
		t_msg pk_msg[1], * ppk_msg[1];
		TEST_EXP(mbx.send(pk_msg));
		VERIFY2("snd_mbx", mbxid, pk_msg);
		TEST_EXP(mbx.receive(ppk_msg));
		VERIFY2("rcv_mbx", mbxid, ppk_msg);
		TEST_EXP(mbx.receive(ppk_msg, toppers::polling));
		VERIFY2("prcv_mbx", mbxid, ppk_msg);
		TEST_EXP(mbx.receive(ppk_msg, 100));
		VERIFY3("trcv_mbx", mbxid, ppk_msg, 100);
		printf("mbxid = %d\n" , get_unsafe_id(mbx));
		TEST_EXP(mbx.destroy());
		VERIFY1("del_mbx", mbxid);
		printf("mbxid = %d\n" , get_unsafe_id(mbx));
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[mailbox<1>] ", stderr);
		typedef	toppers::mailbox<1>	mailbox;
		TEST_EXP(mailbox mbx);
		ID mbxid = get_unsafe_id(mbx);
		printf("mbxid = %d\n", mbxid);
		TEST_EXP(mbx.create(TA_TFIFO));
		VERIFY2("cre_mbx", mbxid, test_params[1]);
		mbxid = get_unsafe_id(mbx);
		printf("mbxid = %d\n", mbxid);
		mailbox::reference pk_rmbx[1];
		TEST_EXP(mbx.refer(pk_rmbx));
		VERIFY2("ref_mbx", mbxid, pk_rmbx);
		t_msg pk_msg[1], * ppk_msg[1];
		TEST_EXP(mbx.send(pk_msg));
		VERIFY2("snd_mbx", mbxid, pk_msg);
		TEST_EXP(mbx.receive(ppk_msg));
		VERIFY2("rcv_mbx", mbxid, ppk_msg);
		TEST_EXP(mbx.receive(ppk_msg, toppers::polling));
		VERIFY2("prcv_mbx", mbxid, ppk_msg);
		TEST_EXP(mbx.receive(ppk_msg, 100));
		VERIFY3("trcv_mbx", mbxid, ppk_msg, 100);
		printf("mbxid = %d\n" , get_unsafe_id(mbx));
		TEST_EXP(mbx.destroy());
		VERIFY1("del_mbx", mbxid);
		printf("mbxid = %d\n" , get_unsafe_id(mbx));
		fputs("-- ok\n", stderr);
	}
}

