/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: test_mpf.cpp,v 1.1 2004/01/16 01:38:28 takagi-n Exp $
 */
#include <toppers/fmempool.hpp>
#include "test.hpp"

void test_mpf()
{
	fputs("----- test fmempool -----\n", stderr);
	{
		fputs("[fmempool<>] ", stderr);
		typedef	toppers::fmempool<>	fmempool;
		TEST_EXP(fmempool mpf(10));
		ID mpfid = get_unsafe_id(mpf);
		printf("mpfid = %d\n", mpfid);
		TEST_EXP(mpf.create());
		VERIFY1("acre_mpf", test_params[0]);
		mpfid = get_unsafe_id(mpf);
		printf("mpfid = %d\n", mpfid);
		fmempool::reference pk_rmpf[1];
		TEST_EXP(mpf.refer(pk_rmpf));
		VERIFY2("ref_mpf", mpfid, pk_rmpf);
		VP blk;
		TEST_EXP(mpf.get(&blk));
		VERIFY2("get_mpf", mpfid, &blk);
		TEST_EXP(mpf.get(&blk, toppers::polling));
		VERIFY2("pget_mpf", mpfid, &blk);
		TEST_EXP(mpf.get(&blk, 100));
		VERIFY3("tget_mpf", mpfid, &blk, 100);
		TEST_EXP(mpf.get(32, &blk));
		VERIFY2("get_mpf", mpfid, &blk);
		TEST_EXP(mpf.get(32, &blk, toppers::polling));
		VERIFY2("pget_mpf", mpfid, &blk);
		TEST_EXP(mpf.get(32, &blk, 100));
		VERIFY3("tget_mpf", mpfid, &blk, 100);
		TEST_EXP(mpf.release(blk));
		VERIFY2("rel_mpf", mpfid, blk);
		TEST_EXP(mpf.destroy());
		VERIFY1("del_mpf", mpfid);
		printf("mpfid = %d\n" , get_unsafe_id(mpf));
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[fmempool<1>] ", stderr);
		typedef	toppers::fmempool<1>	fmempool;
		TEST_EXP(fmempool mpf);
		ID mpfid = get_unsafe_id(mpf);
		printf("mpfid = %d\n", mpfid);
		TEST_EXP(mpf.create());
		VERIFY2("cre_mpf", mpfid, test_params[1]);
		mpfid = get_unsafe_id(mpf);
		printf("mpfid = %d\n", mpfid);
		fmempool::reference pk_rmpf[1];
		TEST_EXP(mpf.refer(pk_rmpf));
		VERIFY2("ref_mpf", mpfid, pk_rmpf);
		VP blk;
		TEST_EXP(mpf.get(&blk));
		VERIFY2("get_mpf", mpfid, &blk);
		TEST_EXP(mpf.get(&blk, toppers::polling));
		VERIFY2("pget_mpf", mpfid, &blk);
		TEST_EXP(mpf.get(&blk, 100));
		VERIFY3("tget_mpf", mpfid, &blk, 100);
		TEST_EXP(mpf.get(32, &blk));
		VERIFY2("get_mpf", mpfid, &blk);
		TEST_EXP(mpf.get(32, &blk, toppers::polling));
		VERIFY2("pget_mpf", mpfid, &blk);
		TEST_EXP(mpf.get(32, &blk, 100));
		VERIFY3("tget_mpf", mpfid, &blk, 100);
		TEST_EXP(mpf.release(blk));
		VERIFY2("rel_mpf", mpfid, blk);
		TEST_EXP(mpf.destroy());
		VERIFY1("del_mpf", mpfid);
		printf("mpfid = %d\n" , get_unsafe_id(mpf));
		fputs("-- ok\n", stderr);
	}
}

