/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: test_mpl.cpp,v 1.1 2004/01/16 01:38:28 takagi-n Exp $
 */
#include <toppers/vmempool.hpp>
#include "test.hpp"

void test_mpl()
{
	fputs("----- test vmempool -----\n", stderr);
	{
		fputs("[vmempool<>] ", stderr);
		typedef	toppers::vmempool<>	vmempool;
		TEST_EXP(vmempool mpl(10));
		ID mplid = get_unsafe_id(mpl);
		printf("mplid = %d\n", mplid);
		TEST_EXP(mpl.create());
		VERIFY1("acre_mpl", test_params[0]);
		mplid = get_unsafe_id(mpl);
		printf("mplid = %d\n", mplid);
		vmempool::reference pk_rmpl[1];
		TEST_EXP(mpl.refer(pk_rmpl));
		VERIFY2("ref_mpl", mplid, pk_rmpl);
		VP blk;
		TEST_EXP(mpl.get(32, &blk));
		VERIFY3("get_mpl", mplid, 32, &blk);
		TEST_EXP(mpl.get(32, &blk, toppers::polling));
		VERIFY3("pget_mpl", mplid, 32, &blk);
		TEST_EXP(mpl.get(32, &blk, 100));
		VERIFY4("tget_mpl", mplid, 32, &blk, 100);
		TEST_EXP(mpl.release(blk));
		VERIFY2("rel_mpl", mplid, blk);
		TEST_EXP(mpl.destroy());
		VERIFY1("del_mpl", mplid);
		printf("mplid = %d\n" , get_unsafe_id(mpl));
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[vmempool<1>] ", stderr);
		typedef	toppers::vmempool<1>	vmempool;
		TEST_EXP(vmempool mpl);
		ID mplid = get_unsafe_id(mpl);
		printf("mplid = %d\n", mplid);
		TEST_EXP(mpl.create());
		VERIFY2("cre_mpl", mplid, test_params[1]);
		mplid = get_unsafe_id(mpl);
		printf("mplid = %d\n", mplid);
		vmempool::reference pk_rmpl[1];
		TEST_EXP(mpl.refer(pk_rmpl));
		VERIFY2("ref_mpl", mplid, pk_rmpl);
		VP blk;
		TEST_EXP(mpl.get(32, &blk));
		VERIFY3("get_mpl", mplid, 32, &blk);
		TEST_EXP(mpl.get(32, &blk, toppers::polling));
		VERIFY3("pget_mpl", mplid, 32, &blk);
		TEST_EXP(mpl.get(32, &blk, 100));
		VERIFY4("tget_mpl", mplid, 32, &blk, 100);
		TEST_EXP(mpl.release(blk));
		VERIFY2("rel_mpl", mplid, blk);
		TEST_EXP(mpl.destroy());
		VERIFY1("del_mpl", mplid);
		printf("mplid = %d\n" , get_unsafe_id(mpl));
		fputs("-- ok\n", stderr);
	}
}

