/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: test_mtx.cpp,v 1.1 2004/01/16 01:38:28 takagi-n Exp $
 */
#include <toppers/mutex.hpp>
#include "test.hpp"

void test_mtx()
{
	fputs("----- test mutex -----\n", stderr);
	{
		fputs("[mutex<>] ", stderr);
		typedef	toppers::mutex<>	mutex;
		TEST_EXP(mutex mtx(10));
		ID mtxid = get_unsafe_id(mtx);
		printf("mtxid = %d\n", mtxid);
		TEST_EXP(mtx.create(TA_TFIFO));
		VERIFY1("acre_mtx", test_params[0]);
		mtxid = get_unsafe_id(mtx);
		printf("mtxid = %d\n", mtxid);
		mutex::reference pk_rmtx[1];
		TEST_EXP(mtx.refer(pk_rmtx));
		VERIFY2("ref_mtx", mtxid, pk_rmtx);
		TEST_EXP(mtx.lock());
		VERIFY1("loc_mtx", mtxid);
		TEST_EXP(mtx.lock(toppers::polling));
		VERIFY1("ploc_mtx", mtxid);
		TEST_EXP(mtx.lock(10));
		VERIFY2("tloc_mtx", mtxid, 10);
		TEST_EXP(mtx.unlock());
		VERIFY1("unl_mtx", mtxid);
		TEST_EXP(mtx.destroy());
		VERIFY1("del_mtx", mtxid);
		printf("mtxid = %d\n" , get_unsafe_id(mtx));
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[mutex<1>] ", stderr);
		typedef	toppers::mutex<1>	mutex;
		TEST_EXP(mutex mtx);
		ID mtxid = get_unsafe_id(mtx);
		printf("mtxid = %d\n", mtxid);
		TEST_EXP(mtx.create(TA_TFIFO));
		VERIFY2("cre_mtx", mtxid, test_params[1]);
		mtxid = get_unsafe_id(mtx);
		printf("mtxid = %d\n", mtxid);
		mutex::reference pk_rmtx[1];
		TEST_EXP(mtx.refer(pk_rmtx));
		VERIFY2("ref_mtx", mtxid, pk_rmtx);
		TEST_EXP(mtx.lock());
		VERIFY1("loc_mtx", mtxid);
		TEST_EXP(mtx.lock(toppers::polling));
		VERIFY1("ploc_mtx", mtxid);
		TEST_EXP(mtx.lock(10));
		VERIFY2("tloc_mtx", mtxid, 10);
		TEST_EXP(mtx.unlock());
		VERIFY1("unl_mtx", mtxid);
		TEST_EXP(mtx.destroy());
		VERIFY1("del_mtx", mtxid);
		printf("mtxid = %d\n" , get_unsafe_id(mtx));
		fputs("-- ok\n", stderr);
	}
}

