/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: test_ovr.cpp,v 1.1 2004/01/16 01:38:28 takagi-n Exp $
 */
#include <toppers/overrunhandler.hpp>
#include <toppers/task.hpp>
#include "test.hpp"

namespace {

	class body : public toppers::overrunhandler_body<>
	{
		typedef	toppers::overrunhandler_body<>	super;
	public:
		explicit body(ID tskid, VP_INT exinf) : super(tskid, exinf) {}
		void run()
		{
			tracer t;
			VP_INT exinf = get_extended_info();
			ASSERT(exinf == VP_INT(123));
			printf("exinf = %p\n", exinf);
		}
	};

}

void test_ovr()
{
	fputs("----- test overrunhandler -----\n", stderr);
	{
		toppers::task<1> tsk;
		fputs("[overrunhandler<>] ", stderr);
		typedef	toppers::overrunhandler<>	overrunhandler;
		TEST_EXP(overrunhandler::define<body>());
		VERIFY1("def_ovr", test_params[0]);
		TEST_EXP(overrunhandler::start(tsk, 100));
		VERIFY2("sta_ovr", 1, 100);
		TEST_EXP(overrunhandler::stop(tsk));
		VERIFY1("stp_ovr", 1);
		TEST_EXP(overrunhandler::start(100));
		VERIFY2("sta_ovr", TSK_SELF, 100);
		TEST_EXP(overrunhandler::stop());
		VERIFY1("stp_ovr", TSK_SELF);
		overrunhandler::reference pk_rovr[1];
		TEST_EXP(overrunhandler::refer(tsk, pk_rovr));
		VERIFY2("ref_ovr", 1, pk_rovr);
		TEST_EXP(overrunhandler::refer(pk_rovr));
		VERIFY2("ref_ovr", TSK_SELF, pk_rovr);
		TEST_EXP(overrunhandler::undefine());
		VERIFY1("def_ovr", 0);
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[overrunhandler body] ", stderr);
		set_test_context(TRUE);
		toppers::overrunhandler_entry<body>(1, (VP_INT)(123));
		fputs("-- ok\n", stderr);
	}
}

