/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: test_por.cpp,v 1.1 2004/01/16 01:38:28 takagi-n Exp $
 */
#include <toppers/rendezvous.hpp>
#include "test.hpp"

void test_por()
{
	fputs("----- test rendezvousport -----\n", stderr);
	{
		fputs("[rendezvousport<>] ", stderr);
		typedef	toppers::rendezvousport<>	rendezvousport;
		typedef	toppers::rendezvous<>	rendezvous;
		TEST_EXP(rendezvousport por(10));
		ID porid = get_unsafe_id(por);
		printf("porid = %d\n", porid);
		TEST_EXP(por.create());
		VERIFY1("acre_por", test_params[0]);
		porid = get_unsafe_id(por);
		printf("porid = %d\n", porid);
		rendezvousport::reference pk_rpor[1];
		TEST_EXP(por.refer(pk_rpor));
		VERIFY2("ref_por", porid, pk_rpor);
		char msg[] = "abcdefg";
		TEST_EXP(por.call(0x1111, msg, sizeof msg));
		VERIFY4("cal_por", porid, 0x1111, msg, sizeof msg);
		TEST_EXP(por.call(0x1111, msg, sizeof msg, 100));
		VERIFY5("tcal_por", porid, 0x1111, msg, sizeof msg, 100);
		rendezvous	rdv;
		char buf[100];
		TEST_EXP(rdv.attach(5));
		ASSERT(rdv.no() == 5);
		printf("rdvno = %d\n" , rdv.no());
		TEST_EXP(por.accept(0x1111, rdv, buf));
		VERIFY4("acp_por", porid, 0x1111, test_params[2], buf);
		printf("rdvno = %d\n" , rdv.no());
		TEST_EXP(por.accept(0x1111, rdv, buf, toppers::polling));
		VERIFY4("pacp_por", porid, 0x1111, test_params[2], buf);
		TEST_EXP(por.accept(0x1111, rdv, buf, 100));
		VERIFY5("tacp_por", porid, 0x1111, test_params[2], buf, 100);
		TEST_EXP(por.forward(0x1111, rdv, "12345", 6));
		VERIFY5("fwd_por", porid, 0x1111, rdv.no(), "12345", 6);
		rendezvous::reference pk_rrdv[1];
		TEST_EXP(rdv.refer(pk_rrdv));
		VERIFY2("ref_rdv", rdv.no(), pk_rrdv);
		RDVNO rdvno = rdv.no();
		TEST_EXP(rdv.reply("67890", 6));
		VERIFY3("rpl_rdv", rdvno, "67890", 6);
		TEST_EXP(por.destroy());
		VERIFY1("del_por", porid);
		printf("porid = %d\n" , get_unsafe_id(por));
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[rendezvousport<1>] ", stderr);
		typedef	toppers::rendezvousport<1>	rendezvousport;
		typedef	toppers::rendezvous<>	rendezvous;
		TEST_EXP(rendezvousport por);
		ID porid = get_unsafe_id(por);
		printf("porid = %d\n", porid);
		TEST_EXP(por.create());
		VERIFY2("cre_por", porid, test_params[1]);
		porid = get_unsafe_id(por);
		printf("porid = %d\n", porid);
		rendezvousport::reference pk_rpor[1];
		TEST_EXP(por.refer(pk_rpor));
		VERIFY2("ref_por", porid, pk_rpor);
		char msg[] = "abcdefg";
		TEST_EXP(por.call(0x1111, msg, sizeof msg));
		VERIFY4("cal_por", porid, 0x1111, msg, sizeof msg);
		TEST_EXP(por.call(0x1111, msg, sizeof msg, 100));
		VERIFY5("tcal_por", porid, 0x1111, msg, sizeof msg, 100);
		rendezvous	rdv;
		char buf[100];
		TEST_EXP(rdv.attach(5));
		ASSERT(rdv.no() == 5);
		printf("rdvno = %d\n" , rdv.no());
		TEST_EXP(por.accept(0x1111, rdv, buf));
		VERIFY4("acp_por", porid, 0x1111, test_params[2], buf);
		printf("rdvno = %d\n" , rdv.no());
		TEST_EXP(por.accept(0x1111, rdv, buf, toppers::polling));
		VERIFY4("pacp_por", porid, 0x1111, test_params[2], buf);
		TEST_EXP(por.accept(0x1111, rdv, buf, 100));
		VERIFY5("tacp_por", porid, 0x1111, test_params[2], buf, 100);
		TEST_EXP(por.forward(0x1111, rdv, "12345", 6));
		VERIFY5("fwd_por", porid, 0x1111, rdv.no(), "12345", 6);
		rendezvous::reference pk_rrdv[1];
		TEST_EXP(rdv.refer(pk_rrdv));
		VERIFY2("ref_rdv", rdv.no(), pk_rrdv);
		RDVNO rdvno = rdv.no();
		TEST_EXP(rdv.reply("67890", 6));
		VERIFY3("rpl_rdv", rdvno, "67890", 6);
		TEST_EXP(por.destroy());
		VERIFY1("del_por", porid);
		printf("porid = %d\n" , get_unsafe_id(por));
		fputs("-- ok\n", stderr);
	}
}

