/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: test_sem.cpp,v 1.1 2004/01/16 01:38:28 takagi-n Exp $
 */
#include <toppers/semaphore.hpp>
#include "test.hpp"

void test_sem()
{
	fputs("----- test semaphore -----\n", stderr);
	{
		fputs("[semaphore<>] ", stderr);
		typedef	toppers::semaphore<>	semaphore;
		TEST_EXP(semaphore sem(10));
		ID semid = get_unsafe_id(sem);
		printf("semid = %d\n", semid);
		TEST_EXP(sem.create(TA_TFIFO, 5, 5));
		VERIFY1("acre_sem", test_params[0]);
		semid = get_unsafe_id(sem);
		printf("semid = %d\n", semid);
		semaphore::reference pk_rsem[1];
		TEST_EXP(sem.refer(pk_rsem));
		VERIFY2("ref_sem", semid, pk_rsem);
		TEST_EXP(sem.signal());
		VERIFY1("sig_sem", semid);
		TEST_EXP(sem.signal(toppers::non_task_context));
		VERIFY1("isig_sem", semid);
		set_test_context(TRUE);
		TEST_EXP(sem.signal(toppers::context_independent));
		VERIFY1("isig_sem", semid);
		set_test_context(FALSE);
		TEST_EXP(sem.signal(toppers::context_independent));
		VERIFY1("sig_sem", semid);
		TEST_EXP(sem.wait());
		VERIFY1("wai_sem", semid);
		TEST_EXP(sem.wait(toppers::polling));
		VERIFY1("pol_sem", semid);
		TEST_EXP(sem.wait(333));
		VERIFY2("twai_sem", semid, 333);
		TEST_EXP(sem.destroy());
		VERIFY1("del_sem", semid);
		printf("semid = %d\n" , get_unsafe_id(sem));
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[semaphore<1>] ", stderr);
		typedef	toppers::semaphore<1>	semaphore;
		TEST_EXP(semaphore sem);
		ID semid = get_unsafe_id(sem);
		printf("semid = %d\n", semid);
		TEST_EXP(sem.create(TA_TFIFO, 5, 5));
		VERIFY2("cre_sem", semid, test_params[1]);
		semid = get_unsafe_id(sem);
		printf("semid = %d\n", semid);
		semaphore::reference pk_rsem[1];
		TEST_EXP(sem.refer(pk_rsem));
		VERIFY2("ref_sem", semid, pk_rsem);
		TEST_EXP(sem.signal());
		VERIFY1("sig_sem", semid);
		TEST_EXP(sem.signal(toppers::non_task_context));
		VERIFY1("isig_sem", semid);
		set_test_context(TRUE);
		TEST_EXP(sem.signal(toppers::context_independent));
		VERIFY1("isig_sem", semid);
		set_test_context(FALSE);
		TEST_EXP(sem.signal(toppers::context_independent));
		VERIFY1("sig_sem", semid);
		TEST_EXP(sem.wait());
		VERIFY1("wai_sem", semid);
		TEST_EXP(sem.wait(toppers::polling));
		VERIFY1("pol_sem", semid);
		TEST_EXP(sem.wait(333));
		VERIFY2("twai_sem", semid, 333);
		TEST_EXP(sem.destroy());
		VERIFY1("del_sem", semid);
		printf("semid = %d\n" , get_unsafe_id(sem));
		fputs("-- ok\n", stderr);
	}
}

