/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: test_stub.cpp,v 1.1 2004/01/16 01:38:28 takagi-n Exp $
 */
#include <toppers/raw_stub.hpp>
#include <toppers/outline_stub.hpp>
#include <toppers/fncode_stub.hpp>
#include "test.hpp"

ID tskid, semid, flgid, dtqid, mbxid, mtxid, mbfid, porid, mpfid, mplid, isrid, cycid, almid;
ID *p_tskid;
PRI tskpri, *p_tskpri;
FN fncd;
TMO tmout;
RELTIM	dlytim, almtim;
OVRTIM	ovrtim;
SYSTIM	p_systim[1];
T_MSG	pk_msg[1], *ppk_msg[1];
VP_INT	stacd, data, p_data[1], arg1, arg2, arg3, arg4, arg5, p_excinf;
VP	msg[100], blk, p_blk[1];
TEXPTN	rasptn;
FLGPTN	setptn, clrptn, waiptn, p_flgptn[1];
RDVPTN	calptn, acpptn;
RDVNO	rdvno, p_rdvno[1];
EXCNO	excno;
MODE	wfmode;
UINT	msgsz, cmsgsz, rmsgsz, blksz;
INHNO	inhno;
INTNO	intno;
IMS		ims;
IMS		p_ims[1];

#define	PACKET(UC, lc)	\
	T_C##UC	pk_c##lc[1];	\
	T_R##UC	pk_r##lc[1];

PACKET(TSK, tsk)
PACKET(SEM, sem)
PACKET(FLG, flg)
PACKET(DTQ, dtq)
PACKET(MBX, mbx)
PACKET(MTX, mtx)
PACKET(MBF, mbf)
PACKET(POR, por)
PACKET(MPF, mpf)
PACKET(MPL, mpl)
PACKET(ISR, isr)
PACKET(CYC, cyc)
PACKET(ALM, alm)

T_DTEX	pk_dtex[1];
T_DOVR	pk_dovr[1];
T_DINH	pk_dinh[1];
T_DEXC	pk_dexc[1];
T_DSVC	pk_dsvc[1];

T_RTST	pk_rtst[1];
T_RTEX	pk_rtex[1];
T_RRDV	pk_rrdv[1];
T_ROVR	pk_rovr[1];
T_RSYS	pk_rsys[1];
T_RVER	pk_rver[1];
T_RCFG	pk_rcfg[1];

template <class Stub>
struct stub_tester : Stub
{
public:
	stub_tester()
	{
		stub_cre_tsk(tskid, pk_ctsk);
		VERIFY2("cre_tsk", tskid, pk_ctsk);
		stub_cre_tsk(tskid, (const t_ctsk*)pk_ctsk);
		VERIFY2("cre_tsk", tskid, pk_ctsk);
		stub_acre_tsk(pk_ctsk);
		VERIFY1("acre_tsk", pk_ctsk);
		stub_acre_tsk((const t_ctsk*)pk_ctsk);
		VERIFY1("acre_tsk", pk_ctsk);
		stub_del_tsk(tskid);
		VERIFY1("del_tsk", tskid);
		stub_act_tsk(tskid);
		VERIFY1("act_tsk", tskid);
		stub_iact_tsk(tskid);
		VERIFY1("iact_tsk", tskid);
		stub_can_act(tskid);
		VERIFY1("can_act", tskid);
		stub_sta_tsk(tskid, stacd);
		VERIFY2("sta_tsk", tskid, stacd);
		stub_ext_tsk();
		VERIFY0("ext_tsk");
		stub_exd_tsk();
		VERIFY0("exd_tsk");
		stub_ter_tsk(tskid);
		VERIFY1("ter_tsk", tskid);
		stub_chg_pri(tskid, tskpri);
		VERIFY2("chg_pri", tskid, tskpri);
		stub_get_pri(tskid, p_tskpri);
		VERIFY2("get_pri", tskid, p_tskpri);
		stub_ref_tsk(tskid, pk_rtsk);
		VERIFY2("ref_tsk", tskid, pk_rtsk);
		stub_ref_tst(tskid, pk_rtst);
		VERIFY2("ref_tst", tskid, pk_rtst);
		stub_slp_tsk();
		VERIFY0("slp_tsk");
		stub_tslp_tsk(tmout);
		VERIFY1("tslp_tsk", tmout);
		stub_wup_tsk(tskid);
		VERIFY1("wup_tsk", tskid);
		stub_iwup_tsk(tskid);
		VERIFY1("iwup_tsk", tskid);
		stub_can_wup(tskid);
		VERIFY1("can_wup", tskid);
		stub_rel_wai(tskid);
		VERIFY1("rel_wai", tskid);
		stub_irel_wai(tskid);
		VERIFY1("irel_wai", tskid);
		stub_sus_tsk(tskid);
		VERIFY1("sus_tsk", tskid);
		stub_rsm_tsk(tskid);
		VERIFY1("rsm_tsk", tskid);
		stub_frsm_tsk(tskid);
		VERIFY1("frsm_tsk", tskid);
		stub_dly_tsk(dlytim);
		VERIFY1("dly_tsk", dlytim);
		stub_def_tex(tskid, pk_dtex);
		VERIFY2("def_tex", tskid, pk_dtex);
		stub_def_tex(tskid, (const t_dtex*)pk_dtex);
		VERIFY2("def_tex", tskid, pk_dtex);
		stub_ras_tex(tskid, rasptn);
		VERIFY2("ras_tex", tskid, rasptn);
		stub_iras_tex(tskid, rasptn);
		VERIFY2("iras_tex", tskid, rasptn);
		stub_dis_tex();
		VERIFY0("dis_tex");
		stub_ena_tex();
		VERIFY0("ena_tex");
		stub_sns_tex();
		VERIFY0("sns_tex");
		stub_ref_tex(tskid, pk_rtex);
		VERIFY2("ref_tex", tskid, pk_rtex);
		stub_cre_sem(semid, pk_csem);
		VERIFY2("cre_sem", semid, pk_csem);
		stub_cre_sem(semid, (const t_csem*)pk_csem);
		VERIFY2("cre_sem", semid, pk_csem);
		stub_acre_sem(pk_csem);
		VERIFY1("acre_sem", pk_csem);
		stub_acre_sem((const t_csem*)pk_csem);
		VERIFY1("acre_sem", pk_csem);
		stub_del_sem(semid);
		VERIFY1("del_sem", semid);
		stub_sig_sem(semid);
		VERIFY1("sig_sem", semid);
		stub_isig_sem(semid);
		VERIFY1("isig_sem", semid);
		stub_wai_sem(semid);
		VERIFY1("wai_sem", semid);
		stub_pol_sem(semid);
		VERIFY1("pol_sem", semid);
		stub_twai_sem(semid, tmout);
		VERIFY2("twai_sem", semid, tmout);
		stub_ref_sem(semid, pk_rsem);
		VERIFY2("ref_sem", semid, pk_rsem);
		stub_cre_flg(flgid, pk_cflg);
		VERIFY2("cre_flg", flgid, pk_cflg);
		stub_cre_flg(flgid, (const t_cflg*)pk_cflg);
		VERIFY2("cre_flg", flgid, pk_cflg);
		stub_acre_flg(pk_cflg);
		VERIFY1("acre_flg", pk_cflg);
		stub_acre_flg((const t_cflg*)pk_cflg);
		VERIFY1("acre_flg", pk_cflg);
		stub_del_flg(flgid);
		VERIFY1("del_flg", flgid);
		stub_set_flg(flgid, setptn);
		VERIFY2("set_flg", flgid, setptn);
		stub_iset_flg(flgid, setptn);
		VERIFY2("iset_flg", flgid, setptn);
		stub_clr_flg(flgid, clrptn);
		VERIFY2("clr_flg", flgid, clrptn);
		stub_wai_flg(flgid, waiptn, wfmode, p_flgptn);
		VERIFY4("wai_flg", flgid, waiptn, wfmode, p_flgptn);
		stub_pol_flg(flgid, waiptn, wfmode, p_flgptn);
		VERIFY4("pol_flg", flgid, waiptn, wfmode, p_flgptn);
		stub_twai_flg(flgid, waiptn, wfmode, p_flgptn, tmout);
		VERIFY5("twai_flg", flgid, waiptn, wfmode, p_flgptn, tmout);
		stub_ref_flg(flgid, pk_rflg);
		VERIFY2("ref_flg", flgid, pk_rflg);
		stub_cre_dtq(dtqid, pk_cdtq);
		VERIFY2("cre_dtq", dtqid, pk_cdtq);
		stub_cre_dtq(dtqid, (const t_cdtq*)pk_cdtq);
		VERIFY2("cre_dtq", dtqid, pk_cdtq);
		stub_acre_dtq(pk_cdtq);
		VERIFY1("acre_dtq", pk_cdtq);
		stub_acre_dtq((const t_cdtq*)pk_cdtq);
		VERIFY1("acre_dtq", pk_cdtq);
		stub_del_dtq(dtqid);
		VERIFY1("del_dtq", dtqid);
		stub_snd_dtq(dtqid, data);
		VERIFY2("snd_dtq", dtqid, data);
		stub_psnd_dtq(dtqid, data);
		VERIFY2("psnd_dtq", dtqid, data);
		stub_ipsnd_dtq(dtqid, data);
		VERIFY2("ipsnd_dtq", dtqid, data);
		stub_tsnd_dtq(dtqid, data, tmout);
		VERIFY3("tsnd_dtq", dtqid, data, tmout);
		stub_fsnd_dtq(dtqid, data);
		VERIFY2("fsnd_dtq", dtqid, data);
		stub_ifsnd_dtq(dtqid, data);
		VERIFY2("ifsnd_dtq", dtqid, data);
		stub_rcv_dtq(dtqid, p_data);
		VERIFY2("rcv_dtq", dtqid, p_data);
		stub_prcv_dtq(dtqid, p_data);
		VERIFY2("prcv_dtq", dtqid, p_data);
		stub_trcv_dtq(dtqid, p_data, tmout);
		VERIFY3("trcv_dtq", dtqid, p_data, tmout);
		stub_ref_dtq(dtqid, pk_rdtq);
		VERIFY2("ref_dtq", dtqid, pk_rdtq);
		stub_cre_mbx(mbxid, pk_cmbx);
		VERIFY2("cre_mbx", dtqid, pk_cmbx);
		stub_cre_mbx(mbxid, (const t_cmbx*)pk_cmbx);
		VERIFY2("cre_mbx", dtqid, pk_cmbx);
		stub_acre_mbx(pk_cmbx);
		VERIFY1("acre_mbx", pk_cmbx);
		stub_acre_mbx((const t_cmbx*)pk_cmbx);
		VERIFY1("acre_mbx", pk_cmbx);
		stub_del_mbx(mbxid);
		VERIFY1("del_mbx", mbxid);
		stub_snd_mbx(mbxid, pk_msg);
		VERIFY2("snd_mbx", mbxid, pk_msg);
		stub_rcv_mbx(mbxid, ppk_msg);
		VERIFY2("rcv_mbx", mbxid, ppk_msg);
		stub_prcv_mbx(mbxid, ppk_msg);
		VERIFY2("prcv_mbx", mbxid, ppk_msg);
		stub_trcv_mbx(mbxid, ppk_msg, tmout);
		VERIFY3("trcv_mbx", mbxid, ppk_msg, tmout);
		stub_ref_mbx(mbxid, pk_rmbx);
		VERIFY2("ref_mbx", mbxid, pk_rmbx);
		stub_cre_mtx(mtxid, pk_cmtx);
		VERIFY2("cre_mtx", mtxid, pk_cmtx);
		stub_cre_mtx(mtxid, (const t_cmtx*)pk_cmtx);
		VERIFY2("cre_mtx", mtxid, pk_cmtx);
		stub_acre_mtx(pk_cmtx);
		VERIFY1("acre_mtx", pk_cmtx);
		stub_acre_mtx((const t_cmtx*)pk_cmtx);
		VERIFY1("acre_mtx", pk_cmtx);
		stub_del_mtx(mtxid);
		VERIFY1("del_mtx", mtxid);
		stub_loc_mtx(mtxid);
		VERIFY1("loc_mtx", mtxid);
		stub_ploc_mtx(mtxid);
		VERIFY1("ploc_mtx", mtxid);
		stub_tloc_mtx(mtxid, tmout);
		VERIFY2("tloc_mtx", mtxid, tmout);
		stub_unl_mtx(mtxid);
		VERIFY1("unl_mtx", mtxid);
		stub_ref_mtx(mtxid, pk_rmtx);
		VERIFY2("ref_mtx", mtxid, pk_rmtx);
		stub_cre_mbf(mbfid, pk_cmbf);
		VERIFY2("cre_mbf", mbfid, pk_cmbf);
		stub_cre_mbf(mbfid, (const t_cmbf*)pk_cmbf);
		VERIFY2("cre_mbf", mbfid, pk_cmbf);
		stub_acre_mbf(pk_cmbf);
		VERIFY1("acre_mbf", pk_cmbf);
		stub_acre_mbf((const t_cmbf*)pk_cmbf);
		VERIFY1("acre_mbf", pk_cmbf);
		stub_del_mbf(mbfid);
		VERIFY1("del_mbf", mbfid);
		stub_snd_mbf(mbfid, msg, msgsz);
		VERIFY3("snd_mbf", mbfid, msg, msgsz);
		stub_psnd_mbf(mbfid, msg, msgsz);
		VERIFY3("psnd_mbf", mbfid, msg, msgsz);
		stub_tsnd_mbf(mbfid, msg, msgsz, tmout);
		VERIFY4("tsnd_mbf", mbfid, msg, msgsz, tmout);
		stub_rcv_mbf(mbfid, msg);
		VERIFY2("rcv_mbf", mbfid, msg);
		stub_prcv_mbf(mbfid, msg);
		VERIFY2("prcv_mbf", mbfid, msg);
		stub_trcv_mbf(mbfid, msg, tmout);
		VERIFY3("trcv_mbf", mbfid, msg, tmout);
		stub_ref_mbf(mbfid, pk_rmbf);
		VERIFY2("ref_mbf", mbfid, pk_rmbf);
		stub_cre_por(porid, pk_cpor);
		VERIFY2("cre_por", porid, pk_cpor);
		stub_cre_por(porid, (const t_cpor*)pk_cpor);
		VERIFY2("cre_por", porid, pk_cpor);
		stub_acre_por(pk_cpor);
		VERIFY1("acre_por", pk_cpor);
		stub_acre_por((const t_cpor*)pk_cpor);
		VERIFY1("acre_por", pk_cpor);
		stub_del_por(porid);
		VERIFY1("del_por", porid);
		stub_cal_por(porid, calptn, msg, cmsgsz);
		VERIFY4("cal_por", porid, calptn, msg, cmsgsz);
		stub_tcal_por(porid, calptn, msg, cmsgsz, tmout);
		VERIFY5("tcal_por", porid, calptn, msg, cmsgsz, tmout);
		stub_acp_por(porid, acpptn, p_rdvno, msg);
		VERIFY4("acp_por", porid, acpptn, p_rdvno, msg);
		stub_pacp_por(porid, acpptn, p_rdvno, msg);
		VERIFY4("pacp_por", porid, acpptn, p_rdvno, msg);
		stub_tacp_por(porid, acpptn, p_rdvno, msg, tmout);
		VERIFY5("tacp_por", porid, acpptn, p_rdvno, msg, tmout);
		stub_fwd_por(porid, acpptn, rdvno, msg, cmsgsz);
		VERIFY5("fwd_por", porid, acpptn, rdvno, msg, cmsgsz);
		stub_rpl_rdv(rdvno, msg, rmsgsz);
		VERIFY3("rpl_rdv", rdvno, msg, rmsgsz);
		stub_ref_por(porid, pk_rpor);
		VERIFY2("ref_por", porid, pk_rpor);
		stub_ref_rdv(rdvno, pk_rrdv);
		VERIFY2("ref_rdv", rdvno, pk_rrdv);
		stub_cre_mpf(mpfid, pk_cmpf);
		VERIFY2("cre_mpf", mpfid, pk_cmpf);
		stub_cre_mpf(mpfid, (const t_cmpf*)pk_cmpf);
		VERIFY2("cre_mpf", mpfid, pk_cmpf);
		stub_acre_mpf(pk_cmpf);
		VERIFY1("acre_mpf", pk_cmpf);
		stub_acre_mpf((const t_cmpf*)pk_cmpf);
		VERIFY1("acre_mpf", pk_cmpf);
		stub_del_mpf(mpfid);
		VERIFY1("del_mpf", mpfid);
		stub_get_mpf(mpfid, p_blk);
		VERIFY2("get_mpf", mpfid, p_blk);
		stub_pget_mpf(mpfid, p_blk);
		VERIFY2("pget_mpf", mpfid, p_blk);
		stub_tget_mpf(mpfid, p_blk, tmout);
		VERIFY3("tget_mpf", mpfid, p_blk, tmout);
		stub_rel_mpf(mpfid, blk);
		VERIFY2("rel_mpf", mpfid, blk);
		stub_ref_mpf(mpfid, pk_rmpf);
		VERIFY2("ref_mpf", mpfid, pk_rmpf);
		stub_cre_mpl(mplid, pk_cmpl);
		VERIFY2("cre_mpl", mplid, pk_cmpl);
		stub_cre_mpl(mplid, (const t_cmpl*)pk_cmpl);
		VERIFY2("cre_mpl", mplid, pk_cmpl);
		stub_acre_mpl(pk_cmpl);
		VERIFY1("acre_mpl", pk_cmpl);
		stub_acre_mpl((const t_cmpl*)pk_cmpl);
		VERIFY1("acre_mpl", pk_cmpl);
		stub_del_mpl(mplid);
		VERIFY1("del_mpl", mplid);
		stub_get_mpl(mplid, blksz, p_blk);
		VERIFY3("get_mpl", mplid, blksz, p_blk);
		stub_pget_mpl(mplid, blksz, p_blk);
		VERIFY3("pget_mpl", mplid, blksz, p_blk);
		stub_tget_mpl(mplid, blksz, p_blk, tmout);
		VERIFY4("tget_mpl", mplid, blksz, p_blk, tmout);
		stub_rel_mpl(mplid, blk);
		VERIFY2("rel_mpl", mplid, blk);
		stub_ref_mpl(mplid, pk_rmpl);
		VERIFY2("ref_mpl", mplid, pk_rmpl);
		stub_set_tim(p_systim);
		VERIFY1("set_tim", p_systim);
		stub_set_tim((const SYSTIM*)p_systim);
		VERIFY1("set_tim", p_systim);
		stub_get_tim(p_systim);
		VERIFY1("get_tim", p_systim);
		stub_isig_tim();
		VERIFY0("isig_tim");
		stub_cre_cyc(cycid, pk_ccyc);
		VERIFY2("cre_cyc", cycid, pk_ccyc);
		stub_cre_cyc(cycid, (const t_ccyc*)pk_ccyc);
		VERIFY2("cre_cyc", cycid, pk_ccyc);
		stub_acre_cyc(pk_ccyc);
		VERIFY1("acre_cyc", pk_ccyc);
		stub_acre_cyc((const t_ccyc*)pk_ccyc);
		VERIFY1("acre_cyc", pk_ccyc);
		stub_del_cyc(cycid);
		VERIFY1("del_cyc", cycid);
		stub_sta_cyc(cycid);
		VERIFY1("sta_cyc", cycid);
		stub_stp_cyc(cycid);
		VERIFY1("stp_cyc", cycid);
		stub_ref_cyc(cycid, pk_rcyc);
		VERIFY2("ref_cyc", cycid, pk_rcyc);
		stub_cre_alm(almid, pk_calm);
		VERIFY2("cre_alm", almid, pk_calm);
		stub_cre_alm(almid, (const t_calm*)pk_calm);
		VERIFY2("cre_alm", almid, pk_calm);
		stub_acre_alm(pk_calm);
		VERIFY1("acre_alm", pk_calm);
		stub_acre_alm((const t_calm*)pk_calm);
		VERIFY1("acre_alm", pk_calm);
		stub_del_alm(almid);
		VERIFY1("del_alm", almid);
		stub_sta_alm(almid, almtim);
		VERIFY2("sta_alm", almid, almtim);
		stub_stp_alm(almid);
		VERIFY1("stp_alm", almid);
		stub_ref_alm(almid, pk_ralm);
		VERIFY2("ref_alm", almid, pk_ralm);
		stub_def_ovr(pk_dovr);
		VERIFY1("def_ovr", pk_dovr);
		stub_def_ovr((const t_dovr*)pk_dovr);
		VERIFY1("def_ovr", pk_dovr);
		stub_sta_ovr(tskid, ovrtim);
		VERIFY2("sta_ovr", tskid, ovrtim);
		stub_stp_ovr(tskid);
		VERIFY1("stp_ovr", tskid);
		stub_ref_ovr(tskid, pk_rovr);
		VERIFY2("ref_ovr", tskid, pk_rovr);
		stub_rot_rdq(tskpri);
		VERIFY1("rot_rdq", tskpri);
		stub_irot_rdq(tskpri);
		VERIFY1("irot_rdq", tskpri);
		stub_get_tid(p_tskid);
		VERIFY1("get_tid", p_tskid);
		stub_iget_tid(p_tskid);
		VERIFY1("iget_tid", p_tskid);
		stub_loc_cpu();
		VERIFY0("loc_cpu");
		stub_iloc_cpu();
		VERIFY0("iloc_cpu");
		stub_unl_cpu();
		VERIFY0("unl_cpu");
		stub_iunl_cpu();
		VERIFY0("iunl_cpu");
		stub_dis_dsp();
		VERIFY0("dis_dsp");
		stub_ena_dsp();
		VERIFY0("ena_dsp");
		stub_sns_ctx();
		VERIFY0("sns_ctx");
		stub_sns_loc();
		VERIFY0("sns_loc");
		stub_sns_dsp();
		VERIFY0("sns_dsp");
		stub_sns_dpn();
		VERIFY0("sns_dpn");
		stub_vsns_ini();
		VERIFY0("vsns_ini");
		stub_ref_sys(pk_rsys);
		VERIFY1("ref_sys", pk_rsys);
		stub_def_inh(inhno, pk_dinh);
		VERIFY2("def_inh", inhno, pk_dinh);
		stub_def_inh(inhno, (const t_dinh*)pk_dinh);
		VERIFY2("def_inh", inhno, pk_dinh);
		stub_cre_isr(isrid, pk_cisr);
		VERIFY2("cre_isr", isrid, pk_cisr);
		stub_cre_isr(isrid, (const t_cisr*)pk_cisr);
		VERIFY2("cre_isr", isrid, pk_cisr);
		stub_acre_isr(pk_cisr);
		VERIFY1("acre_isr", pk_cisr);
		stub_acre_isr((const t_cisr*)pk_cisr);
		VERIFY1("acre_isr", pk_cisr);
		stub_del_isr(isrid);
		VERIFY1("del_isr", isrid);
		stub_ref_isr(isrid, pk_risr);
		VERIFY2("ref_isr", isrid, pk_risr);
		stub_dis_int(intno);
		VERIFY1("dis_int", intno);
		stub_ena_int(intno);
		VERIFY1("ena_int", intno);
		stub_chg_ims(ims);
		VERIFY1("chg_ipm", ims);
		stub_get_ims(p_ims);
		VERIFY1("get_ipm", p_ims);
		stub_def_svc(fncd, pk_dsvc);
		VERIFY2("def_svc", fncd, pk_dsvc);
		stub_def_svc(fncd, (const t_dsvc*)pk_dsvc);
		VERIFY2("def_svc", fncd, pk_dsvc);
		stub_cal_svc(fncd);
		VERIFY6("cal_svc", fncd, 0, 0, 0, 0, 0);
		stub_cal_svc(fncd, arg1);
		VERIFY6("cal_svc", fncd, arg1, 0, 0, 0, 0);
		stub_cal_svc(fncd, arg1, arg2);
		VERIFY6("cal_svc", fncd, arg1, arg2, 0, 0, 0);
		stub_cal_svc(fncd, arg1, arg2, arg3);
		VERIFY6("cal_svc", fncd, arg1, arg2, arg3, 0, 0);
		stub_cal_svc(fncd, arg1, arg2, arg3, arg4);
		VERIFY6("cal_svc", fncd, arg1, arg2, arg3, arg4, 0);
		stub_cal_svc(fncd, arg1, arg2, arg3, arg4, arg5);
		VERIFY6("cal_svc", fncd, arg1, arg2, arg3, arg4, arg5);
		stub_def_exc(excno, pk_dexc);
		VERIFY2("def_exc", excno, pk_dexc);
		stub_def_exc(excno, (const t_dexc*)pk_dexc);
		VERIFY2("def_exc", excno, pk_dexc);
		stub_ref_cfg(pk_rcfg);
		VERIFY1("ref_cfg", pk_rcfg);
		stub_ref_ver(pk_rver);
		VERIFY1("ref_ver", pk_rver);
		stub_vxsns_ctx(p_excinf);
		VERIFY1("vxsns_ctx", p_excinf);
		stub_vxsns_loc(p_excinf);
		VERIFY1("vxsns_loc", p_excinf);
		stub_vxsns_dsp(p_excinf);
		VERIFY1("vxsns_dsp", p_excinf);
		stub_vxsns_dpn(p_excinf);
		VERIFY1("vxsns_dpn", p_excinf);
		stub_vxsns_tex(p_excinf);
		VERIFY1("vxsns_tex", p_excinf);
	}
};

template <class Stub>
struct stub_tester<toppers::fncode_stub<Stub> > : toppers::fncode_stub<Stub>
{
public:
	stub_tester()
	{
		stub_cre_tsk(tskid, pk_ctsk);
		VERIFY6("cal_svc", toppers::tfn_cre_tsk, tskid, pk_ctsk, 0, 0, 0);
		stub_cre_tsk(tskid, (const t_ctsk*)pk_ctsk);
		VERIFY6("cal_svc", toppers::tfn_cre_tsk, tskid, pk_ctsk, 0, 0, 0);
		stub_acre_tsk(pk_ctsk);
		VERIFY6("cal_svc", toppers::tfn_acre_tsk, pk_ctsk, 0, 0, 0, 0);
		stub_acre_tsk((const t_ctsk*)pk_ctsk);
		VERIFY6("cal_svc", toppers::tfn_acre_tsk, pk_ctsk, 0, 0, 0, 0);
		stub_del_tsk(tskid);
		VERIFY6("cal_svc", toppers::tfn_del_tsk, tskid, 0, 0, 0, 0);
		stub_act_tsk(tskid);
		VERIFY6("cal_svc", toppers::tfn_act_tsk, tskid, 0, 0, 0, 0);
		stub_iact_tsk(tskid);
		VERIFY6("cal_svc", toppers::tfn_iact_tsk, tskid, 0, 0, 0, 0);
		stub_can_act(tskid);
		VERIFY6("cal_svc", toppers::tfn_can_act, tskid, 0, 0, 0, 0);
		stub_sta_tsk(tskid, stacd);
		VERIFY6("cal_svc", toppers::tfn_sta_tsk, tskid, stacd, 0, 0, 0);
		stub_ext_tsk();
		VERIFY6("cal_svc", toppers::tfn_ext_tsk, 0, 0, 0, 0, 0);
		stub_exd_tsk();
		VERIFY6("cal_svc", toppers::tfn_exd_tsk, 0, 0, 0, 0, 0);
		stub_ter_tsk(tskid);
		VERIFY6("cal_svc", toppers::tfn_ter_tsk, tskid, 0, 0, 0, 0);
		stub_chg_pri(tskid, tskpri);
		VERIFY6("cal_svc", toppers::tfn_chg_pri, tskid, tskpri, 0, 0, 0);
		stub_get_pri(tskid, p_tskpri);
		VERIFY6("cal_svc", toppers::tfn_get_pri, tskid, p_tskpri, 0, 0, 0);
		stub_ref_tsk(tskid, pk_rtsk);
		VERIFY6("cal_svc", toppers::tfn_ref_tsk, tskid, pk_rtsk, 0, 0, 0);
		stub_ref_tst(tskid, pk_rtst);
		VERIFY6("cal_svc", toppers::tfn_ref_tst, tskid, pk_rtst, 0, 0, 0);
		stub_slp_tsk();
		VERIFY6("cal_svc", toppers::tfn_slp_tsk, 0, 0, 0, 0, 0);
		stub_tslp_tsk(tmout);
		VERIFY6("cal_svc", toppers::tfn_tslp_tsk, tmout, 0, 0, 0, 0);
		stub_wup_tsk(tskid);
		VERIFY6("cal_svc", toppers::tfn_wup_tsk, tskid, 0, 0, 0, 0);
		stub_iwup_tsk(tskid);
		VERIFY6("cal_svc", toppers::tfn_iwup_tsk, tskid, 0, 0, 0, 0);
		stub_can_wup(tskid);
		VERIFY6("cal_svc", toppers::tfn_can_wup, tskid, 0, 0, 0, 0);
		stub_rel_wai(tskid);
		VERIFY6("cal_svc", toppers::tfn_rel_wai, tskid, 0, 0, 0, 0);
		stub_irel_wai(tskid);
		VERIFY6("cal_svc", toppers::tfn_irel_wai, tskid, 0, 0, 0, 0);
		stub_sus_tsk(tskid);
		VERIFY6("cal_svc", toppers::tfn_sus_tsk, tskid, 0, 0, 0, 0);
		stub_rsm_tsk(tskid);
		VERIFY6("cal_svc", toppers::tfn_rsm_tsk, tskid, 0, 0, 0, 0);
		stub_frsm_tsk(tskid);
		VERIFY6("cal_svc", toppers::tfn_frsm_tsk, tskid, 0, 0, 0, 0);
		stub_dly_tsk(dlytim);
		VERIFY6("cal_svc", toppers::tfn_dly_tsk, dlytim, 0, 0, 0, 0);
		stub_def_tex(tskid, pk_dtex);
		VERIFY6("cal_svc", toppers::tfn_def_tex, tskid, pk_dtex, 0, 0, 0);
		stub_def_tex(tskid, (const t_dtex*)pk_dtex);
		VERIFY6("cal_svc", toppers::tfn_def_tex, tskid, pk_dtex, 0, 0, 0);
		stub_ras_tex(tskid, rasptn);
		VERIFY6("cal_svc", toppers::tfn_ras_tex, tskid, rasptn, 0, 0, 0);
		stub_iras_tex(tskid, rasptn);
		VERIFY6("cal_svc", toppers::tfn_iras_tex, tskid, rasptn, 0, 0, 0);
		stub_dis_tex();
		VERIFY6("cal_svc", toppers::tfn_dis_tex, 0, 0, 0, 0, 0);
		stub_ena_tex();
		VERIFY6("cal_svc", toppers::tfn_ena_tex, 0, 0, 0, 0, 0);
		stub_sns_tex();
		VERIFY6("cal_svc", toppers::tfn_sns_tex, 0, 0, 0, 0, 0);
		stub_ref_tex(tskid, pk_rtex);
		VERIFY6("cal_svc", toppers::tfn_ref_tex, tskid, pk_rtex, 0, 0, 0);
		stub_cre_sem(semid, pk_csem);
		VERIFY6("cal_svc", toppers::tfn_cre_sem, semid, pk_csem, 0, 0, 0);
		stub_cre_sem(semid, (const t_csem*)pk_csem);
		VERIFY6("cal_svc", toppers::tfn_cre_sem, semid, pk_csem, 0, 0, 0);
		stub_acre_sem(pk_csem);
		VERIFY6("cal_svc", toppers::tfn_acre_sem, pk_csem, 0, 0, 0, 0);
		stub_acre_sem((const t_csem*)pk_csem);
		VERIFY6("cal_svc", toppers::tfn_acre_sem, pk_csem, 0, 0, 0, 0);
		stub_del_sem(semid);
		VERIFY6("cal_svc", toppers::tfn_del_sem, semid, 0, 0, 0, 0);
		stub_sig_sem(semid);
		VERIFY6("cal_svc", toppers::tfn_sig_sem, semid, 0, 0, 0, 0);
		stub_isig_sem(semid);
		VERIFY6("cal_svc", toppers::tfn_isig_sem, semid, 0, 0, 0, 0);
		stub_wai_sem(semid);
		VERIFY6("cal_svc", toppers::tfn_wai_sem, semid, 0, 0, 0, 0);
		stub_pol_sem(semid);
		VERIFY6("cal_svc", toppers::tfn_pol_sem, semid, 0, 0, 0, 0);
		stub_twai_sem(semid, tmout);
		VERIFY6("cal_svc", toppers::tfn_twai_sem, semid, tmout, 0, 0, 0);
		stub_ref_sem(semid, pk_rsem);
		VERIFY6("cal_svc", toppers::tfn_ref_sem, semid, pk_rsem, 0, 0, 0);
		stub_cre_flg(flgid, pk_cflg);
		VERIFY6("cal_svc", toppers::tfn_cre_flg, flgid, pk_cflg, 0, 0, 0);
		stub_cre_flg(flgid, (const t_cflg*)pk_cflg);
		VERIFY6("cal_svc", toppers::tfn_cre_flg, flgid, pk_cflg, 0, 0, 0);
		stub_acre_flg(pk_cflg);
		VERIFY6("cal_svc", toppers::tfn_acre_flg, pk_cflg, 0, 0, 0, 0);
		stub_acre_flg((const t_cflg*)pk_cflg);
		VERIFY6("cal_svc", toppers::tfn_acre_flg, pk_cflg, 0, 0, 0, 0);
		stub_del_flg(flgid);
		VERIFY6("cal_svc", toppers::tfn_del_flg, flgid, 0, 0, 0, 0);
		stub_set_flg(flgid, setptn);
		VERIFY6("cal_svc", toppers::tfn_set_flg, flgid, setptn, 0, 0, 0);
		stub_iset_flg(flgid, setptn);
		VERIFY6("cal_svc", toppers::tfn_iset_flg, flgid, setptn, 0, 0, 0);
		stub_clr_flg(flgid, clrptn);
		VERIFY6("cal_svc", toppers::tfn_clr_flg, flgid, clrptn, 0, 0, 0);
		stub_wai_flg(flgid, waiptn, wfmode, p_flgptn);
		VERIFY6("cal_svc", toppers::tfn_wai_flg, flgid, waiptn, wfmode, p_flgptn, 0);
		stub_pol_flg(flgid, waiptn, wfmode, p_flgptn);
		VERIFY6("cal_svc", toppers::tfn_pol_flg, flgid, waiptn, wfmode, p_flgptn, 0);
		stub_twai_flg(flgid, waiptn, wfmode, p_flgptn, tmout);
		VERIFY6("cal_svc", toppers::tfn_twai_flg, flgid, waiptn, wfmode, p_flgptn, tmout);
		stub_ref_flg(flgid, pk_rflg);
		VERIFY6("cal_svc", toppers::tfn_ref_flg, flgid, pk_rflg, 0, 0, 0);
		stub_cre_dtq(dtqid, pk_cdtq);
		VERIFY6("cal_svc", toppers::tfn_cre_dtq, dtqid, pk_cdtq, 0, 0, 0);
		stub_cre_dtq(dtqid, (const t_cdtq*)pk_cdtq);
		VERIFY6("cal_svc", toppers::tfn_cre_dtq, dtqid, pk_cdtq, 0, 0, 0);
		stub_acre_dtq(pk_cdtq);
		VERIFY6("cal_svc", toppers::tfn_acre_dtq, pk_cdtq, 0, 0, 0, 0);
		stub_acre_dtq((const t_cdtq*)pk_cdtq);
		VERIFY6("cal_svc", toppers::tfn_acre_dtq, pk_cdtq, 0, 0, 0, 0);
		stub_del_dtq(dtqid);
		VERIFY6("cal_svc", toppers::tfn_del_dtq, dtqid, 0, 0, 0, 0);
		stub_snd_dtq(dtqid, data);
		VERIFY6("cal_svc", toppers::tfn_snd_dtq, dtqid, data, 0, 0, 0);
		stub_psnd_dtq(dtqid, data);
		VERIFY6("cal_svc", toppers::tfn_psnd_dtq, dtqid, data, 0, 0, 0);
		stub_ipsnd_dtq(dtqid, data);
		VERIFY6("cal_svc", toppers::tfn_ipsnd_dtq, dtqid, data, 0, 0, 0);
		stub_tsnd_dtq(dtqid, data, tmout);
		VERIFY6("cal_svc", toppers::tfn_tsnd_dtq, dtqid, data, tmout, 0, 0);
		stub_fsnd_dtq(dtqid, data);
		VERIFY6("cal_svc", toppers::tfn_fsnd_dtq, dtqid, data, 0, 0, 0);
		stub_ifsnd_dtq(dtqid, data);
		VERIFY6("cal_svc", toppers::tfn_ifsnd_dtq, dtqid, data, 0, 0, 0);
		stub_rcv_dtq(dtqid, p_data);
		VERIFY6("cal_svc", toppers::tfn_rcv_dtq, dtqid, p_data, 0, 0, 0);
		stub_prcv_dtq(dtqid, p_data);
		VERIFY6("cal_svc", toppers::tfn_prcv_dtq, dtqid, p_data, 0, 0, 0);
		stub_trcv_dtq(dtqid, p_data, tmout);
		VERIFY6("cal_svc", toppers::tfn_trcv_dtq, dtqid, p_data, tmout, 0, 0);
		stub_ref_dtq(dtqid, pk_rdtq);
		VERIFY6("cal_svc", toppers::tfn_ref_dtq, dtqid, pk_rdtq, 0, 0, 0);
		stub_cre_mbx(mbxid, pk_cmbx);
		VERIFY6("cal_svc", toppers::tfn_cre_mbx, mbxid, pk_cmbx, 0, 0, 0);
		stub_cre_mbx(mbxid, (const t_cmbx*)pk_cmbx);
		VERIFY6("cal_svc", toppers::tfn_cre_mbx, mbxid, pk_cmbx, 0, 0, 0);
		stub_acre_mbx(pk_cmbx);
		VERIFY6("cal_svc", toppers::tfn_acre_mbx, pk_cmbx, 0, 0, 0, 0);
		stub_acre_mbx((const t_cmbx*)pk_cmbx);
		VERIFY6("cal_svc", toppers::tfn_acre_mbx, pk_cmbx, 0, 0, 0, 0);
		stub_del_mbx(mbxid);
		VERIFY6("cal_svc", toppers::tfn_del_mbx, mbxid, 0, 0, 0, 0);
		stub_snd_mbx(mbxid, pk_msg);
		VERIFY6("cal_svc", toppers::tfn_snd_mbx, mbxid, pk_msg, 0, 0, 0);
		stub_rcv_mbx(mbxid, ppk_msg);
		VERIFY6("cal_svc", toppers::tfn_rcv_mbx, mbxid, ppk_msg, 0, 0, 0);
		stub_prcv_mbx(mbxid, ppk_msg);
		VERIFY6("cal_svc", toppers::tfn_prcv_mbx, mbxid, ppk_msg, 0, 0, 0);
		stub_trcv_mbx(mbxid, ppk_msg, tmout);
		VERIFY6("cal_svc", toppers::tfn_trcv_mbx, mbxid, ppk_msg, tmout, 0, 0);
		stub_ref_mbx(mbxid, pk_rmbx);
		VERIFY6("cal_svc", toppers::tfn_ref_mbx, mbxid, pk_rmbx, 0, 0, 0);
		stub_cre_mtx(mtxid, pk_cmtx);
		VERIFY6("cal_svc", toppers::tfn_cre_mtx, mtxid, pk_cmtx, 0, 0, 0);
		stub_cre_mtx(mtxid, (const t_cmtx*)pk_cmtx);
		VERIFY6("cal_svc", toppers::tfn_cre_mtx, mtxid, pk_cmtx, 0, 0, 0);
		stub_acre_mtx(pk_cmtx);
		VERIFY6("cal_svc", toppers::tfn_acre_mtx, pk_cmtx, 0, 0, 0, 0);
		stub_acre_mtx((const t_cmtx*)pk_cmtx);
		VERIFY6("cal_svc", toppers::tfn_acre_mtx, pk_cmtx, 0, 0, 0, 0);
		stub_del_mtx(mtxid);
		VERIFY6("cal_svc", toppers::tfn_del_mtx, mtxid, 0, 0, 0, 0);
		stub_loc_mtx(mtxid);
		VERIFY6("cal_svc", toppers::tfn_loc_mtx, mtxid, 0, 0, 0, 0);
		stub_ploc_mtx(mtxid);
		VERIFY6("cal_svc", toppers::tfn_ploc_mtx, mtxid, 0, 0, 0, 0);
		stub_tloc_mtx(mtxid, tmout);
		VERIFY6("cal_svc", toppers::tfn_tloc_mtx, mtxid, tmout, 0, 0, 0);
		stub_unl_mtx(mtxid);
		VERIFY6("cal_svc", toppers::tfn_unl_mtx, mtxid, 0, 0, 0, 0);
		stub_ref_mtx(mtxid, pk_rmtx);
		VERIFY6("cal_svc", toppers::tfn_ref_mtx, mtxid, pk_rmtx, 0, 0, 0);
		stub_cre_mbf(mbfid, pk_cmbf);
		VERIFY6("cal_svc", toppers::tfn_cre_mbf, mbfid, pk_cmbf, 0, 0, 0);
		stub_cre_mbf(mbfid, (const t_cmbf*)pk_cmbf);
		VERIFY6("cal_svc", toppers::tfn_cre_mbf, mbfid, pk_cmbf, 0, 0, 0);
		stub_acre_mbf(pk_cmbf);
		VERIFY6("cal_svc", toppers::tfn_acre_mbf, pk_cmbf, 0, 0, 0, 0);
		stub_acre_mbf((const t_cmbf*)pk_cmbf);
		VERIFY6("cal_svc", toppers::tfn_acre_mbf, pk_cmbf, 0, 0, 0, 0);
		stub_del_mbf(mbfid);
		VERIFY6("cal_svc", toppers::tfn_del_mbf, mbfid, 0, 0, 0, 0);
		stub_snd_mbf(mbfid, msg, msgsz);
		VERIFY6("cal_svc", toppers::tfn_snd_mbf, mbfid, msg, msgsz, 0, 0);
		stub_psnd_mbf(mbfid, msg, msgsz);
		VERIFY6("cal_svc", toppers::tfn_psnd_mbf, mbfid, msg, msgsz, 0, 0);
		stub_tsnd_mbf(mbfid, msg, msgsz, tmout);
		VERIFY6("cal_svc", toppers::tfn_tsnd_mbf, mbfid, msg, msgsz, tmout, 0);
		stub_rcv_mbf(mbfid, msg);
		VERIFY6("cal_svc", toppers::tfn_rcv_mbf, mbfid, msg, 0, 0, 0);
		stub_prcv_mbf(mbfid, msg);
		VERIFY6("cal_svc", toppers::tfn_prcv_mbf, mbfid, msg, 0, 0, 0);
		stub_trcv_mbf(mbfid, msg, tmout);
		VERIFY6("cal_svc", toppers::tfn_trcv_mbf, mbfid, msg, tmout, 0, 0);
		stub_ref_mbf(mbfid, pk_rmbf);
		VERIFY6("cal_svc", toppers::tfn_ref_mbf, mbfid, pk_rmbf, 0, 0, 0);
		stub_cre_por(porid, pk_cpor);
		VERIFY6("cal_svc", toppers::tfn_cre_por, porid, pk_cpor, 0, 0, 0);
		stub_cre_por(porid, (const t_cpor*)pk_cpor);
		VERIFY6("cal_svc", toppers::tfn_cre_por, porid, pk_cpor, 0, 0, 0);
		stub_acre_por(pk_cpor);
		VERIFY6("cal_svc", toppers::tfn_acre_por, pk_cpor, 0, 0, 0, 0);
		stub_acre_por((const t_cpor*)pk_cpor);
		VERIFY6("cal_svc", toppers::tfn_acre_por, pk_cpor, 0, 0, 0, 0);
		stub_del_por(porid);
		VERIFY6("cal_svc", toppers::tfn_del_por, porid, 0, 0, 0, 0);
		stub_cal_por(porid, calptn, msg, cmsgsz);
		VERIFY6("cal_svc", toppers::tfn_cal_por, porid, calptn, msg, cmsgsz, 0);
		stub_tcal_por(porid, calptn, msg, cmsgsz, tmout);
		VERIFY6("cal_svc", toppers::tfn_tcal_por, porid, calptn, msg, cmsgsz, tmout);
		stub_acp_por(porid, acpptn, p_rdvno, msg);
		VERIFY6("cal_svc", toppers::tfn_acp_por, porid, acpptn, p_rdvno, msg, 0);
		stub_pacp_por(porid, acpptn, p_rdvno, msg);
		VERIFY6("cal_svc", toppers::tfn_pacp_por, porid, acpptn, p_rdvno, msg, 0);
		stub_tacp_por(porid, acpptn, p_rdvno, msg, tmout);
		VERIFY6("cal_svc", toppers::tfn_tacp_por, porid, acpptn, p_rdvno, msg, tmout);
		stub_fwd_por(porid, acpptn, rdvno, msg, cmsgsz);
		VERIFY6("cal_svc", toppers::tfn_fwd_por, porid, acpptn, rdvno, msg, cmsgsz);
		stub_rpl_rdv(rdvno, msg, rmsgsz);
		VERIFY6("cal_svc", toppers::tfn_rpl_rdv, rdvno, msg, rmsgsz, 0, 0);
		stub_ref_por(porid, pk_rpor);
		VERIFY6("cal_svc", toppers::tfn_ref_por, porid, pk_rpor, 0, 0, 0);
		stub_ref_rdv(rdvno, pk_rrdv);
		VERIFY6("cal_svc", toppers::tfn_ref_rdv, rdvno, pk_rrdv, 0, 0, 0);
		stub_cre_mpf(mpfid, pk_cmpf);
		VERIFY6("cal_svc", toppers::tfn_cre_mpf, mpfid, pk_cmpf, 0, 0, 0);
		stub_cre_mpf(mpfid, (const t_cmpf*)pk_cmpf);
		VERIFY6("cal_svc", toppers::tfn_cre_mpf, mpfid, pk_cmpf, 0, 0, 0);
		stub_acre_mpf(pk_cmpf);
		VERIFY6("cal_svc", toppers::tfn_acre_mpf, pk_cmpf, 0, 0, 0, 0);
		stub_acre_mpf((const t_cmpf*)pk_cmpf);
		VERIFY6("cal_svc", toppers::tfn_acre_mpf, pk_cmpf, 0, 0, 0, 0);
		stub_del_mpf(mpfid);
		VERIFY6("cal_svc", toppers::tfn_del_mpf, mpfid, 0, 0, 0, 0);
		stub_get_mpf(mpfid, p_blk);
		VERIFY6("cal_svc", toppers::tfn_get_mpf, mpfid, p_blk, 0, 0, 0);
		stub_pget_mpf(mpfid, p_blk);
		VERIFY6("cal_svc", toppers::tfn_pget_mpf, mpfid, p_blk, 0, 0, 0);
		stub_tget_mpf(mpfid, p_blk, tmout);
		VERIFY6("cal_svc", toppers::tfn_tget_mpf, mpfid, p_blk, tmout, 0, 0);
		stub_rel_mpf(mpfid, blk);
		VERIFY6("cal_svc", toppers::tfn_rel_mpf, mpfid, blk, 0, 0, 0);
		stub_ref_mpf(mpfid, pk_rmpf);
		VERIFY6("cal_svc", toppers::tfn_ref_mpf, mpfid, pk_rmpf, 0, 0, 0);
		stub_cre_mpl(mplid, pk_cmpl);
		VERIFY6("cal_svc", toppers::tfn_cre_mpl, mplid, pk_cmpl, 0, 0, 0);
		stub_cre_mpl(mplid, (const t_cmpl*)pk_cmpl);
		VERIFY6("cal_svc", toppers::tfn_cre_mpl, mplid, pk_cmpl, 0, 0, 0);
		stub_acre_mpl(pk_cmpl);
		VERIFY6("cal_svc", toppers::tfn_acre_mpl, pk_cmpl, 0, 0, 0, 0);
		stub_acre_mpl((const t_cmpl*)pk_cmpl);
		VERIFY6("cal_svc", toppers::tfn_acre_mpl, pk_cmpl, 0, 0, 0, 0);
		stub_del_mpl(mplid);
		VERIFY6("cal_svc", toppers::tfn_del_mpl, mplid, 0, 0, 0, 0);
		stub_get_mpl(mplid, blksz, p_blk);
		VERIFY6("cal_svc", toppers::tfn_get_mpl, mplid, blksz, p_blk, 0, 0);
		stub_pget_mpl(mplid, blksz, p_blk);
		VERIFY6("cal_svc", toppers::tfn_pget_mpl, mplid, blksz, p_blk, 0, 0);
		stub_tget_mpl(mplid, blksz, p_blk, tmout);
		VERIFY6("cal_svc", toppers::tfn_tget_mpl, mplid, blksz, p_blk, tmout, 0);
		stub_rel_mpl(mplid, blk);
		VERIFY6("cal_svc", toppers::tfn_rel_mpl, mplid, blk, 0, 0, 0);
		stub_ref_mpl(mplid, pk_rmpl);
		VERIFY6("cal_svc", toppers::tfn_ref_mpl, mplid, pk_rmpl, 0, 0, 0);
		stub_set_tim(p_systim);
		VERIFY6("cal_svc", toppers::tfn_set_tim, p_systim, 0, 0, 0, 0);
		stub_set_tim((const SYSTIM*)p_systim);
		VERIFY6("cal_svc", toppers::tfn_set_tim, p_systim, 0, 0, 0, 0);
		stub_get_tim(p_systim);
		VERIFY6("cal_svc", toppers::tfn_get_tim, p_systim, 0, 0, 0, 0);
		stub_isig_tim();
		VERIFY6("cal_svc", toppers::tfn_isig_tim, 0, 0, 0, 0, 0);
		stub_cre_cyc(cycid, pk_ccyc);
		VERIFY6("cal_svc", toppers::tfn_cre_cyc, cycid, pk_ccyc, 0, 0, 0);
		stub_cre_cyc(cycid, (const t_ccyc*)pk_ccyc);
		VERIFY6("cal_svc", toppers::tfn_cre_cyc, cycid, pk_ccyc, 0, 0, 0);
		stub_acre_cyc(pk_ccyc);
		VERIFY6("cal_svc", toppers::tfn_acre_cyc, pk_ccyc, 0, 0, 0, 0);
		stub_acre_cyc((const t_ccyc*)pk_ccyc);
		VERIFY6("cal_svc", toppers::tfn_acre_cyc, pk_ccyc, 0, 0, 0, 0);
		stub_del_cyc(cycid);
		VERIFY6("cal_svc", toppers::tfn_del_cyc, cycid, 0, 0, 0, 0);
		stub_sta_cyc(cycid);
		VERIFY6("cal_svc", toppers::tfn_sta_cyc, cycid, 0, 0, 0, 0);
		stub_stp_cyc(cycid);
		VERIFY6("cal_svc", toppers::tfn_stp_cyc, cycid, 0, 0, 0, 0);
		stub_ref_cyc(cycid, pk_rcyc);
		VERIFY6("cal_svc", toppers::tfn_ref_cyc, cycid, pk_rcyc, 0, 0, 0);
		stub_cre_alm(almid, pk_calm);
		VERIFY6("cal_svc", toppers::tfn_cre_alm, almid, pk_calm, 0, 0, 0);
		stub_cre_alm(almid, (const t_calm*)pk_calm);
		VERIFY6("cal_svc", toppers::tfn_cre_alm, almid, pk_calm, 0, 0, 0);
		stub_acre_alm(pk_calm);
		VERIFY6("cal_svc", toppers::tfn_acre_alm, pk_calm, 0, 0, 0, 0);
		stub_acre_alm((const t_calm*)pk_calm);
		VERIFY6("cal_svc", toppers::tfn_acre_alm, pk_calm, 0, 0, 0, 0);
		stub_del_alm(almid);
		VERIFY6("cal_svc", toppers::tfn_del_alm, almid, 0, 0, 0, 0);
		stub_sta_alm(almid, almtim);
		VERIFY6("cal_svc", toppers::tfn_sta_alm, almid, almtim, 0, 0, 0);
		stub_stp_alm(almid);
		VERIFY6("cal_svc", toppers::tfn_stp_alm, almid, 0, 0, 0, 0);
		stub_ref_alm(almid, pk_ralm);
		VERIFY6("cal_svc", toppers::tfn_ref_alm, almid, pk_ralm, 0, 0, 0);
		stub_def_ovr(pk_dovr);
		VERIFY6("cal_svc", toppers::tfn_def_ovr, pk_dovr, 0, 0, 0, 0);
		stub_def_ovr((const t_dovr*)pk_dovr);
		VERIFY6("cal_svc", toppers::tfn_def_ovr, pk_dovr, 0, 0, 0, 0);
		stub_sta_ovr(tskid, ovrtim);
		VERIFY6("cal_svc", toppers::tfn_sta_ovr, tskid, ovrtim, 0, 0, 0);
		stub_stp_ovr(tskid);
		VERIFY6("cal_svc", toppers::tfn_stp_ovr, tskid, 0, 0, 0, 0);
		stub_ref_ovr(tskid, pk_rovr);
		VERIFY6("cal_svc", toppers::tfn_ref_ovr, tskid, pk_rovr, 0, 0, 0);
		stub_rot_rdq(tskpri);
		VERIFY6("cal_svc", toppers::tfn_rot_rdq, tskpri, 0, 0, 0, 0);
		stub_irot_rdq(tskpri);
		VERIFY6("cal_svc", toppers::tfn_irot_rdq, tskpri, 0, 0, 0, 0);
		stub_get_tid(p_tskid);
		VERIFY6("cal_svc", toppers::tfn_get_tid, p_tskid, 0, 0, 0, 0);
		stub_iget_tid(p_tskid);
		VERIFY6("cal_svc", toppers::tfn_iget_tid, p_tskid, 0, 0, 0, 0);
		stub_loc_cpu();
		VERIFY6("cal_svc", toppers::tfn_loc_cpu, 0, 0, 0, 0, 0);
		stub_iloc_cpu();
		VERIFY6("cal_svc", toppers::tfn_iloc_cpu, 0, 0, 0, 0, 0);
		stub_unl_cpu();
		VERIFY6("cal_svc", toppers::tfn_unl_cpu, 0, 0, 0, 0, 0);
		stub_iunl_cpu();
		VERIFY6("cal_svc", toppers::tfn_iunl_cpu, 0, 0, 0, 0, 0);
		stub_dis_dsp();
		VERIFY6("cal_svc", toppers::tfn_dis_dsp, 0, 0, 0, 0, 0);
		stub_ena_dsp();
		VERIFY6("cal_svc", toppers::tfn_ena_dsp, 0, 0, 0, 0, 0);
		stub_sns_ctx();
		VERIFY6("cal_svc", toppers::tfn_sns_ctx, 0, 0, 0, 0, 0);
		stub_sns_loc();
		VERIFY6("cal_svc", toppers::tfn_sns_loc, 0, 0, 0, 0, 0);
		stub_sns_dsp();
		VERIFY6("cal_svc", toppers::tfn_sns_dsp, 0, 0, 0, 0, 0);
		stub_sns_dpn();
		VERIFY6("cal_svc", toppers::tfn_sns_dpn, 0, 0, 0, 0, 0);
		stub_vsns_ini();
		VERIFY6("cal_svc", toppers::tfn_vsns_ini, 0, 0, 0, 0, 0);
		stub_ref_sys(pk_rsys);
		VERIFY6("cal_svc", toppers::tfn_ref_sys, pk_rsys, 0, 0, 0, 0);
		stub_def_inh(inhno, pk_dinh);
		VERIFY6("cal_svc", toppers::tfn_def_inh, inhno, pk_dinh, 0, 0, 0);
		stub_def_inh(inhno, (const t_dinh*)pk_dinh);
		VERIFY6("cal_svc", toppers::tfn_def_inh, inhno, pk_dinh, 0, 0, 0);
		stub_cre_isr(isrid, pk_cisr);
		VERIFY6("cal_svc", toppers::tfn_cre_isr, isrid, pk_cisr, 0, 0, 0);
		stub_cre_isr(isrid, (const t_cisr*)pk_cisr);
		VERIFY6("cal_svc", toppers::tfn_cre_isr, isrid, pk_cisr, 0, 0, 0);
		stub_acre_isr(pk_cisr);
		VERIFY6("cal_svc", toppers::tfn_acre_isr, pk_cisr, 0, 0, 0, 0);
		stub_acre_isr((const t_cisr*)pk_cisr);
		VERIFY6("cal_svc", toppers::tfn_acre_isr, pk_cisr, 0, 0, 0, 0);
		stub_del_isr(isrid);
		VERIFY6("cal_svc", toppers::tfn_del_isr, isrid, 0, 0, 0, 0);
		stub_ref_isr(isrid, pk_risr);
		VERIFY6("cal_svc", toppers::tfn_ref_isr, isrid, pk_risr, 0, 0, 0);
		stub_dis_int(intno);
		VERIFY6("cal_svc", toppers::tfn_dis_int, intno, 0, 0, 0, 0);
		stub_ena_int(intno);
		VERIFY6("cal_svc", toppers::tfn_ena_int, intno, 0, 0, 0, 0);
		stub_chg_ims(ims);
		VERIFY6("cal_svc", toppers::tfn_chg_ims, ims, 0, 0, 0, 0);
		stub_get_ims(p_ims);
		VERIFY6("cal_svc", toppers::tfn_get_ims, p_ims, 0, 0, 0, 0);
		stub_def_svc(fncd, pk_dsvc);
		VERIFY6("cal_svc", toppers::tfn_def_svc, fncd, pk_dsvc, 0, 0, 0);
		stub_def_svc(fncd, (const t_dsvc*)pk_dsvc);
		VERIFY6("cal_svc", toppers::tfn_def_svc, fncd, pk_dsvc, 0, 0, 0);
		stub_cal_svc(fncd);
		VERIFY6("cal_svc", fncd, 0, 0, 0, 0, 0);
		stub_cal_svc(fncd, arg1);
		VERIFY6("cal_svc", fncd, arg1, 0, 0, 0, 0);
		stub_cal_svc(fncd, arg1, arg2);
		VERIFY6("cal_svc", fncd, arg1, arg2, 0, 0, 0);
		stub_cal_svc(fncd, arg1, arg2, arg3);
		VERIFY6("cal_svc", fncd, arg1, arg2, arg3, 0, 0);
		stub_cal_svc(fncd, arg1, arg2, arg3, arg4);
		VERIFY6("cal_svc", fncd, arg1, arg2, arg3, arg4, 0);
		stub_cal_svc(fncd, arg1, arg2, arg3, arg4, arg5);
		VERIFY6("cal_svc", fncd, arg1, arg2, arg3, arg4, arg5);
		stub_def_exc(excno, pk_dexc);
		VERIFY6("cal_svc", toppers::tfn_def_exc, excno, pk_dexc, 0, 0, 0);
		stub_def_exc(excno, (const t_dexc*)pk_dexc);
		VERIFY6("cal_svc", toppers::tfn_def_exc, excno, pk_dexc, 0, 0, 0);
		stub_ref_cfg(pk_rcfg);
		VERIFY6("cal_svc", toppers::tfn_ref_cfg, pk_rcfg, 0, 0, 0, 0);
		stub_ref_ver(pk_rver);
		VERIFY6("cal_svc", toppers::tfn_ref_ver, pk_rver, 0, 0, 0, 0);
		stub_vxsns_ctx(p_excinf);
		VERIFY6("cal_svc", toppers::tfn_vxsns_ctx, p_excinf, 0, 0, 0, 0);
		stub_vxsns_loc(p_excinf);
		VERIFY6("cal_svc", toppers::tfn_vxsns_loc, p_excinf, 0, 0, 0, 0);
		stub_vxsns_dsp(p_excinf);
		VERIFY6("cal_svc", toppers::tfn_vxsns_dsp, p_excinf, 0, 0, 0, 0);
		stub_vxsns_dpn(p_excinf);
		VERIFY6("cal_svc", toppers::tfn_vxsns_dpn, p_excinf, 0, 0, 0, 0);
		stub_vxsns_tex(p_excinf);
		VERIFY6("cal_svc", toppers::tfn_vxsns_tex, p_excinf, 0, 0, 0, 0);
	}
};

void test_stub()
{
	fputs("------ test stub -----\n", stderr);
	{
		fputs("[raw_stub] ", stderr);
		stub_tester<toppers::raw_stub<> > test_raw_stub;
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[outline_stub] ", stderr);
		stub_tester<toppers::outline_stub > test_outline_stub;
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[fncode_stub] ", stderr);
		stub_tester<toppers::fncode_stub<toppers::raw_stub<> > > test_fncode_stub;
		fputs("-- ok\n", stderr);
	}
}

