/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: test_sync.cpp,v 1.1 2004/01/16 01:38:28 takagi-n Exp $
 */
#include <toppers/sync.hpp>
#include <toppers/semaphore.hpp>
#include <toppers/mutex.hpp>
#include <toppers/kernelstatus.hpp>
#include <toppers/taskexception.hpp>
#include "test.hpp"

void test_sync()
{
	fputs("----- test sync -----\n", stderr);
	{
		fputs("[lock<toppers::semaphore<1> >] ", stderr);
		{
			toppers::lock<toppers::semaphore<1> > x;
			VERIFY1("wai_sem", 1);
		}
		VERIFY1("sig_sem", 1);
		{
			toppers::recursive_lock<toppers::semaphore<1> > x;
			VERIFY1("wai_sem", 1);
			{
				toppers::recursive_lock<toppers::semaphore<1> > x;
				VERIFY1("get_tid", test_params[0]);
			}
			VERIFY0("sns_dsp");
		}
		VERIFY1("sig_sem", 1);
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[lock<toppers::mutex<1> >] ", stderr);
		{
			toppers::lock<toppers::mutex<1> > x;
			VERIFY1("loc_mtx", 1);
		}
		VERIFY1("unl_mtx", 1);
		{
			toppers::recursive_lock<toppers::mutex<1> > x;
			VERIFY1("loc_mtx", 1);
			{
				toppers::recursive_lock<toppers::mutex<1> > x;
				VERIFY1("get_tid", test_params[0]);
			}
			VERIFY0("sns_dsp");
		}
		VERIFY1("unl_mtx", 1);
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[lock<toppers::cpulock<> >] ", stderr);
		{
			toppers::lock<toppers::cpulock<> > x;
			VERIFY0("loc_cpu");
		}
		VERIFY0("unl_cpu");
		{
			loc_cpu();
			toppers::recursive_lock<toppers::cpulock<> > x;
			VERIFY0("sns_loc");
		}
		VERIFY0("sns_loc");
		{
			unl_cpu();
			toppers::recursive_lock<toppers::cpulock<> > x;
			VERIFY0("loc_cpu");
		}
		VERIFY0("unl_cpu");
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[lock<toppers::dispatcher<> >] ", stderr);
		{
			toppers::lock<toppers::dispatcher<> > x;
			VERIFY0("dis_dsp");
		}
		VERIFY0("ena_dsp");
		{
			dis_dsp();
			toppers::recursive_lock<toppers::dispatcher<> > x;
			VERIFY0("sns_dsp");
		}
		VERIFY0("sns_dsp");
		{
			ena_dsp();
			toppers::recursive_lock<toppers::dispatcher<> > x;
			VERIFY0("dis_dsp");
		}
		VERIFY0("ena_dsp");
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[lock<toppers::taskexception<> >] ", stderr);
		{
			toppers::lock<toppers::taskexception<> > x;
			VERIFY0("dis_tex");
		}
		VERIFY0("ena_tex");
		{
			dis_tex();
			toppers::recursive_lock<toppers::taskexception<> > x;
			VERIFY0("sns_tex");
		}
		VERIFY0("sns_tex");
		{
			ena_tex();
			toppers::recursive_lock<toppers::taskexception<> > x;
			VERIFY0("dis_tex");
		}
		VERIFY0("ena_tex");
		fputs("-- ok\n", stderr);
	}
}

