/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: test_tex.cpp,v 1.1 2004/01/16 01:38:28 takagi-n Exp $
 */
#include <toppers/taskexception.hpp>
#include <toppers/task.hpp>
#include "test.hpp"

namespace {

	class body : public toppers::taskexception_body<>
	{
		typedef	toppers::taskexception_body<>	super;
	public:
		explicit body(TEXPTN texptn, VP_INT exinf) : super(texptn, exinf) {}
		void run()
		{
			tracer t;
			VP_INT exinf = get_extended_info();
			ASSERT(exinf == VP_INT(123));
			printf("exinf = %p\n", exinf);
		}
	};

}

void test_tex()
{
	fputs("----- test taskexception -----\n", stderr);
	{
		toppers::task<1> tsk;
		fputs("[taskexception<>] ", stderr);
		typedef	toppers::taskexception<>	taskexception;
		TEST_EXP(taskexception::define<body>(tsk));
		VERIFY2("def_tex", 1, test_params[1]);
		TEST_EXP(taskexception::raise(tsk, 0x2222));
		VERIFY2("ras_tex", 1, 0x2222);
		TEST_EXP(taskexception::raise(tsk, 0x2222, toppers::non_task_context));
		VERIFY2("iras_tex", 1, 0x2222);
		set_test_context(TRUE);
		TEST_EXP(taskexception::raise(tsk, 0x2222, toppers::context_independent));
		VERIFY2("iras_tex", 1, 0x2222);
		set_test_context(FALSE);
		TEST_EXP(taskexception::raise(tsk, 0x2222, toppers::context_independent));
		VERIFY2("ras_tex", 1, 0x2222);
		TEST_EXP(taskexception::raise(0x2222));
		VERIFY2("ras_tex", 0, 0x2222);
		TEST_EXP(taskexception::raise(0x2222, toppers::non_task_context));
		VERIFY2("iras_tex", 0, 0x2222);
		set_test_context(TRUE);
		TEST_EXP(taskexception::raise(0x2222, toppers::context_independent));
		VERIFY2("iras_tex", 0, 0x2222);
		set_test_context(FALSE);
		TEST_EXP(taskexception::raise(0x2222, toppers::context_independent));
		VERIFY2("ras_tex", 0, 0x2222);
		TEST_EXP(taskexception::disable());
		VERIFY0("dis_tex");
		TEST_EXP(taskexception::enable());
		VERIFY0("ena_tex");
		TEST_EXP(taskexception::sense());
		VERIFY0("sns_tex");
		taskexception::reference	pk_rtex[1];
		TEST_EXP(taskexception::refer(tsk, pk_rtex));
		VERIFY2("ref_tex", 1, pk_rtex);
		TEST_EXP(taskexception::refer(pk_rtex));
		VERIFY2("ref_tex", 0, pk_rtex);
		TEST_EXP(taskexception::undefine(tsk));
		VERIFY2("def_tex", 1, 0);
		TEST_EXP(taskexception::define<body>());
		VERIFY2("def_tex", TSK_SELF, test_params[1]);
		TEST_EXP(taskexception::undefine());
		VERIFY2("def_tex", TSK_SELF, 0);
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[taskexception body] ", stderr);
		set_test_context(FALSE);
		toppers::taskexception_entry<body>(0x1111, (VP_INT)(123));
		fputs("-- ok\n", stderr);
	}
}

