/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: test_trace.cpp,v 1.3 2004/01/26 00:53:45 takagi-n Exp $
 */
#include <toppers/trace.hpp>
#include <string.h>
#include "test.hpp"

template <typename T>
class TOPPERS_TYPENAME_test
{
};

void test_trace()
{
	fputs("----- test trace -----\n", stderr);
	{
		fputs("[TOPPERS_TYPENAME] ", stderr);
		ASSERT(strcmp(TOPPERS_TYPENAME(TOPPERS_TYPENAME_test<int>), "TOPPERS_TYPENAME_test<int>") == 0);
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[syslog_tracer] ", stderr);
		toppers::syslog_tracer<> tr(LOG_NOTICE);
		using namespace toppers;

		tr << 0L << endl;
		VERIFY("0");
		tr << 1234 << endl;
		VERIFY("1234");
		tr << 5678U << endl;
		VERIFY("5678");
		tr << (short)111 << endl;
		VERIFY("111");
		tr << (unsigned short)222 << endl;
		VERIFY("222");

		tr << hex << 0x12345 << endl;
		VERIFY("12345");
		tr << showbase << 0x67890 << endl;
		VERIFY("0x67890");
		tr << oct << 012345 << endl;
		VERIFY("012345");
		tr << unshowbase << 0670123 << endl;
		VERIFY("670123");
		tr << dec << 98765 << endl;
		VERIFY("98765");

		tr << hex << showbase << uppercase << 0xabcdef << endl;
		VERIFY("0XABCDEF");
		tr << hex << showbase << lowercase << 0xabcdef << endl;
		VERIFY("0xabcdef");
		tr << dec << unshowbase;

		tr << setw(5) << setfill('0');
		tr << oct << 0123 << endl;
		VERIFY("00123");
		tr << oct << 0123456 << endl;
		VERIFY("123456");
		tr << hex << 0x123 << endl;
		VERIFY("00123");
		tr << hex << 0x123456 << endl;
		VERIFY("123456");
		tr << dec << 123 << endl;
		VERIFY("00123");
		tr << dec << 123456 << endl;
		VERIFY("123456");

		tr << showbase;
		tr << oct << 012 << endl;
		VERIFY("00012");
		tr << 012345 << endl;
		VERIFY("012345");
		tr << hex << 0x12 << endl;
		VERIFY("0x012");
		tr << 0x12345 << endl;
		VERIFY("0x12345");
		tr << unshowbase;

		tr.init();
		tr << 'A' << endl;
		VERIFY("A");
		tr << "abc" << endl;
		VERIFY("abc");
		tr << boolalpha << true << endl;
		VERIFY("true");
		tr << boolalpha << false << endl;
		VERIFY("false");
		tr << unboolalpha << true << endl;
		VERIFY("1");
		tr << unboolalpha << false << endl;
		VERIFY("0");

		tr << setw(5) << setfill('-');
		tr << 'A' << endl;
		VERIFY("----A");
		tr << "abc" << endl;
		VERIFY("--abc");
		tr << boolalpha << true << endl;
		VERIFY("-true");
		tr << boolalpha << false << endl;
		VERIFY("false");
		tr << unboolalpha << true << endl;
		VERIFY("----1");
		tr << unboolalpha << false << endl;
		VERIFY("----0");

		tr << endl;
		VERIFY("");

		tr.init();
		tr << setpri(3) << 1234 << endl;
		VERIFY("1234");

		tr << t_ctsk() << endl;
		tr << t_rtsk() << endl;
		tr << t_rtst() << endl;
		tr << t_dtex() << endl;
		tr << t_rtex() << endl;
		tr << t_csem() << endl;
		tr << t_rsem() << endl;
		tr << t_cflg() << endl;
		tr << t_rflg() << endl;
		tr << t_cdtq() << endl;
		tr << t_rdtq() << endl;
		tr << t_cmbx() << endl;
		tr << t_rmbx() << endl;
		tr << t_msg() << endl;
		tr << t_msg_pri() << endl;
		tr << t_cmtx() << endl;
		tr << t_rmtx() << endl;
		tr << t_cmbf() << endl;
		tr << t_rmbf() << endl;
		tr << t_cpor() << endl;
		tr << t_rpor() << endl;
		tr << t_rrdv() << endl;
		tr << t_cmpf() << endl;
		tr << t_rmpf() << endl;
		tr << t_cmpl() << endl;
		tr << t_rmpl() << endl;
		tr << t_ccyc() << endl;
		tr << t_rcyc() << endl;
		tr << t_calm() << endl;
		tr << t_ralm() << endl;
		tr << t_dovr() << endl;
		tr << t_rovr() << endl;
		tr << t_rsys() << endl;
		tr << t_dinh() << endl;
		tr << t_cisr() << endl;
		tr << t_risr() << endl;
		tr << t_dsvc() << endl;
		tr << t_dexc() << endl;
		tr << t_rcfg() << endl;
		tr << t_rver() << endl;

		fputs("-- ok\n", stderr);
	}
}

