/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: test_tsk.cpp,v 1.1 2004/01/16 01:38:28 takagi-n Exp $
 */
#include <toppers/task.hpp>
#include "test.hpp"

namespace {

	class body : public toppers::task_body<>
	{
		typedef	toppers::task_body<>	super;
	public:
		explicit body(VP_INT exinf) : super(exinf) {}
		void run()
		{
			tracer t;
			VP_INT exinf = get_extended_info();
			printf("exinf = %p\n", exinf);
			if (exinf != 0)
			{
				TEST_EXP(exit_and_destroy());
			}
			else
			{
				TEST_EXP(sleep());
				VERIFY0("slp_tsk");
				TEST_EXP(sleep(10));
				VERIFY1("tslp_tsk", 10);
				TEST_EXP(delay(100));
				VERIFY1("dly_tsk", 100);
				TEST_EXP(yield());
				VERIFY1("dly_tsk", 0);
			}
		}
	};

}

void test_tsk()
{
	fputs("----- test task -----\n", stderr);
	{
		fputs("[task<>] ", stderr);
		typedef	toppers::task<>	task;
		TEST_EXP(task tsk(10));
		ID tskid = get_unsafe_id(tsk);
		printf("tskid = %d\n", tskid);
		TEST_EXP(tsk.create<body>());
		VERIFY1("acre_tsk", test_params[0]);
		tskid = get_unsafe_id(tsk);
		printf("tskid = %d\n", tskid);
		task::reference pk_rtsk[1];
		TEST_EXP(tsk.refer(pk_rtsk));
		VERIFY2("ref_tsk", tskid, pk_rtsk);
		task::easy_reference pk_rtst[1];
		TEST_EXP(tsk.refer(pk_rtst));
		VERIFY2("ref_tst", tskid, pk_rtst);
		TEST_EXP(tsk.activate());
		VERIFY1("act_tsk", tskid);
		TEST_EXP(tsk.activate(toppers::non_task_context));
		VERIFY1("iact_tsk", tskid);
		set_test_context(TRUE);
		TEST_EXP(tsk.activate(toppers::context_independent));
		VERIFY1("iact_tsk", tskid);
		set_test_context(FALSE);
		TEST_EXP(tsk.activate(toppers::context_independent));
		VERIFY1("act_tsk", tskid);
		TEST_EXP(tsk.activate((VP_INT)123));
		VERIFY2("sta_tsk", tskid, 123);
		TEST_EXP(tsk.cancel_activation());
		VERIFY1("can_act", tskid);
		TEST_EXP(tsk.terminate());
		VERIFY1("ter_tsk", tskid);
		TEST_EXP(tsk.change_priority(10));
		VERIFY2("chg_pri", tskid, 10);
		PRI tskpri;
		TEST_EXP(tsk.get_priority(&tskpri));
		VERIFY2("get_pri", tskid, &tskpri);
		printf("tskpri = %d\n", tskpri);
		TEST_EXP(tsk.wakeup());
		VERIFY1("wup_tsk", tskid);
		TEST_EXP(tsk.wakeup(toppers::non_task_context));
		VERIFY1("iwup_tsk", tskid);
		set_test_context(TRUE);
		TEST_EXP(tsk.wakeup(toppers::context_independent));
		VERIFY1("iwup_tsk", tskid);
		set_test_context(FALSE);
		TEST_EXP(tsk.wakeup(toppers::context_independent));
		VERIFY1("wup_tsk", tskid);
		TEST_EXP(tsk.cancel_wakeup());
		VERIFY1("can_wup", tskid);
		TEST_EXP(tsk.release_wait());
		VERIFY1("rel_wai", tskid);
		TEST_EXP(tsk.release_wait(toppers::non_task_context));
		VERIFY1("irel_wai", tskid);
		set_test_context(TRUE);
		TEST_EXP(tsk.release_wait(toppers::context_independent));
		VERIFY1("irel_wai", tskid);
		set_test_context(FALSE);
		TEST_EXP(tsk.release_wait(toppers::context_independent));
		VERIFY1("rel_wai", tskid);
		TEST_EXP(tsk.suspend());
		VERIFY1("sus_tsk", tskid);
		TEST_EXP(tsk.resume());
		VERIFY1("rsm_tsk", tskid);
		TEST_EXP(tsk.resume(toppers::forced));
		VERIFY1("frsm_tsk", tskid);
		TEST_EXP(tsk.destroy());
		VERIFY1("del_tsk", tskid);
		printf("tskid = %d\n" , get_unsafe_id(tsk));
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[task<1>] ", stderr);
		typedef	toppers::task<1>	task;
		TEST_EXP(task tsk);
		ID tskid = get_unsafe_id(tsk);
		printf("tskid = %d\n", tskid);
		TEST_EXP(tsk.create<body>());
		VERIFY2("cre_tsk", tskid, test_params[1]);
		tskid = get_unsafe_id(tsk);
		printf("tskid = %d\n", tskid);
		task::reference pk_rtsk[1];
		TEST_EXP(tsk.refer(pk_rtsk));
		VERIFY2("ref_tsk", tskid, pk_rtsk);
		task::easy_reference pk_rtst[1];
		TEST_EXP(tsk.refer(pk_rtst));
		VERIFY2("ref_tst", tskid, pk_rtst);
		TEST_EXP(tsk.activate());
		VERIFY1("act_tsk", tskid);
		TEST_EXP(tsk.activate(toppers::non_task_context));
		VERIFY1("iact_tsk", tskid);
		set_test_context(TRUE);
		TEST_EXP(tsk.activate(toppers::context_independent));
		VERIFY1("iact_tsk", tskid);
		set_test_context(FALSE);
		TEST_EXP(tsk.activate(toppers::context_independent));
		VERIFY1("act_tsk", tskid);
		TEST_EXP(tsk.activate((VP_INT)123));
		VERIFY2("sta_tsk", tskid, 123);
		TEST_EXP(tsk.cancel_activation());
		VERIFY1("can_act", tskid);
		TEST_EXP(tsk.terminate());
		VERIFY1("ter_tsk", tskid);
		TEST_EXP(tsk.change_priority(10));
		VERIFY2("chg_pri", tskid, 10);
		PRI tskpri;
		TEST_EXP(tsk.get_priority(&tskpri));
		VERIFY2("get_pri", tskid, &tskpri);
		printf("tskpri = %d\n", tskpri);
		TEST_EXP(tsk.wakeup());
		VERIFY1("wup_tsk", tskid);
		TEST_EXP(tsk.wakeup(toppers::non_task_context));
		VERIFY1("iwup_tsk", tskid);
		set_test_context(TRUE);
		TEST_EXP(tsk.wakeup(toppers::context_independent));
		VERIFY1("iwup_tsk", tskid);
		set_test_context(FALSE);
		TEST_EXP(tsk.wakeup(toppers::context_independent));
		VERIFY1("wup_tsk", tskid);
		TEST_EXP(tsk.cancel_wakeup());
		VERIFY1("can_wup", tskid);
		TEST_EXP(tsk.release_wait());
		VERIFY1("rel_wai", tskid);
		TEST_EXP(tsk.release_wait(toppers::non_task_context));
		VERIFY1("irel_wai", tskid);
		set_test_context(TRUE);
		TEST_EXP(tsk.release_wait(toppers::context_independent));
		VERIFY1("irel_wai", tskid);
		set_test_context(FALSE);
		TEST_EXP(tsk.release_wait(toppers::context_independent));
		VERIFY1("rel_wai", tskid);
		TEST_EXP(tsk.suspend());
		VERIFY1("sus_tsk", tskid);
		TEST_EXP(tsk.resume());
		VERIFY1("rsm_tsk", tskid);
		TEST_EXP(tsk.resume(toppers::forced));
		VERIFY1("frsm_tsk", tskid);
		TEST_EXP(tsk.destroy());
		VERIFY1("del_tsk", tskid);
		printf("tskid = %d\n" , get_unsafe_id(tsk));
		fputs("-- ok\n", stderr);
	}
	{
		fputs("[task body] ", stderr);
		set_test_context(FALSE);
		toppers::task_entry<body>((VP_INT)(1));
		toppers::task_entry<body>((VP_INT)(0));
		fputs("-- ok\n", stderr);
	}
}

