/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: alarmhandler.hpp,v 1.3 2004/01/26 00:53:45 takagi-n Exp $
 */

/**
 *	@file	toppers/alarmhandler.hpp
 *	@brief	顼ϥɥ椹륯饹
 *
 *	 ΥإåեǤϰʲΥƥץ졼ȥ饹ӥƥץ졼ȴؿƤ롣
 *
 *	@code
 *	class alarmhandler<Id, Diagnostics, Stub>;
 *	class alarmhandler_body<Diagnostics, Stub>;
 *	void alarmhandler_entry<Body>(VP_INT);
 *	@endcode
 */

#ifndef	TOPPERS_ALARMHANDLER_HPP_
#define	TOPPERS_ALARMHANDLER_HPP_

#include <toppers/context.hpp>

namespace toppers
{

	template <class Body> void alarmhandler_entry(VP_INT);

	template <class Diagnostics, class Stub> class alarmhandler_body;

	/**
	 *	@class	alarmhandler alarmhandler.hpp <toppers/alarmhandler.hpp>
	 *	@brief	顼ϥɥ鵡ǽ򥫥ץ벽ƥץ졼ȥ饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 @e alaramhandler ƥץ졼ȥ饹ϥ顼ϥɥФ򥫥ץ벽Ƥ롣\n
	 *	@e task Ʊ͡ϥɥν@e alaramhandler_body ƥץ졼ȥ饹饹Ȥ
	 *	Ҥɬפ롣
	 *
	 *	@see	alarmhandler_body
	 */
	template <	ID Id			= 0,
				class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB >
	class alarmhandler : Diagnostics
	{
		typedef	object_controller<Id, obj_alarmhandler, Stub>	controller;
		object_id<Id> objid_;

	public:
		///	ѥåȷ
		typedef	typename controller::creation	creation;
		///	ֻȾѥåȷ
		typedef	typename controller::reference	reference;
		///	ܥǥ饹
		typedef	alarmhandler_body<Diagnostics, Stub>	body;

		/**	@name	󥹥ȥ饯	*/
		//@{

		///	ǥեȥ󥹥ȥ饯
		alarmhandler() {}
		///	IDֹΥ󥹥ȥ饯
		explicit alarmhandler(ID id) : objid_(id) {}

		///	ƥץ졼Ȱ㤤Ѵ󥹥ȥ饯
		template <ID Id2, class Diagnostics2, class Stub2>
		alarmhandler(const alarmhandler<Id2, Diagnostics2, Stub2>& other)
			: objid_(get_unsafe_id(other))
		{
			TOPPERS_STATIC_ASSERT(Id == 0);
		}
		//@}

		/**	@name	Ⱥ	*/
		//@{

		//	ߴΤ¿
		ER create(creation* pk_cobj)
		{
			ER ercd = controller::create(objid_, pk_cobj);
			return handle_error(ercd);
		}
		///	顼ϥɥ
		ER create(const creation* pk_cobj)
		{
			ER ercd = controller::create(objid_, pk_cobj);
			return handle_error(ercd);
		}
		///	顼ϥɥʸ̤Υեɻ
		ER create(ATR almatr, VP_INT exinf, void (*almhdr)(VP_INT))
		{
			creation packet;
			packet.almatr = almatr;
			packet.exinf  = exinf;
			packet.almhdr = FP(almhdr);
			return create(&packet);
		}
		///	顼ϥɥʥܥǥ
		template <class Body>
		ER create(ATR almatr = 0, VP_INT exinf = 0)
		{
			return create(almatr & ~TA_ASM | TA_HLNG, exinf, &alarmhandler_entry<Body>);
		}
		///	顼ϥɥκ
		ER destroy()
		{
			ER ercd = controller::destroy(objid_);
			return handle_error(ercd);
		}

		//@}

		/**	@name	ֻ	*/
		//@{

		///	顼ϥɥξֻ
		ER refer(reference* pk_robj) const
		{
			ER ercd = controller::refer(objid_, pk_robj);
			return handle_error(ercd);
		}

		//@}

		/**	@name	ư	*/
		//@{

		///	顼ϥɥεư
		ER start(RELTIM almtim) const
		{
			ER ercd = Stub::stub_sta_alm(objid_.id(), almtim);
			return handle_error(ercd);
		}
		///	顼ϥɥ
		ER stop() const
		{
			ER ercd = Stub::stub_stp_alm(objid_.id());
			return handle_error(ercd);
		}

		//@}

		///	顼ϥɥIDֹμ
		friend ID get_unsafe_id(const alarmhandler<Id, Diagnostics, Stub>& alarmhandler)
		{
			return alarmhandler.objid_.id();
		}
	};

	/**
	 *	@class	alarmhandler_body alarmhandler.hpp <toppers/alarmhandler.hpp>
	 *	@brief	顼ϥɥư쥯饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 顼ϥɥ硢@e alarmhandler_body ƥץ졼ȥ饹 public
	 *	Ѿ饹η@e alarmhandler_entry ƥץ졼ȴؿΥƥץ졼
	 *	Ϥ
	 *
	 *	@see	alarmhandler alarmhandler_entry
	 */
	template <	class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB >
	class alarmhandler_body : public non_task_context_body<Diagnostics, Stub>
	{
		VP_INT exinf_;

	protected:
		///	ǥȥ饯
		~alarmhandler_body() {}

	public:
		///	󥹥ȥ饯
		explicit alarmhandler_body(VP_INT exinf) : exinf_(exinf) {}

		///	ĥμ
		VP_INT get_extended_info() const { return exinf_; }
	};

	/**
	 *	@brief	顼ϥɥΥƥץ졼
	 *	@see	alarmhandler_body
	 *	@ingroup	KernelObjectManager
	 *
	 *	 ƥץ졼Ȱ@e Body Ȥƻꤷܥǥ饹ΤȤ륢顼ϥɥ롣
	 *	δؿ@e T_CALM ¤Τ@e almhdr եɤꤹ뤳ȤǤ롣
	 *
	 *	@attention	@e CRE_ALM Ū API ˤФƻѤϡC󥱡δؿǰöåԥ󥰤뤳ȡ
	 */
	template <class Body>
	inline void alarmhandler_entry(VP_INT exinf)
	{
		Body body(exinf);
		body.run();
	}

}

#endif	// ! TOPPERS_ALARMHANDLER_HPP_
