/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: assert.hpp,v 1.3 2004/01/26 00:53:45 takagi-n Exp $
 */

/**
 *	@file	toppers/assert.hpp
 *	@brief	ǽΤΥޥ
 *
 *	 ΥإåեǤϰʲΥޥƤ롣
 *
 *	@code
 *	TOPPERS_ASSERT(expr);
 *	TOPPERS_STATIC_ASSERT(expr);
 *	@endcode
 */

#ifndef	TOPPERS_ASSERT_HPP_
#define	TOPPERS_ASSERT_HPP_

#include <toppers/config.hpp>

#define TOPPERS_JOIN(a, b)    TOPPERS_JOIN_(a, b)
#define TOPPERS_JOIN_(a, b)   a ## b

#define TOPPERS_STRINGIFY(a)  TOPPERS_STRINGIFY_(a)
#define TOPPERS_STRINGIFY_(a) # a

namespace toppers
{

	template <bool> struct static_assertion
	{
		enum { okay = 1 };
	};

	template <> struct static_assertion<false> {};

	namespace detail
	{
		int assertion_failed(const char* expr, const char* file, int line) throw();
	}

}

/**
 *	@def	TOPPERS_ASSERT(expr)
 *	@brief	¹Ի
 *	@ingroup	Diagnostics
 *	@param	expr	ɾоݤμ
 *
 *	 ɸ饤֥@e assert ƱƱñǺ뤳ȤϤǤʤ\n
 *	 TOPPERSͥ롢ޤNEWLIB@e assert 򥵥ݡȤ饤֥Ѥϡñ@e assert ִ롣
 *	@e assert ݡȤʤĶξ硢@e toppers::detail::assertion_failed ؿĶ˹碌Ƽɬפ롣
 *
 *	@code
 *	int toppers::detail::assertion_failed(const char* expr, const char* file, int line) throw();
 *	@endcode
 *
 *	 @e expr , @e file , @e line ϡ줾ɾʸ󡢥ե̾ʸ󡢹ֹǤ롣ֵͤϲǤ褤
 *
 *	@attention	ɸ饤֥꤬@e assert 򥵥ݡȤƤϡtoppers/assert.hpp ˥󥯥롼ɤɬפ롣
 */
#if	TKERNEL_MAKER == 0x0118 || defined(assert)
#define	TOPPERS_ASSERT			assert
#elif	!defined(NDEBUG)
#define	TOPPERS_ASSERT(expr)	((void)((expr) ? 0 : ::toppers::detail::assertion_failed(#expr, __FILE__, __LINE__)))
#else
#define	TOPPERS_ASSERT(expr)	((void)0)
#endif

/**
 *	@brief	Ū
 *	@ingroup	Diagnostics
 *	@param	expr:	ɾоݤ
 *
 *	 @e expr ǻꤷɾϲⵯʤɾ줿ϥѥ륨顼
 *	ѥ륨顼ȯΥåϥѥˤäưۤʤ뤬GCC 3.xξϰʲΤ褦ʥåϤ롣
 *
 *	@code
 *	ե̾:ֹ: error: `okay' is not a member of type `toppers::static_assertion<false>'
 *	@endcode
 */
#define TOPPERS_STATIC_ASSERT(expr)	typedef int TOPPERS_JOIN(toppers_diagnostics_, __LINE__)[toppers::static_assertion<!!(expr)>::okay]

#endif	// ! TOPPERS_ASSERT_HPP_
