/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: context.hpp,v 1.3 2004/01/26 00:53:45 takagi-n Exp $
 */

/**
 *	@file	toppers/context.hpp
 *	@brief	󥿥ƥȤư˴ؤ
 *
 *	 ΥإåեǤϰʲΥƥץ졼ȥ饹ӥޥƤ롣
 *
 *	@code
 *	class task_context_body<Diagnostics, Stub>;
 *	class non_task_context_body<Diagnostics, Stub>;
 *	TOPPERS_BIND_HANDLER(func);
 *	@endcode
 */

#ifndef	TOPPERS_CONTEXT_HPP_
#define	TOPPERS_CONTEXT_HPP_

#include <toppers/object.hpp>

namespace toppers
{

	/**
	 *	@class	task_context_body context.hpp <toppers/context.hpp>
	 *	@brief	ƥȤѴ쥯饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 @e task_context_body ƥץ졼ȥ饹ϡƥѥܥǥ饹δ쥯饹ȤƻѤ롣\n
	 *	 ƥȤˤơФϤΥ饹ǥץ벽Ƥ롣
	 *	@e task_context_body ƥץ졼ȥ饹饹Ǥϡ@e context_independent 
	 *	@e task_context ƱǤꡢ󥿥åѲ뤿˻Ѥ뤳ȤǤ롣
	 *
	 *	@see	non_task_context_body
	 */
	template <class Diagnostics, class Stub>
	class task_context_body : protected Diagnostics
	{
		VP_INT exinf_;

	public:
		///	ưμ¹
		void run() {}

		///	γĥλ
		VP_INT get_extended_info() const { return exinf_; }

		///	εԤ
		static ER sleep(forever_tag = forever)
		{
			ER ercd = Stub::stub_slp_tsk();
			return handle_error(ercd);
		}
		///	εԤʥॢȻ
		static ER sleep(TMO tmout)
		{
			ER ercd = Stub::stub_tslp_tsk(tmout);
			return handle_error(ercd);
		}

		///	ٱ
		static ER delay(RELTIM dlytim)
		{
			ER ercd = Stub::stub_dly_tsk(dlytim);
			return handle_error(ercd);
		}

		///	ڤؤ
		static ER yield()
		{
			ER ercd = Stub::stub_dly_tsk(0);
			return handle_error(ercd);
		}

		///	ƥȤꤹ
		static const task_context_tag		task_context		= toppers::task_context;
		///	󥿥ƥȤꤹ
		static const non_task_context_tag	non_task_context	= toppers::non_task_context;
		///	ߤΥƥȡʤʤƥȡˤꤹ
		static const task_context_tag		context_independent	= toppers::task_context;

	protected:
		///	ӥ륹
		typedef	Stub	stub;

		///	󥹥ȥ饯
		task_context_body(VP_INT exinf) : exinf_(exinf) {}
		///	ǥȥ饯
		~task_context_body() {}

		///	¹ΥIDֹ򻲾Ȥ
		static ID get_task_id()
		{
			ID tskid;
			Stub::stub_get_tid(&tskid);
			return tskid;
		}

	private:
		task_context_body(const task_context_body<Diagnostics, Stub>&);
		task_context_body<Diagnostics, Stub>& operator=(const task_context_body<Diagnostics, Stub>&);

		static ER sleep(polling_tag);
	};

	/**
	 *	@class	non_task_context_body context.hpp <toppers/context.hpp>
	 *	@brief	󥿥ƥȤΥϥɥѴ쥯饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 @e non_task_context_body ƥץ졼ȥ饹ϡ󥿥ƥѥܥǥ饹δ쥯饹ȤƻѤ롣\n
	 *	 @e non_task_context_body ƥץ졼ȥ饹饹Ǥϡ@e context_independent 
	 *	@e non_task_context ƱǤꡢ󥿥åѲ뤿˻Ѥ뤳ȤǤ롣
	 *
	 *	@see	task_context_body
	 */
	template <class Diagnostics, class Stub>
	class non_task_context_body : protected Diagnostics
	{
		TOPPERS_STATIC_ASSERT(!Diagnostics::use_exception);

	public:
		///	ϥɥưμ¹
		void run();

		///	ƥȤꤹ
		static const task_context_tag		task_context		= toppers::task_context;
		///	󥿥ƥȤꤹ
		static const non_task_context_tag	non_task_context	= toppers::non_task_context;
		///	ߤΥƥȡʤʤ󥿥ƥȡˤꤹ
		static const non_task_context_tag	context_independent	= toppers::non_task_context;

	protected:
		///	ӥ륹
		typedef	Stub	stub;

		///	󥹥ȥ饯
		non_task_context_body() {}
		///	ǥȥ饯
		~non_task_context_body() {}

		///	¹ΥIDֹ򻲾Ȥ
		static ID get_task_id()
		{
			ID tskid;
			Stub::stub_iget_tid(&tskid);
			return tskid;
		}

	private:
		non_task_context_body(const non_task_context_body<Diagnostics, Stub>&);
		non_task_context_body<Diagnostics, Stub>& operator=(const non_task_context_body<Diagnostics, Stub>&);
	};

	namespace detail
	{

		template <typename Func, Func Routine, typename R, typename T>
		inline void (*bind_context_handler(R (*func)(T)))(VP_INT)
		{
			struct _
			{
				static void handler(VP_INT exinf)
				{
					(*(R(*)(T))Routine)(T(exinf));
				}
			};
			return &_::handler;
		}

	}

/**
 *	@brief	ǤշδؿΥϥɥؿؤηӤĤ
 *	@ingroup	KernelObjectManager
 *	@param	func	ؿؤΥݥ󥿡ʳؿϻԲġ
 *	@return	ϥɥؤΥݥ
 *
 *	 ΰۤʤؿ@e VP_INT γĥϥɥؿ˷ӤĤ롣
 *	ӤĤ뤳ȤǤؿϡ顼ޤ@e VP_INT Ѵ󥹥ȥ饯
 *	ĥ饹ͣΰȤؿǤʤФʤʤ
 *
 *	@include	bind_handler.cpp
 *	@todo	ΥСǤϲǽʸ¤GCCʳΥѥˤб롣
 */
#define	TOPPERS_BIND_HANDLER(func)	::toppers::detail::bind_context_handler<__typeof__(&(func)), &(func)>(&(func))

}

#endif	// ! TOPPERS_CONTEXT_HPP_
