/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: cpuexception.hpp,v 1.3 2004/01/26 00:53:45 takagi-n Exp $
 */

/**
 *	@file	toppers/cpuexception.hpp
 *	@brief	CPU㳰ϥɥ椹륯饹
 *
 *	 ΥإåեǤϰʲΥƥץ졼ȥ饹ӥƥץ졼ȴؿƤ롣
 *
 *	@code
 *	class cpuexception<Diagnostics, Stub>;
 *	class cpuexception_body<Diagnostics, Stub>;
 *	void cpuexception_entry<Body>(VP);
 *	@endcode
 */

#ifndef	TOPPERS_CPUEXCEPTION_HPP_
#define	TOPPERS_CPUEXCEPTION_HPP_

#include <toppers/context.hpp>
#include <toppers/kernelstatus.hpp>

namespace toppers
{

	template <class Body> void cpuexception_entry();

	template <class Diagnostics, class Stub> class cpuexception_body;

	/**
	 *	@class	cpuexception cpuexception.hpp <toppers/cpuexception.hpp>
	 *	@brief	CPU㳰εǽ򥫥ץ벽ƥץ졼ȥ饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 @e cpuexception ƥץ졼ȥ饹CPU㳰Ф򥫥ץ벽Ƥ롣\n
	 *	@e task Ʊ͡ϥɥν@e cpuexception_body ƥץ졼ȥ饹饹Ȥ
	 *	Ҥɬפ롣
	 *
	 *	@see	cpuexception_body
	 */
	template <	class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB >
	class cpuexception : Diagnostics
	{
	public:
		///	ѥåȷ
		typedef	t_dexc	definition;
		///	ܥǥ饹
		typedef	cpuexception_body<Diagnostics, Stub>	body;

		//	ߴΤ¿
		static ER define(EXCNO excno, definition* pk_dobj)
		{
			ER ercd = Stub::stub_def_exc(excno, pk_dobj);
			return static_handle_error(ercd);
		}
		///	CPU㳰ϥɥ
		static ER define(EXCNO excno, const definition* pk_dobj)
		{
			ER ercd = Stub::stub_def_exc(excno, pk_dobj);
			return static_handle_error(ercd);
		}
		///	CPU㳰ϥɥʸ̤Υեɻ
		static ER define(EXCNO excno, ATR excatr, void (*exchdr)(VP))
		{
			t_dexc packet;
			packet.excatr = excatr;
			packet.exchdr = FP(exchdr);
			return define(excno, &packet);
		}
		///	CPU㳰ϥɥʥܥǥ
		template <class Body>
		static ER define(EXCNO excno, ATR excatr = 0)
		{
			return define(excno, excatr, &cpuexception_entry<Body>);
		}
		///	CPU㳰ϥɥä
		static ER undefine(EXCNO excno)
		{
			return define(excno, static_cast<definition*>(0));
		}
	};

	/**
	 *	@class	cpuexception_body cpuexception.hpp <toppers/cpuexception.hpp>
	 *	@brief	CPU㳰ϥɥư쥯饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	  CPU㳰ϥɥ硢@e cpuexception_body ƥץ졼ȥ饹 public
	 *	Ѿ饹η @e cpuexception_entry ƥץ졼ȴؿΥƥץ졼
	 *	Ϥ
	 *
	 *	@see	cpuexception cpuexception_entry
	 */
	template <	class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB >
	class cpuexception_body
#if	TKERNEL_MAKER == 0x0118
		: public non_task_context_body<Diagnostics, Stub>
#endif
	{
		TOPPERS_STATIC_ASSERT(!Diagnostics::use_exception);
		VP_INT exinf_;

	protected:
		///	ǥȥ饯
		~cpuexception_body() {}

	public:
		///	󥹥ȥ饯
		explicit cpuexception_body(VP_INT exinf) : exinf_(exinf) {}

		///	CPU㳰ȯΥƥȤλ
		static bool sense_context(VP_INT exinf)
		{
			return Stub::stub_vxsns_ctx(VP(exinf));
		}

		///	CPU㳰ȯCPUå֤λ
		static bool sense_cpulock(VP_INT exinf)
		{
			return Stub::stub_vxsns_loc(VP(exinf));
		}

		///	CPU㳰ȯΥǥѥåػ߾֤λ
		static bool sense_dispatch(VP_INT exinf)
		{
			return Stub::stub_vxsns_dsp(VP(exinf));
		}

		///	CPU㳰ȯΥǥѥåڥǥ󥰾֤λ
		static bool sense_dispatch_pending(VP_INT exinf)
		{
			return Stub::stub_vxsns_dpn(VP(exinf));
		}

		///	CPU㳰ȯΥ㳰ػ߾֤λ
		static bool sense_taskexception(VP_INT exinf)
		{
			return Stub::stub_vxsns_tex(VP(exinf));
		}

		///	ĥλ
		VP_INT get_extended_info() const { return exinf_; }
	};

	/**
	 *	@brief	CPU㳰ϥɥΥƥץ졼
	 *	@see	cpuexception_body
	 *	@ingroup	KernelObjectManager
	 *
	 *	 ƥץ졼Ȱ@e Body Ȥƻꤷܥǥ饹ΤȤ CPU㳰ϥɥ롣
	 *	δؿ@e T_DEXC ¤Τ@e exchdr եɤꤹ뤳ȤǤ롣
	 *
	 *	@attention	@e DEF_EXC Ū API ˤФƻѤϡC󥱡δؿǰöåԥ󥰤뤳ȡ
	 */
	template <class Body>
	inline void cpuexception_entry(VP p_exinf)
	{
		Body body((VP_INT)p_exinf);
		body.run();
	}

}

#endif	// ! TOPPERS_CPUEXCEPTION_HPP_
