/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: cyclichandler.hpp,v 1.3 2004/01/26 00:53:45 takagi-n Exp $
 */

/**
 *	@file	toppers/cyclichandler.hpp
 *	@brief	ϥɥ椹륯饹
 *
 *	 ΥإåեǤϰʲΥƥץ졼ȥ饹ӥƥץ졼ȴؿƤ롣
 *
 *	@code
 *	class cyclichandler<Id, Diagnostics, Stub>;
 *	class cyclichandler_body<Diagnostics, Stub>;
 *	void cyclichandler_entry<Body>(VP_INT);
 *	@endcode
 */

#ifndef	TOPPERS_CYCLICHANDLER_HPP_
#define	TOPPERS_CYCLICHANDLER_HPP_

#include <toppers/context.hpp>

namespace toppers
{

	template <class Body> void cyclichandler_entry(VP_INT);

	template <class Diagnostics, class Stub> class cyclichandler_body;

	/**
	 *	@class	cyclichandler cyclichandler.hpp <toppers/cyclichandler.hpp>
	 *	@brief	ϥɥεǽ򥫥ץ벽ƥץ졼ȥ饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 @e cyclichandler ƥץ졼ȥ饹ϼϥɥФ򥫥ץ벽Ƥ롣\n
	 *	@e task Ʊ͡ϥɥν@e cyclichandler_body ƥץ졼ȥ饹饹Ȥ
	 *	Ҥɬפ롣
	 *
	 *	@see	cyclichandler_body
	 */
	template <	ID Id			= 0,
				class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB >
	class cyclichandler : Diagnostics
	{
		typedef	object_controller<Id, obj_cyclichandler, Stub>	controller;
		object_id<Id> objid_;

	public:
		///	ѥåȷ
		typedef	typename controller::creation	creation;
		///	ֻȾѥåȷ
		typedef	typename controller::reference	reference;
		///	ܥǥ饹
		typedef	cyclichandler_body<Diagnostics, Stub>	body;

		/**	@name	󥹥ȥ饯	*/
		//@{

		///	ǥեȥ󥹥ȥ饯
		cyclichandler() {}
		///	IDֹΥ󥹥ȥ饯
		explicit cyclichandler(ID id) : objid_(id) {}

		///	ƥץ졼Ȱ㤤Ѵ󥹥ȥ饯
		template <ID Id2, class Diagnostics2, class Stub2>
		cyclichandler(const cyclichandler<Id2, Diagnostics2, Stub2>& other)
			: objid_(get_unsafe_id(other))
		{
			TOPPERS_STATIC_ASSERT(Id == 0);
		}

		//@}

		/**	@name	Ⱥ	*/
		//@{

		//	ߴΤ¿
		ER create(creation* pk_cobj)
		{
			ER ercd = controller::create(objid_, pk_cobj);
			return handle_error(ercd);
		}
		///	ϥɥ
		ER create(const creation* pk_cobj)
		{
			ER ercd = controller::create(objid_, pk_cobj);
			return handle_error(ercd);
		}
		///	ϥɥʸ̤Υեɻ
		ER create(ATR cycatr, VP_INT exinf, void (*cychdr)(VP_INT), RELTIM cyctim = 1, RELTIM cycphs = 0)
		{
			creation packet;
			packet.cycatr = cycatr;
			packet.exinf  = exinf;
			packet.cychdr = FP(cychdr);
			packet.cyctim = cyctim;
			packet.cycphs = cycphs;
			return create(&packet);
		}
		///	ϥɥʥܥǥ
		template <class Body>
		ER create(ATR cycatr = TA_STA, VP_INT exinf = 0, RELTIM cyctim = 1, RELTIM cycphs = 0)
		{
			return create(cycatr & ~TA_ASM | TA_HLNG, exinf, &cyclichandler_entry<Body>, cyctim, cycphs);
		}
		///	ϥɥκ
		ER destroy()
		{
			ER ercd = controller::destroy(objid_);
			return handle_error(ercd);
		}

		//@}

		/**	@name	ֻ	*/
		//@{

		///	ϥɥξֻ
		ER refer(reference* pk_robj) const
		{
			ER ercd = controller::refer(objid_, pk_robj);
			return handle_error(ercd);
		}

		//@}

		/**	@name	ư	*/
		//@{

		///	ϥɥεư
		ER start() const
		{
			ER ercd = Stub::stub_sta_cyc(objid_.id());
			return handle_error(ercd);
		}
		///	ϥɥ
		ER stop() const
		{
			ER ercd = Stub::stub_stp_cyc(objid_.id());
			return handle_error(ercd);
		}

		//@}

		///	ϥɥIDֹμ
		friend ID get_unsafe_id(const cyclichandler<Id, Diagnostics, Stub>& cyclichandler)
		{
			return cyclichandler.objid_.id();
		}
	};

	/**
	 *	@class	cyclichandler_body cyclichandler.hpp <toppers/cyclichandler.hpp>
	 *	@brief	ϥɥư쥯饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 ϥɥ硢@e cyclichandler_body ƥץ졼ȥ饹 public
	 *	Ѿ饹η@e cyclichandler_entry ƥץ졼ȴؿΥƥץ졼
	 *	Ϥ
	 *
	 *	@see	cyclichandler cyclichandler_entry
	 */
	template <	class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB >
	class cyclichandler_body : public non_task_context_body<Diagnostics, Stub>
	{
		VP_INT exinf_;

	protected:
		///	ǥȥ饯
		~cyclichandler_body() {}

	public:
		///	󥹥ȥ饯
		explicit cyclichandler_body(VP_INT exinf) : exinf_(exinf) {}

		///	ĥμ
		VP_INT get_extended_info() const { return exinf_; }
	};


	/**
	 *	@brief	ϥɥΥƥץ졼
	 *	@ingroup	KernelObjectManager
	 *
	 *	 ƥץ졼Ȱ@e Body Ȥƻꤷܥǥ饹ΤȤϥɥ롣
	 *	δؿ@e T_CCYC ¤Τ@e cychdr եɤꤹ뤳ȤǤ롣
	 *
	 *	@attention	@e CRE_CYC Ū API ˤФƻѤϡC󥱡δؿǰöåԥ󥰤뤳ȡ
	 *	@see	cyclichandler_body
	 */
	template <class Body>
	inline void cyclichandler_entry(VP_INT exinf)
	{
		Body body(exinf);
		body.run();
	}

}

#endif	// ! TOPPERS_CYCLICHANDLER_HPP_
