/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: dataqueue.hpp,v 1.3 2004/01/26 00:53:45 takagi-n Exp $
 */

/**
 *	@file	toppers/dataqueue.hpp
 *	@brief	ǡ塼椹륯饹
 *
 *	 ΥإåեǤϰʲΥƥץ졼ȥ饹Ƥ롣
 *
 *	@code
 *	class dataqueue<Id, Diagnostics, Stub>;
 *	@endcode
 */

#ifndef	TOPPERS_DATAQUEUE_HPP_
#define	TOPPERS_DATAQUEUE_HPP_

#include <toppers/object.hpp>

namespace toppers
{

	/**
	 *	@class	dataqueue dataqueue.hpp <toppers/dataqueue.hpp>
	 *	@brief	ǡ塼εǽ򥫥ץ벽ƥץ졼ȥ饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 @e dataqueue ƥץ졼ȥ饹ϡǡ塼εǽ򥫥ץ벽
	 *	ƥȤԵˡѥ᡼뤿Υ󥿥ե󶡤롣
	 */
	template <	ID Id			= 0,
				class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB	>
	class dataqueue : Diagnostics
	{
		typedef	object_controller<Id, obj_dataqueue, Stub>	controller;
		object_id<Id> objid_;

	public:
		///	ѥåȷ
		typedef	typename controller::creation	creation;
		///	ֻȾѥåȷ
		typedef	typename controller::reference	reference;

		/**	@name	󥹥ȥ饯	*/
		//@{

		///	ǥեȥ󥹥ȥ饯
		dataqueue() {}
		///	IDֹΥ󥹥ȥ饯
		explicit dataqueue(ID id) : objid_(id) {}

		///	ƥץ졼Ȱ㤤Ѵ󥹥ȥ饯
		template <ID Id2, class Diagnostics2, class Stub2>
		dataqueue(const dataqueue<Id2, Diagnostics2, Stub2>& other)
			: objid_(get_unsafe_id(other))
		{
			TOPPERS_STATIC_ASSERT(Id == 0);
		}

		//@}

		/**	@name	Ⱥ	*/
		//@{

		//	ߴΤ¿
		ER create(creation* pk_cobj)
		{
			ER ercd = controller::create(objid_, pk_cobj);
			return handle_error(ercd);
		}
		///	ǡ塼
		ER create(const creation* pk_cobj)
		{
			ER ercd = controller::create(objid_, pk_cobj);
			return handle_error(ercd);
		}
		///	ǡ塼ʸ̤Υեɻ
		ER create(ATR dtqatr = TA_TFIFO, UINT dtqcnt = 0, VP dtq = 0)
		{
			creation packet;
			packet.dtqatr;
			packet.dtqcnt;
			packet.dtq;
			return create(&packet);
		}
		///	ǡ塼κ
		ER destroy()
		{
			ER ercd = controller::destroy(objid_);
			return handle_error(ercd);
		}

		//@}

		/**	@name	ֻ	*/
		//@{

		///	ǡ塼ξֻ
		ER refer(reference* pk_robj) const
		{
			ER ercd = controller::refer(objid_, pk_robj);
			return handle_error(ercd);
		}

		//@}

		/**	@name	ǡ	*/
		//@{

		///	ǡ塼ؤ
		ER send(VP_INT data, forever_tag = forever, task_context_tag = task_context) const
		{
			ER ercd = Stub::stub_snd_dtq(objid_.id(), data);
			return handle_error(ercd);
		}
		///	ǡ塼ؤʥݡ󥰡
		ER send(VP_INT data, polling_tag, task_context_tag = task_context) const
		{
			ER ercd = Stub::stub_psnd_dtq(objid_.id(), data);
			return handle_error(ercd);
		}
		///	ǡ塼ؤʥॢȻ
		ER send(VP_INT data, TMO tmout, task_context_tag = task_context) const
		{
			ER ercd = Stub::stub_tsnd_dtq(objid_.id(), data, tmout);
			return handle_error(ercd);
		}
		///	ǡ塼ؤζ
		ER send(VP_INT data, forced_tag, task_context_tag = task_context) const
		{
			ER ercd = Stub::stub_fsnd_dtq(objid_.id(), data);
			return handle_error(ercd);
		}
		///	ǡ塼ؤʥݡ/󥿥ƥȡ
		ER send(VP_INT data, polling_tag, non_task_context_tag) const
		{
			ER ercd = Stub::stub_ipsnd_dtq(objid_.id(), data);
			return handle_error(ercd);
		}
		///	ǡ塼ؤζ󥿥ƥȡ
		ER send(VP_INT data, forced_tag, non_task_context_tag) const
		{
			ER ercd = Stub::stub_ifsnd_dtq(objid_.id(), data);
			return handle_error(ercd);
		}
		///	ǡ塼ؤʥݡ/ƥ¸
		ER send(VP_INT data, polling_tag, context_independent_tag) const
		{
			ER ercd;
			if (Stub::stub_sns_ctx())
				ercd = Stub::stub_ipsnd_dtq(objid_.id(), data);
			else
				ercd = Stub::stub_psnd_dtq(objid_.id(), data);
			return handle_error(ercd);
		}
		///	ǡ塼ؤζʥƥ¸
		ER send(VP_INT data, forced_tag, context_independent_tag) const
		{
			ER ercd;
			if (Stub::stub_sns_ctx())
				ercd = Stub::stub_ifsnd_dtq(objid_.id(), data);
			else
				ercd = Stub::stub_fsnd_dtq(objid_.id(), data);
			return handle_error(ercd);
		}

		///	ǡ塼μ
		ER receive(VP_INT* p_data, forever_tag = forever) const
		{
			ER ercd = Stub::stub_rcv_dtq(objid_.id(), p_data);
			return handle_error(ercd);
		}
		///	ǡ塼μʥݡ󥰡
		ER receive(VP_INT* p_data, polling_tag) const
		{
			ER ercd = Stub::stub_prcv_dtq(objid_.id(), p_data);
			return handle_error(ercd);
		}
		///	ǡ塼μʥॢȻ
		ER receive(VP_INT* p_data, TMO tmout) const
		{
			ER ercd = Stub::stub_trcv_dtq(objid_.id(), p_data, tmout);
			return handle_error(ercd);
		}

		//@}

		///	ǡ塼IDֹμ
		friend ID get_unsafe_id(const dataqueue<Id, Diagnostics, Stub>& dataqueue)
		{
			return dataqueue.objid_.id();
		}
	};

}

#endif	// ! TOPPERS_DATAQUEUE_HPP_
