/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: diagnostics.hpp,v 1.3 2004/01/26 00:53:45 takagi-n Exp $
 */

/**
 *	@file	toppers/diagnostics.hpp
 *	@brief	ץǥ饹
 *
 *	 ΥإåեǤϰʲΥƥץ졼ȥ饹Ƥ롣
 *
 *	@code
 *	class null_diagnostics;
 *	class error_handler_diagnostics<T>;
 *	class polymorphic_diagnostics<T>;
 *	@endcode
 */

#ifndef	TOPPERS_DIAGNOSTICS_HPP_
#define	TOPPERS_DIAGNOSTICS_HPP_

#include <toppers/kernel.hpp>
#include <toppers/assert.hpp>
#include <cstdlib>

#ifndef	TOPPERS_DEFAULT_DIAGNOSTICS
#define	TOPPERS_DEFAULT_DIAGNOSTICS	null_diagnostics
#endif

namespace toppers
{

	/**
	 *	@class	null_diagnostics diagnostics.hpp <toppers/diagnostics.hpp>
	 *	@brief	ä˲Ԥʤǥ饹
	 *	@ingroup	Diagnostics
	 *
	 *	 @e null_diagnostics 饹϶ŪʿǤ򲿤Ԥʤ
	 *	Υ饹ܥ饤֥¿Υƥץ졼ȥ饹ɬפȤ
	 *	@e Diagnostics ƥץ졼ȰΥǥեȥݥꥷȤƻѤ롣
	 *	 @e null_diagnostics ΥдؿΤ@e panic ϡ㳰Ū˺Ѥ
	 *	ץ۾ｪλ롣
	 */
	class null_diagnostics
	{
	public:
		enum
		{
			///	null_diagnostics 饹㳰ѤʤȤ򼨤
			use_exception = false
		};

		///	ŪдؿǤΥ顼
		static ER_UINT handle_error(ER_UINT ercd)
		{
			return ercd;
		}

		///	ŪдؿǤΥ顼
		static ER_UINT static_handle_error(ER_UINT ercd)
		{
			return ercd;
		}

		///	̿Ūʥ顼򸡽ФݤΥѥ˥å
		static void panic()
		{
			std::abort();
		}
	};

	/**
	 *	@class	error_handler_diagnostics diagnostics.hpp <toppers/diagnostics.hpp>
	 *	@brief	顼ϥɥؿƤӽФǥ饹
	 *	@ingroup	Diagnostics
	 *
	 *	 @e error_handler_diagnostics ƥץ졼ȥ饹ϡŪдؿ@e set_error_handler
	 *	ˤäƥ顼ؿϿ顼л˸ƤӽФΤΤǤ롣\n
	 *	 顼ؿ϶̤ΤΤ򣱤ĤϿǤʤƥץ졼Ȱ@e T Ŭ
	 *	ꤹ뤳Ȥˤꡢۤʤ륨顼ؿȤʬ뤳ȤǽǤ롣
	 *	ƥץ졼Ȱ@e T η̤ʰ̵̣ñ˥顼ؿȤʬ뤿
	 *	Ѥ롣
	 *
	 *	@code
	 *	// ʲΤ褦 error_handler_diagnostics ò뤳Ȥǽ
	 *	class foo {};
	 *	typedef toppers::task<MAIN_TASK, toppers::error_handler_diagnostics<foo> > task;
	 *	@endcode
	 */
	template <class T = void>
	class error_handler_diagnostics
	{
		static ER_UINT (*handler_)(ER_UINT);

	public:
		enum
		{
			///	error_handler_diagnostics 饹㳰Ѥ뤫⤷ʤȤ򼨤
			use_exception = true
		};

		typedef	ER_UINT (*handler_type)(ER_UINT);

		///	ŪдؿǤΥ顼
		static ER_UINT handle_error(ER_UINT ercd)
		{
			return ercd < 0 ? (*handler_)(ercd) : ercd;
		}

		///	ŪдؿǤΥ顼
		static ER_UINT static_handle_error(ER_UINT ercd)
		{
			return handler_error(ercd);
		}

		///	̿Ūʥ顼򸡽ФݤΥѥ˥å
		static void panic()
		{
			std::abort();
		}

		///	顼ϥɥ
		static handler_type set_error_handler(handler_type handler)
		{
			handler_type prev = handler_;
			handler_ = handler;
			return prev;
		}
	};

	template <class T>
	ER_UINT (*error_handler_diagnostics<T>::handler_)(ER_UINT) = 0;

	/**
	 *	@class	polymorphic_diagnostics diagnostics.hpp <toppers/diagnostics.hpp>
	 *	@brief	ƽ۴ؿȤ󶡤ǥ饹
	 *	@ingroup	Diagnostics
	 *
	 *	 @e polymorphic_diagnostics ƥץ졼ȥ饹@e error_handler_diagnostics
	 *	ƥץ졼ȥ饹 protected ѾƤ롣
	 *	ǥեȤư@e error_handler_diagnostics Ѥʤ@e handler_error
	 *	@e panic дؿ۴ؿȤƼƤ롣ޤǥȥ饯
	 *	۴ؿˤʤäƤ뤿ᡢܥ饤֥꤬󶡤륯饹饹
	 *	ͭǤ롣
	 */
	template <class T = void>
	class polymorphic_diagnostics : protected error_handler_diagnostics<T>
	{
		typedef	error_handler_diagnostics<T>	super;

	public:
		enum
		{
			///	error_handler_diagnostics 饹㳰Ѥ뤫⤷ʤȤ򼨤
			use_exception = true
		};

		///	ۥǥȥ饯
		virtual ~polymorphic_diagnostics() throw()
		{
		}

		///	ŪдؿǤΥ顼
		virtual ER_UINT handle_error(ER_UINT ercd) const
		{
			return super::handler_error(ercd);
		}

		///	̿Ūʥ顼򸡽ФݤΥѥ˥å
		virtual void panic() const
		{
			return super::panic();
		}
	};

}

#endif	// ! TOPPERS_DIAGNOSTICS_HPP_
