/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: eventflag.hpp,v 1.3 2004/01/26 00:53:45 takagi-n Exp $
 */

/**
 *	@file	toppers/eventflag.hpp
 *	@brief	٥ȥե饰δԤ饹
 *
 *	 ΥإåեǤϰʲΥƥץ졼ȥ饹Ƥ롣
 *
 *	@code
 *	class eventflag<Id, Diagnostics, Stub>;
 *	@endcode
 */

#ifndef	TOPPERS_EVENTFLAG_HPP_
#define	TOPPERS_EVENTFLAG_HPP_

#include <toppers/object.hpp>

namespace toppers
{

	/**
	 *	@class	eventflag eventflag.hpp <toppers/eventflag.hpp>
	 *	@brief	٥ȥե饰εǽ򥫥ץ벽ƥץ졼ȥ饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 @e eventflag ƥץ졼ȥ饹ϡ٥ȥե饰εǽ򥫥ץ벽
	 *	ƥȤԵˡѥ᡼뤿Υ󥿥ե󶡤롣
	 */
	template <	ID Id			= 0,
				class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB	>
	class eventflag : Diagnostics
	{
		typedef	object_controller<Id, obj_eventflag, Stub>	controller;
		object_id<Id> objid_;

	public:
		///	ѥåȷ
		typedef	typename controller::creation	creation;
		///	ֻȾѥåȷ
		typedef	typename controller::reference	reference;

		/**	@name	󥹥ȥ饯	*/
		//@{

		///	ǥեȥ󥹥ȥ饯
		eventflag() {}
		///	IDֹΥ󥹥ȥ饯
		explicit eventflag(ID id) : objid_(id) {}

		///	ƥץ졼Ȱ㤤Ѵ󥹥ȥ饯
		template <ID Id2, class Diagnostics2, class Stub2>
		eventflag(const eventflag<Id2, Diagnostics2, Stub2>& other)
			: objid_(get_unsafe_id(other))
		{
			TOPPERS_STATIC_ASSERT(Id == 0);
		}

		//@}

		/**	@name	Ⱥ	*/
		//@{

		//	ߴΤ¿
		ER create(creation* pk_cobj)
		{
			ER ercd = controller::create(objid_, pk_cobj);
			return handle_error(ercd);
		}
		///	٥ȥե饰
		ER create(const creation* pk_cobj)
		{
			ER ercd = controller::create(objid_, pk_cobj);
			return handle_error(ercd);
		}
		///	٥ȥե饰ʸ̤Υեɻ
		ER create(ATR flgatr = TA_TFIFO | TA_WSGL, FLGPTN iflgptn = 0)
		{
			creation packet;
			packet.flgatr  = flgatr;
			packet.iflgptn = iflgptn;
			return create(&packet);
		}
		///	٥ȥե饰κ
		ER destroy()
		{
			ER ercd = controller::destroy(objid_);
			return handle_error(ercd);
		}

		//@}

		/**	@name	ֻ	*/
		//@{

		///	٥ȥե饰ξֻ
		ER refer(reference* pk_robj) const
		{
			ER ercd = controller::refer(objid_, pk_robj);
			return handle_error(ercd);
		}

		//@}

		/**	@name	٥ȥե饰	*/
		//@{

		///	٥ȥե饰Υå
		ER set(FLGPTN setptn, task_context_tag = task_context) const
		{
			ER ercd = Stub::stub_set_flg(objid_.id(), setptn);
			return handle_error(ercd);
		}
		///	٥ȥե饰Υåȡ󥿥ƥȡ
		ER set(FLGPTN setptn, non_task_context_tag) const
		{
			ER ercd = Stub::stub_iset_flg(objid_.id(), setptn);
			return handle_error(ercd);
		}
		///	٥ȥե饰Υåȡʥƥ¸
		ER set(FLGPTN setptn, context_independent_tag) const
		{
			ER ercd;
			if (Stub::stub_sns_ctx())
				ercd = Stub::stub_iset_flg(objid_.id(), setptn);
			else
				ercd = Stub::stub_set_flg(objid_.id(), setptn);
			return handle_error(ercd);
		}

		///	٥ȥե饰Υꥢ
		ER clear(FLGPTN clrptn) const
		{
			ER ercd = Stub::stub_clr_flg(objid_.id(), clrptn);
			return handle_error(ercd);
		}

		///	٥ȥե饰Ԥ
		ER wait(FLGPTN waiptn, MODE wfmode, FLGPTN* p_flgptn, forever_tag = forever) const
		{
			ER ercd = Stub::stub_wai_flg(objid_.id(), waiptn, wfmode, p_flgptn);
			return handle_error(ercd);
		}
		///	٥ȥե饰Ԥʥݡ󥰡
		ER wait(FLGPTN waiptn, MODE wfmode, FLGPTN* p_flgptn, polling_tag) const
		{
			ER ercd = Stub::stub_pol_flg(objid_.id(), waiptn, wfmode, p_flgptn);
			return handle_error(ercd);
		}
		///	٥ȥե饰ԤʥॢȻ
		ER wait(FLGPTN waiptn, MODE wfmode, FLGPTN* p_flgptn, TMO tmout) const
		{
			ER ercd = Stub::stub_twai_flg(objid_.id(), waiptn, wfmode, p_flgptn, tmout);
			return handle_error(ercd);
		}

		//@}

		///	٥ȥե饰IDֹμ
		friend ID get_unsafe_id(const eventflag<Id, Diagnostics, Stub>& eventflag)
		{
			return eventflag.objid_.id();
		}
	};

}

#endif	// ! TOPPERS_EVENTFLAG_HPP_
