/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: interrupt.hpp,v 1.3 2004/01/26 00:53:45 takagi-n Exp $
 */

/**
 *	@file	toppers/interrupt.hpp
 *	@brief	ߴ˴ؤ륯饹
 *
 *	 ΥإåեǤϰʲΥƥץ졼ȥ饹ӥƥץ졼ȴؿƤ롣
 *
 *	@code
 *	class interrupt<Diagnostics, Stub>;
 *	class interrupthandler<Diagnostics, Stub>;
 *	class interrupthandler_body<Diagnostics, Stub>;
 *	void interrupthandler_entry<Body>();
 *	class isr<Id, Diagnostics, Stub>;
 *	class isr_body<Diagnostics, Stub>;
 *	void isr_entry<Body>(VP_INT);
 *	@endcode
 */

#ifndef	TOPPERS_INTERRUPT_HPP_
#define	TOPPERS_INTERRUPT_HPP_

#include <toppers/context.hpp>

namespace toppers
{

	template <class Body> void interrupthandler_entry();

	template <class Diagnostics, class Stub> class interrupthandler_body;

	/**
	 *	@class	interrupt interrupt.hpp <toppers/interrupt.hpp>
	 *	@brief	ߤ椹ƥץ졼ȥ饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 @e interrupt ƥץ졼ȥ饹ϡߤζػߡĤȥޥ
	 *	ץ벽ΤǤ롣
	 *	Υ饹ѤѤϡߥϥɥ
	 *	ӳߥӥ롼˱ƶͿ롣
	 *
	 *	@see	interrupthandler interrupthandler_body interrupthandler_entry isr
	 */
	template <	class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB	>
	class interrupt : Diagnostics
	{
	public:
		/**	@name	ߤζػߡ	*/
		//@{

		///	ߤζػ
		static ER disable(INTNO intno)
		{
			ER ercd = Stub::stub_dis_int(intno);
			return static_handle_error(ercd);
		}
		///	ߤε
		static ER enable(INTNO intno)
		{
			ER ercd = Stub::stub_ena_int(intno);
			return static_handle_error(ercd);
		}

		//@}

		/**	@name	ߥޥ	*/
		//@{

		///	ߥޥѹ
		static ER change_mask(IMS ims)
		{
			ER ercd = Stub::stub_chg_ims(ims);
			return static_handle_error(ercd);
		}
		///	ߥޥλ
		static ER get_mask(IMS* p_ims)
		{
			ER ercd = Stub::stub_get_ims(p_ims);
			return static_handle_error(ercd);
		}

		//@}
	};

	/**
	 *	@class	interrupthandler interrupt.hpp <toppers/interrupt.hpp>
	 *	@brief	ߥϥɥ椹ƥץ졼ȥ饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 @e interrupthandler ƥץ졼ȥ饹ϳߥϥɥФ򥫥ץ벽Ƥ롣\n
	 *	@e task Ʊ͡ϥɥν@e interrupthandler_body ƥץ졼ȥ饹饹Ȥ
	 *	Ҥɬפ롣
	 *
	 *	@see	interrupt interrupthandler_body interrupthandler_entry isr
	 */
	template <	class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB	>
	class interrupthandler : Diagnostics
	{
	public:
		///	ߥϥɥѥåȷ
		typedef	t_dinh	definition;

		//	ߴΤ¿
		static ER define(INHNO inhno, definition* pk_dobj)
		{
			ER ercd = Stub::stub_def_inh(inhno, pk_dobj);
			return static_handle_error(ercd);
		}
		///	ߥϥɥ
		static ER define(INHNO inhno, const definition* pk_dobj)
		{
			ER ercd = Stub::stub_def_inh(inhno, pk_dobj);
			return static_handle_error(ercd);
		}
		///	ߥϥɥʸ̤Υեɻ
		static ER define(INHNO inhno, ATR inhatr, void (*inthdr)())
		{
			definition packet;
			packet.inhatr = inhatr;
			packet.inthdr = FP(inthdr);
			return define(inhno, &packet);
		}
		///	ߥϥɥʥܥǥ
		template <class Body>
		static ER define(INHNO inhno, ATR inhatr = 0)
		{
			return define(inhno, inhatr, &interrupthandler_entry<Body>);
		}
		///	ߥϥɥä
		static ER undefine(INHNO inhno)
		{
			return define(inhno, static_cast<definition*>(0));
		}
	};

	/**
	 *	@class	interrupthandler_body interrupt.hpp <toppers/interrupt.hpp>
	 *	@brief	ߥϥɥư쥯饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 ߥϥɥ硢@e interrupthandler_body ƥץ졼ȥ饹 public
	 *	Ѿ饹η@e interrupthandler_entry ƥץ졼ȴؿΥƥץ졼ȰϤ
	 *
	 *	@see	interrupt interrupthandler_entry
	 */
	template <	class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB	>
	class interrupthandler_body : public non_task_context_body<Diagnostics, Stub>
	{
	protected:
		~interrupthandler_body() {}

	public:
		interrupthandler_body() {}
	};

	/**
	 *	@brief	ߥϥɥΥƥץ졼
	 *	@ingroup	KernelObjectManager
	 *
	 *	 ƥץ졼Ȱ@e Body Ȥƻꤷܥǥ饹ΤȤߥϥɥ롣
	 *	δؿ@e T_DINH ¤Τ@e inthdr եɤꤹ뤳ȤǤ롣
	 *
	 *	@attention	@e DEF_INH Ū API ˤФƻѤϡC󥱡δؿǰöåԥ󥰤뤳ȡ
	 *	@see	interrupthandler_body
	 */
	template <class Body>
	inline void interrupthandler_entry()
	{
		Body body;
		body.run();
	}


	template <class Body> void isr_entry(VP_INT);

	template <class Diagnostics, class Stub> class isr_body;

	/**
	 *	@class	isr interrupt.hpp <toppers/interrupt.hpp>
	 *	@brief	ߥӥ롼εǽ򥫥ץ벽ƥץ졼ȥ饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 @e isr ƥץ졼ȥ饹ϳߥӥ롼Ф򥫥ץ벽Ƥ롣\n
	 *	@e task Ʊ͡ϥɥν@e isr_body ƥץ졼ȥ饹饹Ȥ
	 *	Ҥɬפ롣
	 *
	 *	@see	isr_body isr_entry interrupt interrupthandler
	 */
	template <	ID Id			= 0,
				class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB	>
	class isr : Diagnostics
	{
		typedef	object_controller<Id, obj_isr, Stub>	controller;
		object_id<Id> objid_;

	public:
		///	ѥåȷ
		typedef	typename controller::creation	creation;
		///	ֻȾѥåȷ
		typedef	typename controller::reference	reference;
		///	ܥǥ饹
		typedef	isr_body<Diagnostics, Stub>	body;

		/**	@name	󥹥ȥ饯	*/
		//@{

		///	ǥեȥ󥹥ȥ饯
		isr() {}
		///	IDֹΥ󥹥ȥ饯
		explicit isr(ID id) : objid_(id) {}

		///	ƥץ졼Ȱ㤤Ѵ󥹥ȥ饯
		template <ID Id2, class Diagnostics2, class Stub2>
		isr(const isr<Id2, Diagnostics2, Stub2>& other)
			: objid_(get_unsafe_id(other))
		{
			TOPPERS_STATIC_ASSERT(Id == 0);
		}

		//@}

		/**	@name	Ⱥ	*/
		//@{

		//	ߴΤ¿
		ER create(creation* pk_cobj)
		{
			ER ercd = controller::create(objid_, pk_cobj);
			return handle_error(ercd);
		}
		///	ߥӥ롼
		ER create(const creation* pk_cobj)
		{
			ER ercd = controller::create(objid_, pk_cobj);
			return handle_error(ercd);
		}
		///	ߥӥ롼ʸ̤Υեɻ
		ER create(ATR isratr, VP_INT exinf, INTNO intno, void (*isr)(VP_INT))
		{
			creation packet;
			packet.isratr = isratr;
			packet.exinf  = exinf;
			packet.intno  = intno;
			packet.isr    = FP(isr);
			return create(&packet);
		}
		///	ߥӥ롼ʥܥǥ
		template <class Body>
		ER create(ATR isratr, VP_INT exinf, INTNO intno)
		{
			return create(isratr & ~TA_ASM | TA_HLNG, exinf, intno, &isr_entry<Body>);
		}
		///	ߥӥ롼κ
		ER destroy()
		{
			ER ercd = controller::destroy(objid_);
			return handle_error(ercd);
		}

		//@}

		/**	@name	ֻ	*/
		//@{

		///	ߥӥ롼ξֻ
		ER refer(reference* pk_robj) const
		{
			ER ercd = controller::refer(objid_, pk_robj);
			return handle_error(ercd);
		}

		//@}

		///	ߥӥ롼IDֹμ
		friend ID get_unsafe_id(const isr<Id, Diagnostics, Stub>& isr)
		{
			return isr.objid_.id();
		}
	};

	/**
	 *	@class	isr_body interrupt.hpp <toppers/interrupt.hpp>
	 *	@brief	ߥӥ롼ư쥯饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 ߥӥ롼硢@e isr_body ƥץ졼ȥ饹 public
	 *	Ѿ饹η@e isr_entry ƥץ졼ȴؿΥƥץ졼ȰϤ
	 *
	 *	@see	isr isr_entry
	 */
	template <	class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB	>
	class isr_body : public non_task_context_body<Diagnostics, Stub>
	{
		VP_INT exinf_;

	protected:
		~isr_body() {}

	public:
		///	󥹥ȥ饯
		explicit isr_body(VP_INT exinf) : exinf_(exinf) {}

		///	ĥμ
		VP_INT get_extended_info() const { return exinf_; }
	};

	/**
	 *	@brief	ߥӥ롼Υƥץ졼
	 *	@ingroup	KernelObjectManager
	 *
	 *	 ƥץ졼Ȱ@e Body Ȥƻꤷܥǥ饹ΤȤߥӥ롼롣
	 *	δؿ@e T_CISR ¤Τ@e isr եɤꤹ뤳ȤǤ롣
	 *
	 *	@attention	@e CRE_ISR Ū API ˤФƻѤϡC󥱡δؿǰöåԥ󥰤뤳ȡ
	 *	@see	isr_body
	 */
	template <class Body>
	inline void isr_entry(VP_INT exinf)
	{
		Body body(exinf);
		body.run();
	}

}

#endif	// ! TOPPERS_INTERRUPT_HPP_
