/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: kernel.hpp,v 1.3 2004/01/26 00:53:45 takagi-n Exp $
 */

/**
 *	@file	toppers/kernel.hpp
 *	@brief	ͥ뵡ǽ饤֥꤫Ѥ뤿Ū
 *
 *	 ΥإåեǤϰʲηӥƥץ졼ȴؿƤ롣
 *
 *	@code
 *	enum function_code_type;
 *	enum object_type;
 *	enum task_context_tag
 *	enum non_task_context_tag;
 *	enum context_independent_tag;
 *	enum forever_tag;
 *	enum polling_tag;
 *	enum normal_tag;
 *	enum forced_tag;
 *	struct has_svc<Fncd>;
 *	struct has_obj<ObjType>;
 *	bool sense_kernel<Sense>();
 *	@endcode
 */

#ifndef	TOPPERS_KERNEL_HPP_
#define	TOPPERS_KERNEL_HPP_

#include <toppers/complement.hpp>

#ifndef	TOPPERS_HAS_ISR
#define	TOPPERS_HAS_ISR		false
#endif

namespace toppers
{

	///	ǽ
	enum function_code_type
	{
		tfn_cre_tsk			= -5,
		tfn_del_tsk			= -6,
		tfn_act_tsk			= -7,
		tfn_can_act			= -8,
		tfn_sta_tsk			= -9,
		tfn_ext_tsk			= -10,
		tfn_exd_tsk			= -11,
		tfn_ter_tsk			= -12,
		tfn_chg_pri			= -13,
		tfn_get_pri			= -14,
		tfn_ref_tsk			= -15,
		tfn_ref_tst			= -16,

		tfn_slp_tsk			= -17,
		tfn_tslp_tsk		= -18,
		tfn_wup_tsk			= -19,
		tfn_can_wup			= -20,
		tfn_rel_wai			= -21,
		tfn_sus_tsk			= -22,
		tfn_rsm_tsk			= -23,
		tfn_frsm_tsk		= -24,
		tfn_dly_tsk			= -25,

		tfn_def_tex			= -27,
		tfn_ras_tex			= -28,
		tfn_dis_tex			= -29,
		tfn_ena_tex			= -30,
		tfn_sns_tex			= -31,
		tfn_ref_tex			= -32,

		tfn_cre_sem			= -33,
		tfn_del_sem			= -34,
		tfn_sig_sem			= -35,
		tfn_wai_sem			= -37,
		tfn_pol_sem			= -38,
		tfn_twai_sem		= -39,
		tfn_ref_sem			= -40,

		tfn_cre_flg			= -41,
		tfn_del_flg			= -42,
		tfn_set_flg			= -43,
		tfn_clr_flg			= -44,
		tfn_wai_flg			= -45,
		tfn_pol_flg			= -46,
		tfn_twai_flg		= -47,
		tfn_ref_flg			= -48,

		tfn_cre_dtq			= -49,
		tfn_del_dtq			= -50,
		tfn_snd_dtq			= -53,
		tfn_psnd_dtq		= -54,
		tfn_tsnd_dtq		= -55,
		tfn_fsnd_dtq		= -56,
		tfn_rcv_dtq			= -57,
		tfn_prcv_dtq		= -58,
		tfn_trcv_dtq		= -59,
		tfn_ref_dtq			= -60,

		tfn_cre_mbx			= -61,
		tfn_del_mbx			= -62,
		tfn_snd_mbx			= -63,
		tfn_rcv_mbx			= -65,
		tfn_prcv_mbx		= -66,
		tfn_trcv_mbx		= -67,
		tfn_ref_mbx			= -68,

		tfn_cre_mpf			= -69,
		tfn_del_mpf			= -70,
		tfn_rel_mpf			= -71,
		tfn_get_mpf			= -73,
		tfn_pget_mpf		= -74,
		tfn_tget_mpf		= -75,
		tfn_ref_mpf			= -76,

		tfn_set_tim			= -77,
		tfn_get_tim			= -78,

		tfn_cre_cyc			= -79,
		tfn_del_cyc			= -80,
		tfn_sta_cyc			= -81,
		tfn_stp_cyc			= -82,
		tfn_ref_cyc			= -83,

		tfn_rot_rdq			= -85,
		tfn_get_tid			= -86,
		tfn_loc_cpu			= -89,
		tfn_unl_cpu			= -90,
		tfn_dis_dsp			= -91,
		tfn_ena_dsp			= -92,
		tfn_sns_ctx			= -93,
		tfn_sns_loc			= -94,
		tfn_sns_dsp			= -95,
		tfn_sns_dpn			= -96,
		tfn_ref_sys			= -97,

		tfn_def_inh			= -101,
		tfn_cre_isr			= -102,
		tfn_del_isr			= -103,
		tfn_ref_isr			= -104,
		tfn_dis_int			= -105,
		tfn_ena_int			= -106,
		tfn_chg_ixx			= -107,
		tfn_chg_ims			= tfn_chg_ixx,
		tfn_get_ixx			= -108,
		tfn_get_ims			= tfn_get_ixx,

		tfn_def_svc			= -109,
		tfn_def_exc			= -110,
		tfn_ref_cfg			= -111,
		tfn_ref_ver			= -112,

		tfn_iact_tsk		= -113,
		tfn_iwup_tsk		= -114,
		tfn_irel_wai		= -115,
		tfn_iras_tex		= -116,
		tfn_isig_sem		= -117,
		tfn_iset_flg		= -118,
		tfn_ipsnd_dtq		= -119,
		tfn_ifsnd_dtq		= -120,
		tfn_irot_rdq		= -121,
		tfn_iget_tid		= -122,
		tfn_iloc_cpu		= -123,
		tfn_iunl_cpu		= -124,
		tfn_isig_tim		= -125,

		tfn_cre_mtx			= -129,
		tfn_del_mtx			= -130,
		tfn_unl_mtx			= -131,
		tfn_loc_mtx			= -133,
		tfn_ploc_mtx		= -134,
		tfn_tloc_mtx		= -135,
		tfn_ref_mtx			= -136,

		tfn_cre_mbf			= -137,
		tfn_del_mbf			= -138,
		tfn_snd_mbf			= -141,
		tfn_psnd_mbf		= -142,
		tfn_tsnd_mbf		= -143,
		tfn_rcv_mbf			= -145,
		tfn_prcv_mbf		= -146,
		tfn_trcv_mbf		= -147,
		tfn_ref_mbf			= -148,

		tfn_cre_por			= -149,
		tfn_del_por			= -150,
		tfn_cal_por			= -151,
		tfn_tcal_por		= -152,
		tfn_acp_por			= -153,
		tfn_pacp_por		= -154,
		tfn_tacp_por		= -155,
		tfn_fwd_por			= -156,
		tfn_rpl_rdv			= -157,
		tfn_ref_por			= -158,
		tfn_ref_rdv			= -159,

		tfn_cre_mpl			= -161,
		tfn_del_mpl			= -162,
		tfn_rel_mpl			= -163,
		tfn_get_mpl			= -165,
		tfn_pget_mpl		= -166,
		tfn_tget_mpl		= -167,
		tfn_ref_mpl			= -168,

		tfn_cre_alm			= -169,
		tfn_del_alm			= -170,
		tfn_sta_alm			= -171,
		tfn_stp_alm			= -172,
		tfn_ref_alm			= -173,

		tfn_def_ovr			= -177,
		tfn_sta_ovr			= -178,
		tfn_stp_ovr			= -179,
		tfn_ref_ovr			= -180,

		tfn_acre_tsk		= -193,
		tfn_acre_sem		= -194,
		tfn_acre_flg		= -195,
		tfn_acre_dtq		= -196,
		tfn_acre_mbx		= -197,
		tfn_acre_mtx		= -198,
		tfn_acre_mbf		= -199,
		tfn_acre_por		= -200,
		tfn_acre_mpf		= -201,
		tfn_acre_mpl		= -202,
		tfn_acre_cyc		= -203,
		tfn_acre_alm		= -204,
		tfn_acre_isr		= -205,

		tfn_vxsns_ctx		= -225,
		tfn_vxsns_loc		= -226,
		tfn_vxsns_dsp		= -227,
		tfn_vxsns_dpn		= -228,
		tfn_vxsns_tex		= -229,
		tfn_vsns_ini		= -232,

		tfn_vxget_tim		= -233,

		tfn_cal_svc			= -32767
	};

	/**
	 *	@struct	has_svc	kernel.hpp	<toppers/kernel.hpp>
	 *	@brief	ͥ뤬ꤷӥ򥵥ݡȤƤ뤫ɤȽ̤
	 *	@ingroup	KernelObjectManager	Diagnostics
	 *	@attention	ӥ뤬ݡȤƤ뤫ɤϡץȥפޥ뤫ɤȽ̤Ƥꡢ
	 *				ºݤεǽ̤ˤθƤʤ
	 *
	 *	 ƥץ졼Ȱ@e Fncd ǻꤷӥ򥫡ͥ뤬ݡȤƤ뤫ɤ@e value
	 *	Ȥ롣\n
	 *	 @e Fncd ˤϡ function_code_type Ǥ`@e toppers::tfn_ӥ̾ 'ꤹ뤳ȡ
	 */
	template <function_code_type Fncd>
	struct has_svc
	{
		enum
		{
			///	@e Fncd ǻꤷӥ뤬ݡȤƤ@e true
			value = true
		};
	};

	template <> struct has_svc<tfn_cre_tsk> { enum { value = (sizeof cre_tsk(0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_del_tsk> { enum { value = (sizeof del_tsk(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_sta_tsk> { enum { value = (sizeof sta_tsk(0, 0) != sizeof(large_type)) }; };
#ifdef	exd_tsk
	template <> struct has_svc<tfn_exd_tsk> { enum { value = true;
#else
	template <> struct has_svc<tfn_exd_tsk> { enum { value = (sizeof test_svc(exd_tsk) == sizeof(yes_type)) }; };
#endif
	template <> struct has_svc<tfn_ref_tsk> { enum { value = (sizeof ref_tsk(0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_ref_tst> { enum { value = (sizeof ref_tst(0, 0) != sizeof(large_type)) }; };

	template <> struct has_svc<tfn_def_tex> { enum { value = (sizeof def_tex(0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_ref_tex> { enum { value = (sizeof ref_tex(0, 0) != sizeof(large_type)) }; };

	template <> struct has_svc<tfn_cre_sem> { enum { value = (sizeof cre_sem(0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_del_sem> { enum { value = (sizeof del_sem(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_ref_sem> { enum { value = (sizeof ref_sem(0, 0) != sizeof(large_type)) }; };

	template <> struct has_svc<tfn_cre_flg> { enum { value = (sizeof cre_flg(0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_del_flg> { enum { value = (sizeof del_flg(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_ref_flg> { enum { value = (sizeof ref_flg(0, 0) != sizeof(large_type)) }; };

	template <> struct has_svc<tfn_cre_dtq> { enum { value = (sizeof cre_dtq(0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_del_dtq> { enum { value = (sizeof del_dtq(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_ref_dtq> { enum { value = (sizeof ref_dtq(0, 0) != sizeof(large_type)) }; };

	template <> struct has_svc<tfn_cre_mbx> { enum { value = (sizeof cre_mbx(0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_del_mbx> { enum { value = (sizeof del_mbx(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_ref_mbx> { enum { value = (sizeof ref_mbx(0, 0) != sizeof(large_type)) }; };

	template <> struct has_svc<tfn_cre_mpf> { enum { value = (sizeof cre_mpf(0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_del_mpf> { enum { value = (sizeof del_mpf(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_ref_mpf> { enum { value = (sizeof ref_mpf(0, 0) != sizeof(large_type)) }; };

	template <> struct has_svc<tfn_cre_cyc> { enum { value = (sizeof cre_cyc(0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_del_cyc> { enum { value = (sizeof del_cyc(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_ref_cyc> { enum { value = (sizeof ref_cyc(0, 0) != sizeof(large_type)) }; };

	template <> struct has_svc<tfn_ref_sys> { enum { value = (sizeof ref_sys(0) != sizeof(large_type)) }; };

	template <> struct has_svc<tfn_def_inh> { enum { value = (sizeof def_inh(0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_cre_isr> { enum { value = (sizeof cre_isr(0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_del_isr> { enum { value = (sizeof del_isr(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_ref_isr> { enum { value = (sizeof ref_isr(0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_dis_int> { enum { value = (sizeof dis_int(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_ena_int> { enum { value = (sizeof ena_int(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_chg_ixx> { enum { value = (sizeof chg_ims(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_get_ixx> { enum { value = (sizeof chg_ims(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_def_svc> { enum { value = (sizeof def_svc(0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_def_exc> { enum { value = (sizeof def_exc(0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_ref_cfg> { enum { value = (sizeof ref_cfg(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_ref_ver> { enum { value = (sizeof ref_ver(0) != sizeof(large_type)) }; };

	template <> struct has_svc<tfn_cre_mtx> { enum { value = (sizeof cre_mtx(0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_del_mtx> { enum { value = (sizeof del_mtx(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_unl_mtx> { enum { value = (sizeof unl_mtx(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_loc_mtx> { enum { value = (sizeof loc_mtx(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_ploc_mtx> { enum { value = (sizeof ploc_mtx(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_tloc_mtx> { enum { value = (sizeof tloc_mtx(0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_ref_mtx> { enum { value = (sizeof ref_mtx(0, 0) != sizeof(large_type)) }; };

	template <> struct has_svc<tfn_cre_mbf> { enum { value = (sizeof cre_mbf(0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_del_mbf> { enum { value = (sizeof del_mbf(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_snd_mbf> { enum { value = (sizeof snd_mbf(0, 0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_psnd_mbf> { enum { value = (sizeof psnd_mbf(0, 0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_tsnd_mbf> { enum { value = (sizeof tsnd_mbf(0, 0, 0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_rcv_mbf> { enum { value = (sizeof rcv_mbf(0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_prcv_mbf> { enum { value = (sizeof prcv_mbf(0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_trcv_mbf> { enum { value = (sizeof trcv_mbf(0, 0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_ref_mbf> { enum { value = (sizeof ref_mbf(0, 0) != sizeof(large_type)) }; };

	template <> struct has_svc<tfn_cre_por> { enum { value = (sizeof cre_por(0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_del_por> { enum { value = (sizeof del_por(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_cal_por> { enum { value = (sizeof cal_por(0, 0, 0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_tcal_por> { enum { value = (sizeof tcal_por(0, 0, 0, 0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_acp_por> { enum { value = (sizeof acp_por(0, 0, 0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_pacp_por> { enum { value = (sizeof pacp_por(0, 0, 0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_tacp_por> { enum { value = (sizeof tacp_por(0, 0, 0, 0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_fwd_por> { enum { value = (sizeof fwd_por(0, 0, 0, 0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_rpl_rdv> { enum { value = (sizeof rpl_rdv(0, 0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_ref_por> { enum { value = (sizeof ref_por(0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_ref_rdv> { enum { value = (sizeof ref_rdv(0, 0) != sizeof(large_type)) }; };

	template <> struct has_svc<tfn_cre_mpl> { enum { value = (sizeof cre_mpl(0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_del_mpl> { enum { value = (sizeof del_mpl(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_rel_mpl> { enum { value = (sizeof rel_mpl(0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_get_mpl> { enum { value = (sizeof get_mpl(0, 0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_pget_mpl> { enum { value = (sizeof pget_mpl(0, 0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_tget_mpl> { enum { value = (sizeof tget_mpl(0, 0, 0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_ref_mpl> { enum { value = (sizeof ref_mpl(0, 0) != sizeof(large_type)) }; };

	template <> struct has_svc<tfn_cre_alm> { enum { value = (sizeof cre_alm(0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_del_alm> { enum { value = (sizeof del_alm(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_sta_alm> { enum { value = (sizeof sta_alm(0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_stp_alm> { enum { value = (sizeof stp_alm(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_ref_alm> { enum { value = (sizeof ref_alm(0, 0) != sizeof(large_type)) }; };

	template <> struct has_svc<tfn_def_ovr> { enum { value = (sizeof def_ovr(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_sta_ovr> { enum { value = (sizeof sta_ovr(0, 0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_stp_ovr> { enum { value = (sizeof stp_ovr(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_ref_ovr> { enum { value = (sizeof ref_ovr(0, 0) != sizeof(large_type)) }; };

	template <> struct has_svc<tfn_acre_tsk> { enum { value = (sizeof acre_tsk(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_acre_sem> { enum { value = (sizeof acre_sem(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_acre_flg> { enum { value = (sizeof acre_flg(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_acre_dtq> { enum { value = (sizeof acre_dtq(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_acre_mbx> { enum { value = (sizeof acre_mbx(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_acre_mtx> { enum { value = (sizeof acre_mtx(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_acre_mbf> { enum { value = (sizeof acre_mbf(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_acre_por> { enum { value = (sizeof acre_por(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_acre_mpf> { enum { value = (sizeof acre_mpf(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_acre_mpl> { enum { value = (sizeof acre_mpl(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_acre_cyc> { enum { value = (sizeof acre_cyc(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_acre_alm> { enum { value = (sizeof acre_alm(0) != sizeof(large_type)) }; };
	template <> struct has_svc<tfn_acre_isr> { enum { value = (sizeof acre_isr(0) != sizeof(large_type)) }; };

	template <> struct has_svc<tfn_vxget_tim> { enum { value = (sizeof vxget_tim(0) != sizeof(large_type)) }; };

	template <> struct has_svc<tfn_cal_svc> { enum { value = (sizeof cal_svc(0, 0, 0, 0, 0, 0) != sizeof(large_type)) }; };

	///	ͥ륪֥Ȥμ
	enum object_type
	{
		obj_semaphore		= 128,
		obj_eventflag		= 129,
		obj_dataqueue		= 130,
		obj_mailbox			= 131,
		obj_mutex			= 132,
		obj_messagebuffer	= 133,
		obj_rendezvousport	= 135,
		obj_rendezvous		= 136,
		obj_fmempool		= 137,
		obj_vmempool		= 138,
		obj_task			= 139,
		obj_readyqueue		= 141,
		obj_timerqueue		= 142,
		obj_cyclichandler	= 144,
		obj_alarmhandler	= 145,
		obj_overrunhandler	= 146,
		obj_isr				= 147,
		obj_kernelstatus	= 148,
		obj_taskexception	= 149,
		obj_cpuexception	= 150,
		obj_all				= -1,
		obj_none			= 0
	};

	/**
	 *	@struct	has_obj	kernel.hpp	<toppers/kernel.hpp>
	 *	@brief	ͥ뤬ꤷͥ륪֥Ȥ򥵥ݡȤƤ뤫ɤȽ̤
	 *	@ingroup	KernelObjectManager	Diagnostics
	 *	@attention	ͥ륪֥ȤݡȤƤ뤫ɤϡʥӥ뤬뤫ɤȽ̤Ƥ롣
	 *
	 *	ƥץ졼Ȱ@e ObjType ǻꤷͥ륪֥Ȥ򥫡ͥ뤬ݡȤƤ뤫ɤ@e value
	 *	Ȥ롣\n
	 *	@e ObjType ˤϡ object_type Ǥ`@e toppers::obj_ͥ륪֥̾ 'ꤹ뤳ȡ
	 */
	template <object_type ObjType>
	struct has_obj
	{
		enum
		{
			///	@e ObjType ǻꤷͥ륪֥ȤݡȤƤ@e true
			value = true
		};
	};

	template <> struct has_obj<obj_mutex> { enum { value = has_svc<tfn_loc_mtx>::value }; };
	template <> struct has_obj<obj_messagebuffer> { enum { value = has_svc<tfn_snd_mbf>::value }; };
	template <> struct has_obj<obj_rendezvousport> { enum { value = has_svc<tfn_cal_por>::value }; };
	template <> struct has_obj<obj_rendezvous> { enum { value = has_svc<tfn_rpl_rdv>::value }; };
	template <> struct has_obj<obj_vmempool> { enum { value = has_svc<tfn_get_mpl>::value }; };
	template <> struct has_obj<obj_alarmhandler> { enum { value = has_svc<tfn_sta_alm>::value }; };
	template <> struct has_obj<obj_overrunhandler> { enum { value = has_svc<tfn_sta_ovr>::value }; };
	template <> struct has_obj<obj_isr> { enum { value = has_svc<tfn_cre_isr>::value || TOPPERS_HAS_ISR }; };

	///	ƥѤΥӥ׵᤹뤿Υ
	enum task_context_tag
	{
		///	ƥȤꤹ
		task_context = 1
	};

	///	󥿥ƥѤΥӥ׵᤹뤿Υ
	enum non_task_context_tag
	{
		///	󥿥ƥȤꤹ
		non_task_context = 2
	};

	///	ƥȤ˱ӥ׵᤹뤿Υ
	enum context_independent_tag
	{
		///	ƥ¸ꤹ
		context_independent = 0
	};

	///	ʵԤѤΥӥ׵᤹뤿Υ
	enum forever_tag
	{
		///	ʵԤꤹ
		forever = TMO_FEVR
	};

	///	ݡѤΥӥ׵᤹뤿Υ
	enum polling_tag
	{
		///	ݡ󥰤ꤹ
		polling = TMO_POL
	};

	///	̾ѡʶ¹ԤǤϤʤˤΥӥ׵᤹뤿Υ
	enum normal_tag
	{
		///	̾Ѥꤹ
		normal = 0
	};

	///	¹ѤΥӥ׵᤹뤿Υ
	enum forced_tag
	{
		///	¹Ѥꤹ
		forced = -3
	};

	/**
	 *	@brief	ͥ뤬ư椫ɤȽ̤롣
	 *	@ingroup	KernelObjectManager
	 *
	 *	vsns_ini ӥƤӽФơͥ뤬ư椫ɤȽ̤롣\n
	 *	δؿϡƥץ졼Ȱ@e false ꤹȾ@e false ֤ᡢɬפ˱ƥͥ
	 *	ưȽ̤ά˻Ѥ롣
	 */
	template <bool Sense>
	inline bool sense_kernel()
	{
		return vsns_ini();
	}

	template <>
	inline bool sense_kernel<false>()
	{
		return false;
	}

}

#endif	// ! TOPPERS_KERNEL_HPP_
