/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: kernelstatus.hpp,v 1.3 2004/01/26 00:53:45 takagi-n Exp $
 */

/**
 *	@file	toppers/kernelstatus.hpp
 *	@brief	֤ͥ椹륯饹
 *
 *	 ΥإåեǤϰʲΥƥץ졼ȥ饹Ƥ롣
 *
 *	@code
 *	class kernelstatus<Diagnostics, Stub>;
 *	class readyqueue<Diagnostics, Stub>;
 *	class cpulock<Diagnostics, Stub>;
 *	class dispatcher<Diagnostics, Stub>;
 *	@endcode
 */

#ifndef	TOPPERS_KERNELSTATUS_HPP_
#define	TOPPERS_KERNELSTATUS_HPP_

#include <toppers/object.hpp>

namespace toppers
{

	template <class Diagnostics, class Stub> class readyqueue;
	template <class Diagnostics, class Stub> class cpulock;
	template <class Diagnostics, class Stub> class dispacher;

	/**
	 *	@class	kernelstatus	kernelstatus.hpp	<toppers/kernelstatus.hpp>
	 *	@brief	֤ͥ˴ؤ򥫥ץ벽ƥץ졼ȥ饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 @e kernelstatus ƥץ졼ȥ饹ϼȤƥͥξֻȤ򥫥ץ벽Ƥ롣
	 *	ͥξ֤ˤϥƥСʤɡĤ뤬¿줿
	 *	Ʊ̾ΥдؿǻȤǤ褦ˤʤäƤ롣
	 */
	template <	class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB	>
	class kernelstatus : Diagnostics
	{
	public:
		///	ƥ󻲾ȥѥåȷ
		typedef	t_rsys	system_reference;
		///	С󻲾ȥѥåȷ
		typedef	t_rver	version_reference;
		///	ե졼󻲾ȥѥåȷ
		typedef	t_rcfg	configuration_reference;
		///	ƥ󻲾ȥѥåȷ
		typedef	system_reference	reference;

		struct context;

		///	ƥλ
		static ER refer(system_reference* pk_robj)
		{
			ER ercd = Stub::stub_ref_sys(pk_robj);
			return static_handle_error(ercd);
		}
		///	ͥΥСλ
		static ER refer(version_reference* pk_robj)
		{
			ER ercd = Stub::stub_ref_ver(pk_robj);
			return static_handle_error(ercd);
		}
		///	ե졼λ
		static ER refer(configuration_reference* pk_robj)
		{
			ER ercd = Stub::stub_ref_cfg(pk_robj);
			return static_handle_error(ercd);
		}
	};

	/**
	 *	@struct	kernelstatus<Diagnostics, Stub>::context	kernelstatus.hpp	<toppers/kernelstatus.hpp>
	 *	@brief	¹楳ƥȻȥ饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 @e kernelstatus<Diagnostics, Stub>::context ƥץ졼ȥ饹ϡ߼¹ΥƥȤƥȤ
	 *	󥿥ƥȤȽ̤롣
	 */
	template <class Diagnostics, class Stub>
	struct kernelstatus<Diagnostics, Stub>::context
	{
		///	ƥȤλ
		static bool sense()
		{
			return Stub::stub_sns_ctx();
		}
	};


	/**
	 *	@class	readyqueue	kernelstatus.hpp	<toppers/kernelstatus.hpp>
	 *	@brief	ǥ塼򥫥ץ벽ƥץ졼ȥ饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 @e readyqueue ƥץ졼ȥ饹ϡ̤ͥβž򥫥ץ벽Ƥ롣
	 *	ƥдؿϼ¹ԥƥȤѥ᡼뤳ȤƤ롣
	 */
	template <	class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB	>
	class readyqueue : Diagnostics
	{
	public:
		///	̤ͥβž
		static ER rotate(PRI tskpri, task_context_tag = task_context)
		{
			ER ercd = Stub::stub_rot_rdq(tskpri);
			return static_handle_error(ercd);
		}
		///	̤ͥβž󥿥ƥȡ
		static ER rotate(PRI tskpri, non_task_context_tag)
		{
			ER ercd = Stub::stub_irot_rdq(tskpri);
			return static_handle_error(ercd);
		}
		///	̤ͥβžʥƥ¸
		static ER rotate(PRI tskpri, context_independent_tag)
		{
			ER ercd;
			if (Stub::stub_sns_ctx())
				ercd = Stub::stub_irot_rdq(tskpri);
			else
				ercd = Stub::stub_rot_rdq(tskpri);
			return static_handle_error(ercd);
		}
	};

	/**
	 *	@class	cpulock	kernelstatus.hpp	<toppers/kernelstatus.hpp>
	 *	@brief	CPUå֤򥫥ץ벽ƥץ졼ȥ饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 @e cpulock ƥץ졼ȥ饹ϡCPUå֤򥫥ץ벽Ƥ롣
	 *	ƥдؿϼ¹ԥƥȤѥ᡼뤳ȤƤ롣
	 */
	template <	class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB	>
	class cpulock : Diagnostics
	{
	public:
		///	CPUå֤λ
		static bool sense()
		{
			return Stub::stub_sns_loc();
		}
		///	CPUå֤ؤΰʹ
		static ER lock(task_context_tag = task_context)
		{
			ER ercd = Stub::stub_loc_cpu();
			return static_handle_error(ercd);
		}
		///	CPUå֤ؤΰʹߡ󥿥ƥȡ
		static ER lock(non_task_context_tag)
		{
			ER ercd = Stub::stub_iloc_cpu();
			return static_handle_error(ercd);
		}
		///	CPUå֤ؤΰʹߡʥƥ¸
		static ER lock(context_independent_tag)
		{
			ER ercd;
			if (Stub::stub_sns_ctx())
				ercd = Stub::stub_iloc_cpu();
			else
				ercd = Stub::stub_loc_cpu();
			return static_handle_error(ercd);
		}
		///	CPUå֤β
		static ER unlock(task_context_tag = task_context)
		{
			ER ercd = Stub::stub_unl_cpu();
			return static_handle_error(ercd);
		}
		///	CPUå֤β󥿥ƥȡ
		static ER unlock(non_task_context_tag)
		{
			ER ercd = Stub::stub_iunl_cpu();
			return static_handle_error(ercd);
		}
		///	CPUå֤βʥƥ¸
		static ER unlock(context_independent_tag)
		{
			ER ercd;
			if (Stub::stub_sns_ctx())
				ercd = Stub::stub_iunl_cpu();
			else
				ercd = Stub::stub_unl_cpu();
			return static_handle_error(ercd);
		}
	};

	namespace detail
	{

		template <bool SenseKernel, class LockObj> class lock_helper;

		template <bool SenseKernel, class Diagnostics, class Stub>
		class lock_helper<SenseKernel, cpulock<Diagnostics, Stub> >
		{
		public:
			typedef	cpulock<Diagnostics, Stub>	sync_type;

			static bool sense(const sync_type& sync)
			{
				return sense_kernel<SenseKernel>() ? true : sync_type::sense();
			}
			static ER lock(const sync_type& sync)
			{
				return sense_kernel<SenseKernel>() ? E_OK : sync_type::lock();
			}
			static ER unlock(const sync_type& sync)
			{
				return sense_kernel<SenseKernel>() ? E_OK : sync_type::unlock();
			}
		};

	}


	/**
	 *	@class	dispatcher	kernelstatus.hpp	<toppers/kernelstatus.hpp>
	 *	@brief	ǥѥå򥫥ץ벽ƥץ졼ȥ饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 @e dispatcher ƥץ졼ȥ饹ϡǥѥåػ߾֤򥫥ץ벽Ƥ롣
	 */
	template <	class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB	>
	class dispatcher : Diagnostics
	{
	public:
		struct pending;

		///	ǥѥåػ߾֤λ
		static bool sense()
		{
			return Stub::stub_sns_dsp();
		}
		///	ǥѥåζػ
		static ER disable()
		{
			ER ercd = Stub::stub_dis_dsp();
			return static_handle_error(ercd);
		}
		///	ǥѥåε
		static ER enable()
		{
			ER ercd = Stub::stub_ena_dsp();
			return static_handle_error(ercd);
		}
	};

	/**
	 *	@struct	dispatcher<Diagnostics, Stub>::pending	kernelstatus.hpp	<toppers/kernelstatus.hpp>
	 *	@brief	ǥѥåαֻȥ饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 @e dispatcher ƥץ졼ȥ饹ϡǥѥåػ߾֤򥫥ץ벽Ƥ롣
	 */
	template <class Diagnostics, class Stub>
	struct dispatcher<Diagnostics, Stub>::pending
	{
		static bool sense()
		{
			return Stub::stub_sns_dpn();
		}
	};

	namespace detail
	{

		template <bool SenseKernel, class LockObj> class lock_helper;

		template <bool SenseKernel, class Diagnostics, class Stub>
		class lock_helper<SenseKernel, dispatcher<Diagnostics, Stub> >
		{
		public:
			typedef	dispatcher<Diagnostics, Stub>	sync_type;

			static bool sense(const sync_type& sync)
			{
				return sense_kernel<SenseKernel>() ? true : sync_type::sense();
			}
			static ER lock(const sync_type& sync)
			{
				return sense_kernel<SenseKernel>() ? E_OK : sync_type::disable();
			}
			static ER unlock(const sync_type& sync)
			{
				return sense_kernel<SenseKernel>() ? E_OK : sync_type::enable();
			}
		};

	}

}

#endif	// ! TOPPERS_KERNELSTATUS_HPP_
