/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: mailbox.hpp,v 1.3 2004/01/26 00:53:45 takagi-n Exp $
 */

/**
 *	@file	toppers/mailbox.hpp
 *	@brief	᡼ܥå椹륯饹
 *
 *	 ΥإåեǤϰʲΥƥץ졼ȥ饹Ƥ롣
 *
 *	@code
 *	class mailbox<Id, Diagnostics, Stub>;
 *	@endcode
 */

#ifndef	TOPPERS_MAILBOX_HPP_
#define	TOPPERS_MAILBOX_HPP_

#include <toppers/object.hpp>

namespace toppers
{

	/**
	 *	@class	mailbox mailbox.hpp <toppers/mailbox.hpp>
	 *	@brief	᡼ܥåεǽ򥫥ץ벽ƥץ졼ȥ饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 @e mailbox ƥץ졼ȥ饹ϡ᡼ܥåεǽ򥫥ץ벽
	 *	Եˡѥ᡼뤿Υ󥿥ե󶡤롣
	 */
	template <	ID Id			= 0,
				class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB	>
	class mailbox : Diagnostics
	{
		typedef	object_controller<Id, obj_mailbox, Stub>	controller;
		object_id<Id> objid_;

	public:
		///	ѥåȷ
		typedef	typename controller::creation	creation;
		///	ֻȾѥåȷ
		typedef	typename controller::reference	reference;

		/**	@name	󥹥ȥ饯	*/
		//@{

		///	ǥեȥ󥹥ȥ饯
		mailbox() {}
		///	IDֹΥ󥹥ȥ饯
		explicit mailbox(ID id) : objid_(id) {}

		///	ƥץ졼Ȱ㤤Ѵ󥹥ȥ饯
		template <ID Id2, class Diagnostics2, class Stub2>
		mailbox(const mailbox<Id2, Diagnostics2, Stub2>& other)
			: objid_(get_unsafe_id(other))
		{
			TOPPERS_STATIC_ASSERT(Id == 0);
		}

		//@}

		/**	@name	Ⱥ	*/
		//@{

		//	ߴΤ¿
		ER create(creation* pk_cobj)
		{
			ER ercd = controller::create(objid_, pk_cobj);
			return handle_error(ercd);
		}
		///	᡼ܥå
		ER create(const creation* pk_cobj)
		{
			ER ercd = controller::create(objid_, pk_cobj);
			return handle_error(ercd);
		}
		///	᡼ܥåʸ̤Υեɻ
		ER create(ATR mbxatr = TA_TFIFO | TA_MFIFO, PRI maxmpri = TMAX_MPRI, VP mprihd = 0)
		{
			creation packet;
			packet.mbxatr  = mbxatr;
			packet.maxmpri = maxmpri;
			packet.mprihd  = mprihd;
			return create(&packet);
		}
		///	᡼ܥåκ
		ER destroy()
		{
			ER ercd = controller::destroy(objid_);
			return handle_error(ercd);
		}

		//@}

		/**	@name	ֻ	*/
		//@{

		///	᡼ܥåξֻ
		ER refer(reference* pk_robj) const
		{
			ER ercd = controller::refer(objid_, pk_robj);
			return handle_error(ercd);
		}

		//@}

		/**	@name	å	*/
		//@{

		///	᡼ܥåؤ
		ER send(t_msg* pk_msg) const
		{
			ER ercd = Stub::stub_snd_mbx(objid_.id(), pk_msg);
			return handle_error(ercd);
		}

		///	᡼ܥåμ
		ER receive(t_msg** ppk_msg, forever_tag = forever) const
		{
			ER ercd = Stub::stub_rcv_mbx(objid_.id(), ppk_msg);
			return handle_error(ercd);
		}
		///	᡼ܥåμʥݡ󥰡
		ER receive(t_msg** ppk_msg, polling_tag) const
		{
			ER ercd = Stub::stub_prcv_mbx(objid_.id(), ppk_msg);
			return handle_error(ercd);
		}
		///	᡼ܥåμʥॢȻ
		ER receive(t_msg** ppk_msg, TMO tmout) const
		{
			ER ercd = Stub::stub_trcv_mbx(objid_.id(), ppk_msg, tmout);
			return handle_error(ercd);
		}

		//@}

		///	᡼ܥåIDֹμ
		friend ID get_unsafe_id(const mailbox<Id, Diagnostics, Stub>& mailbox)
		{
			return mailbox.objid_.id();
		}
	};

}

#endif	// ! TOPPERS_MAILBOX_HPP_
