/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: messagebuffer.hpp,v 1.3 2004/01/26 00:53:45 takagi-n Exp $
 */

/**
 *	@file	toppers/messagebuffer.hpp
 *	@brief	åХåե椹륯饹
 *
 *	 ΥإåեǤϰʲΥƥץ졼ȥ饹Ƥ롣
 *
 *	@code
 *	class messagebuffer<Id, Diagnostics, Stub>;
 *	@endcode
 */

#ifndef	TOPPERS_MESSAGEBUFFER_HPP_
#define	TOPPERS_MESSAGEBUFFER_HPP_

#include <toppers/object.hpp>

namespace toppers
{

	/**
	 *	@class	messagebuffer messagebuffer.hpp <toppers/messagebuffer.hpp>
	 *	@brief	åХåեεǽ򥫥ץ벽ƥץ졼ȥ饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 @e messagebuffer ƥץ졼ȥ饹ϡåХåեεǽ򥫥ץ벽
	 *	Եˡѥ᡼뤿Υ󥿥ե󶡤롣
	 */
	template <	ID Id			= 0,
				class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB	>
	class messagebuffer : Diagnostics
	{
		typedef	object_controller<Id, obj_messagebuffer, Stub>	controller;
		object_id<Id> objid_;

	public:
		///	ѥåȷ
		typedef	typename controller::creation	creation;
		///	ֻȾѥåȷ
		typedef	typename controller::reference	reference;

		/**	@name	󥹥ȥ饯	*/
		//@{

		///	ǥեȥ󥹥ȥ饯
		messagebuffer() {}
		///	IDֹΥ󥹥ȥ饯
		explicit messagebuffer(ID id) : objid_(id) {}

		///	ƥץ졼Ȱ㤤Ѵ󥹥ȥ饯
		template <ID Id2, class Diagnostics2, class Stub2>
		messagebuffer(const messagebuffer<Id2, Diagnostics2, Stub2>& other)
			: objid_(get_unsafe_id(other))
		{
			TOPPERS_STATIC_ASSERT(Id == 0);
		}

		//@}

		/**	@name	Ⱥ	*/
		//@{

		//	ߴΤ¿
		ER create(creation* pk_cobj)
		{
			ER ercd = controller::create(objid_, pk_cobj);
			return handle_error(ercd);
		}
		///	åХåե
		ER create(const creation* pk_cobj)
		{
			ER ercd = controller::create(objid_, pk_cobj);
			return handle_error(ercd);
		}
		///	åХåեʸ̤Υեɻ
		ER create(ATR mbfatr = TA_TFIFO, UINT maxmsz = 256, SIZE mbfsz = 0, VP mbf = 0)
		{
			creation packet;
			packet.mbfatr = mbfatr;
			packet.maxmsz = maxmsz;
			packet.mbfsz  = mbfsz;
			packet.mbf    = mbf;
			return create(&packet);
		}
		///	åХåեκ
		ER destroy()
		{
			ER ercd = controller::destroy(objid_);
			return handle_error(ercd);
		}

		//@}

		/**	@name	ֻ	*/
		//@{

		///	åХåեξֻ
		ER refer(reference* pk_robj) const
		{
			ER ercd = controller::refer(objid_, pk_robj);
			return handle_error(ercd);
		}

		//@}

		/**	@name	å	*/
		//@{

		///	åХåեؤ
		ER send(const void* msg, UINT msgsz, forever_tag = forever) const
		{
			ER ercd = Stub::stub_snd_mbf(objid_.id(), msg, msgsz);
			return handle_error(ercd);
		}
		///	åХåեؤʥݡ󥰡
		ER send(const void* msg, UINT msgsz, polling_tag) const
		{
			ER ercd = Stub::stub_psnd_mbf(objid_.id(), msg, msgsz);
			return handle_error(ercd);
		}
		///	åХåեؤʥॢȻ
		ER send(const void* msg, UINT msgsz, TMO tmout) const
		{
			ER ercd = Stub::stub_tsnd_mbf(objid_.id(), msg, msgsz, tmout);
			return handle_error(ercd);
		}

		///	åХåեμ
		ER_UINT receive(void* msg, forever_tag = forever) const
		{
			ER_UINT ercd = Stub::stub_rcv_mbf(objid_.id(), msg);
			return handle_error(ercd);
		}
		///	åХåեμʥݡ󥰡
		ER_UINT receive(void* msg, polling_tag) const
		{
			ER_UINT ercd = Stub::stub_prcv_mbf(objid_.id(), msg);
			return handle_error(ercd);
		}
		///	åХåեμʥॢȻ
		ER_UINT receive(void* msg, TMO tmout) const
		{
			ER_UINT ercd = Stub::stub_trcv_mbf(objid_.id(), msg, tmout);
			return handle_error(ercd);
		}

		//@}

		///	åХåե IDֹμ
		friend ID get_unsafe_id(const messagebuffer<Id, Diagnostics, Stub>& messagebuffer)
		{
			return messagebuffer.objid_.id();
		}
	};

}

#endif	// ! TOPPERS_MESSAGEBUFFER_HPP_
