/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: mutex.hpp,v 1.3 2004/01/26 00:53:45 takagi-n Exp $
 */

/**
 *	@file	toppers/mutex.hpp
 *	@brief	ߥ塼ƥå椹륯饹
 *
 *	 ΥإåեǤϰʲΥƥץ졼ȥ饹Ƥ롣
 *
 *	@code
 *	class mutex<Id, Diagnostics, Stub>;
 *	@endcode
 */

#ifndef	TOPPERS_MUTEX_HPP_
#define	TOPPERS_MUTEX_HPP_

#include <toppers/object.hpp>

namespace toppers
{

	/**
	 *	@class	mutex mutex.hpp <toppers/mutex.hpp>
	 *	@brief	ߥ塼ƥåεǽ򥫥ץ벽ƥץ졼ȥ饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 @e mutex ƥץ졼ȥ饹ϡߥ塼ƥåεǽ򥫥ץ벽
	 *	ƥȤԵˡѥ᡼뤿Υ󥿥ե󶡤롣
	 *	Υ饹󶡤륤󥿥եϡ¾Ʊ֥ȥ饹
	 *	򴹲ǽˤʤäƤ롣
	 *
	 *	@see	lock recursive_lock
	 */
	template <	ID Id			= 0,
				class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB	>
	class mutex : Diagnostics
	{
		typedef	object_controller<Id, obj_mutex, Stub>	controller;
		object_id<Id> objid_;

	public:
		///	ѥåȷ
		typedef	typename controller::creation	creation;
		///	ֻȥѥåȷ
		typedef	typename controller::reference	reference;

		/**	@name	󥹥ȥ饯	*/
		//@{

		///	ǥեȥ󥹥ȥ饯
		mutex() {}
		///	IDֹΥ󥹥ȥ饯
		explicit mutex(ID id) : objid_(id) {}

		///	ƥץ졼Ȱ㤤Ѵ󥹥ȥ饯
		template <ID Id2, class Diagnostics2, class Stub2>
		mutex(const mutex<Id2, Diagnostics2, Stub2>& other)
			: objid_(get_unsafe_id(other))
		{
			TOPPERS_STATIC_ASSERT(Id == 0);
		}

		//@}

		/**	@name	Ⱥ	*/
		//@{

		//	ߴΤ¿
		ER create(creation* pk_cobj)
		{
			ER ercd = controller::create(objid_, pk_cobj);
			return handle_error(ercd);
		}
		///	ߥ塼ƥå
		ER create(const creation* pk_cobj)
		{
			ER ercd = controller::create(objid_, pk_cobj);
			return handle_error(ercd);
		}
		///	ߥ塼ƥåʸ̤Υեɻ
		ER create(ATR mtxatr = TA_TFIFO, PRI ceilpri = 1)
		{
			creation packet;
			packet.mtxatr  = mtxatr;
			packet.ceilpri = ceilpri;
			return create(&packet);
		}
		///	ߥ塼ƥåκ
		ER destroy()
		{
			ER ercd = controller::destroy(objid_);
			return handle_error(ercd);
		}

		//@}

		/**	@name	ֻ	*/
		//@{

		///	ߥ塼ƥåξֻ
		ER refer(reference* pk_robj) const
		{
			ER ercd = controller::refer(objid_, pk_robj);
			return handle_error(ercd);
		}

		//@}

		/**	@name	å	*/
		//@{

		///	ߥ塼ƥåΥå
		ER lock(forever_tag = forever) const
		{
			ER ercd = Stub::stub_loc_mtx(objid_.id());
			return handle_error(ercd);
		}
		///	ߥ塼ƥåΥåʥݡ󥰡
		ER lock(polling_tag) const
		{
			ER ercd = Stub::stub_ploc_mtx(objid_.id());
			return handle_error(ercd);
		}
		///	ߥ塼ƥåΥåʥॢȻ
		ER lock(TMO tmout) const
		{
			ER ercd = Stub::stub_tloc_mtx(objid_.id(), tmout);
			return handle_error(ercd);
		}

		///	ߥ塼ƥåΥå
		ER unlock() const
		{
			ER ercd = Stub::stub_unl_mtx(objid_.id());
			return handle_error(ercd);
		}

		//@}

		///	ߥ塼ƥåIDֹμ
		friend ID get_unsafe_id(const mutex<Id, Diagnostics, Stub>& mutex)
		{
			return mutex.objid_.id();
		}
	};

	namespace detail
	{

		template <bool SenseKernel, class LockObj> class lock_helper;

		template <bool SenseKernel, ID Id, class Diagnostics, class Stub>
		class lock_helper<SenseKernel, mutex<Id, Diagnostics, Stub> >
		{
		public:
			typedef	mutex<Id, Diagnostics, Stub>	sync_type;

			static ER lock(const sync_type& sync)
			{
				return sense_kernel<SenseKernel>() ? E_OK : sync.lock();
			}
			static ER unlock(const sync_type& sync)
			{
				return sense_kernel<SenseKernel>() ? E_OK : sync.unlock();
			}
		};

	}

}

#endif	// ! TOPPERS_MUTEX_HPP_
