/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: overrunhandler.hpp,v 1.3 2004/01/26 00:53:45 takagi-n Exp $
 */

/**
 *	@file	toppers/overrunhandler.hpp
 *	@brief	Сϥɥ椹륯饹
 *
 *	 ΥإåեǤϰʲΥƥץ졼ȥ饹ӥƥץ졼ȴؿƤ롣
 *
 *	@code
 *	class overrunhandler<Diagnostics, Stub>;
 *	class overrunhandler_body<Diagnostics, Stub>;
 *	void overrunhandler_entry<Body>(ID, VP_INT);
 *	@endcode
 */

#ifndef	TOPPERS_OVERRUNHANDLER_HPP_
#define	TOPPERS_OVERRUNHANDLER_HPP_

#include <toppers/context.hpp>

namespace toppers
{

	template <class Body> void overrunhandler_entry(ID, VP_INT);

	template <class Diagnostics, class Stub> class overrunhandler_body;
	template <ID Id, class Diagnostics, class Stub> class task;

	/**
	 *	@class	overrunhandler overrunhandler.hpp <toppers/overrunhandler.hpp>
	 *	@brief	Сϥɥεǽ򥫥ץ벽ƥץ졼ȥ饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 @e overrunhandler ƥץ졼ȥ饹ϥ顼ϥɥФ򥫥ץ벽Ƥ롣\n
	 *	@e task Ʊ͡ϥɥν@e overrunhandler_body ƥץ졼ȥ饹饹Ȥ
	 *	Ҥɬפ롣
	 *
	 *	@see	overrunhandler_body overrunhandler_entry
	 */
	template <	class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB	>
	class overrunhandler : Diagnostics
	{
	public:
		///	ѥåȷ
		typedef	t_dovr	definition;
		///	ֻȾѥåȷ
		typedef	t_rovr	reference;
		///	ܥǥ饹
		typedef	overrunhandler_body<Diagnostics, Stub>	body;

		/**	@name	ϥɥ	*/
		//@{

		//	ߴΤ¿
		static ER define(definition* pk_dobj)
		{
			ER ercd = Stub::stub_def_ovr(pk_dobj);
			return static_handle_error(ercd);
		}
		///	Сϥɥ
		static ER define(const definition* pk_cobj)
		{
			ER ercd = Stub::stub_def_ovr(pk_dobj);
			return static_handle_error(ercd);
		}
		///	Сϥɥʸ̤Υեɻ
		static ER define(ATR ovratr, void (*ovrhdr)(ID, VP_INT))
		{
			definition packet;
			packet.ovratr = ovratr;
			packet.ovrhdr = FP(ovrhdr);
			return define(&packet);
		}
		///	Сϥɥʥܥǥ
		template <class Body>
		static ER define(ATR ovratr = 0)
		{
			return define(ovratr & ~TA_ASM | TA_HLNG, &overrunhandler_entry<Body>);
		}
		///	Сϥɥä
		static ER undefine()
		{
			return define(static_cast<definition*>(0));
		}

		//@}

		/**	@name	ֻ	*/
		//@{

		///	Сϥɥξֻ
		template <ID Id, class Diagnostics2, class Stub2>
		static ER refer(const task<Id, Diagnostics2, Stub2>& host, reference* pk_robj)
		{
			ER ercd = Stub::stub_ref_ovr(get_unsafe_id(host), pk_robj);
			return handle_error(ercd);
		}
		///	Ф륪Сϥɥξֻ
		static ER refer(reference* pk_robj)
		{
			ER ercd = Stub::stub_ref_ovr(TSK_SELF, pk_robj);
			return handle_error(ercd);
		}

		//@}

		/**	@name	ư	*/
		//@{

		///	Сϥɥεư
		template <ID Id, class Diagnostics2, class Stub2>
		static ER start(const task<Id, Diagnostics2, Stub2>& host, OVRTIM ovrtim)
		{
			ER ercd = Stub::stub_sta_ovr(get_unsafe_id(host), ovrtim);
			return handle_error(ercd);
		}
		///	Сϥɥ
		template <ID Id, class Diagnostics2, class Stub2>
		static ER stop(const task<Id, Diagnostics2, Stub2>& host)
		{
			ER ercd = Stub::stub_stp_ovr(get_unsafe_id(host));
			return handle_error(ercd);
		}

		///	Ф륪Сϥɥεư
		static ER start(OVRTIM ovrtim)
		{
			ER ercd = Stub::stub_sta_ovr(TSK_SELF, ovrtim);
			return handle_error(ercd);
		}
		///	Ф륪Сϥɥ
		static ER stop()
		{
			ER ercd = Stub::stub_stp_ovr(TSK_SELF);
			return handle_error(ercd);
		}

		//@}

	private:
		ID get_host_id() const
		{
			return get_unsafe_id(host_);
		}
	};

	/**
	 *	@class	overrunhandler_body overrunhandler.hpp <toppers/overrunhandler.hpp>
	 *	@brief	Сϥɥư쥯饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 Сϥɥ硢@e overrunhandler_body ƥץ졼ȥ饹 public
	 *	Ѿ饹η@e overrunhandler_entry ƥץ졼ȴؿΥƥץ졼
	 *	Ϥ
	 *
	 *	@see	overrunhandler overrunhandler_entry
	 */
	template <	class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB	>
	class overrunhandler_body : public non_task_context_body<Diagnostics, Stub>
	{
		task<0, Diagnostics, Stub> task_;
		VP_INT exinf_;

	protected:
		///	ǥȥ饯
		~overrunhandler_body() {}

	public:
		///	󥹥ȥ饯
		explicit overrunhandler_body(ID tskid, VP_INT exinf)
			: task_(tskid), exinf_(exinf)
		{
		}

		///	֥Ȥλ
		const task<0, Diagnostics, Stub>& get_task() const { return task_; }

		///	ĥμ
		VP_INT get_extended_info() const { return exinf_; }
	};

	/**
	 *	@brief	СϥɥΥƥץ졼
	 *	@ingroup	KernelObjectManager
	 *
	 *	 ƥץ졼Ȱ@e Body Ȥƻꤷܥǥ饹ΤȤ륪Сϥɥ롣
	 *	δؿ@e T_DOVR ¤Τ@e ovrhdr եɤꤹ뤳ȤǤ롣
	 *
	 *	@attention	@e DEF_OVR Ū API ˤФƻѤϡC󥱡δؿǰöåԥ󥰤뤳ȡ
	 *	@see	overrunhandler_body
	 */
	template <class Body>
	inline void overrunhandler_entry(ID tskid, VP_INT exinf)
	{
		Body body(tskid, exinf);
		body.run();
	}

}

#endif	// ! TOPPERS_OVERRUNHANDLER_HPP_
