/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: rendezvous.hpp,v 1.3 2004/01/26 00:53:45 takagi-n Exp $
 */

/**
 *	@file	toppers/rendezvous.hpp
 *	@brief	ǥ֤椹뤿Υ饹
 *
 *	 ΥإåեǤϰʲΥƥץ졼ȥ饹Ƥ롣
 *
 *	@code
 *	class rendezvous<Diagnostics, Stub>;
 *	class rendezvousport<Id, Diagnostics, Stub>;
 *	@endcode
 */

#ifndef	TOPPERS_RENDEZVOUS_HPP_
#define	TOPPERS_RENDEZVOUS_HPP_

#include <toppers/object.hpp>

namespace toppers
{

	/**
	 *	@class	rendezvous rendezvous.hpp <toppers/rendezvous.hpp>
	 *	@brief	ǥֹ򥫥ץ벽ƥץ졼ȥ饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 @e rendezvous ƥץ졼ȥ饹ϡǥֹεǽ򥫥ץ벽
	 *	Եˡѥ᡼뤿Υ󥿥ե󶡤롣
	 *
	 *	@see	rendezvousport
	 */
	template <	class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB	>
	class rendezvous : Diagnostics
	{
		RDVNO rdvno_;

	public:
		///	ֻȾѥåȷ
		typedef	t_rrdv	reference;

		///	ǥֹΥ󥹥ȥ饯
		explicit rendezvous(RDVNO rdvno = 0) : rdvno_(rdvno) {}

		///	ǥ֤ξֻ
		ER refer(reference* pk_robj) const
		{
			ER ercd = Stub::stub_ref_rdv(rdvno_, pk_robj);
			return handle_error(ercd);
		}

		///	ǥ֤
		ER reply(const void* msg, UINT rmsgsz)
		{
			ER ercd = Stub::stub_rpl_rdv(rdvno_, msg, rmsgsz);
			if (ercd == E_OK)
				rdvno_ = 0;
			return handle_error(ercd);
		}

		///	ǥֹμ
		RDVNO no() const { return rdvno_; }
		///	ǥֹδϢդ
		void attach(RDVNO rdvno) { rdvno_ = rdvno; }
	};

	/**
	 *	@class	rendezvousport rendezvous.hpp <toppers/rendezvous.hpp>
	 *	@brief	ǥ֥ݡȤεǽ򥫥ץ벽ƥץ졼ȥ饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 @e rendezvousport ƥץ졼ȥ饹ϡǥ֥ݡȤεǽ򥫥ץ벽
	 *	Եˡѥ᡼뤿Υ󥿥ե󶡤롣
	 *
	 *	@see	rendezvous
	 */
	template <	ID Id			= 0,
				class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB	>
	class rendezvousport : Diagnostics
	{
		typedef	object_controller<Id, obj_rendezvousport, Stub>	controller;
		object_id<Id> objid_;

	public:
		///	ѥåȷ
		typedef	typename controller::creation	creation;
		///	ֻȾѥåȷ
		typedef	typename controller::reference	reference;

		/**	@name	󥹥ȥ饯	*/
		//@{

		///	ǥեȥ󥹥ȥ饯
		rendezvousport() {}
		///	IDֹΥ󥹥ȥ饯
		explicit rendezvousport(ID id) : objid_(id) {}

		///	ƥץ졼Ȱ㤤Ѵ󥹥ȥ饯
		template <ID Id2, class Diagnostics2, class Stub2>
		rendezvousport(const rendezvousport<Id2, Diagnostics2, Stub2>& other)
			: objid_(get_unsafe_id(other))
		{
			TOPPERS_STATIC_ASSERT(Id == 0);
		}

		//@}

		/**	@name	Ⱥ	*/
		//@{

		//	ߴΤ¿
		ER create(creation* pk_cobj)
		{
			ER ercd = controller::create(objid_, pk_cobj);
			return handle_error(ercd);
		}
		///	ǥ֥ݡȤ
		ER create(const creation* pk_cobj)
		{
			ER ercd = controller::create(objid_, pk_cobj);
			return handle_error(ercd);
		}
		///	ǥ֥ݡȤʸ̤Υեɻ
		ER create(ATR poratr = TA_TFIFO, UINT maxcmsz = 256, UINT maxrmsz = 256)
		{
			creation packet;
			packet.poratr  = poratr;
			packet.maxcmsz = maxcmsz;
			packet.maxrmsz = maxrmsz;
			return create(&packet);
		}
		///	ǥ֥ݡȤκ
		ER destroy()
		{
			ER ercd = controller::destroy(objid_);
			return handle_error(ercd);
		}

		//@}

		/**	@name	ֻ	*/
		//@{

		///	ǥ֥ݡȤξֻ
		ER refer(reference* pk_robj) const
		{
			ER ercd = controller::refer(objid_, pk_robj);
			return handle_error(ercd);
		}

		//@}

		/**	@name	ǥ̿	*/
		//@{

		///	ǥ֤θƽФ
		ER_UINT call(RDVPTN calptn, void* msg, UINT cmsgsz, forever_tag = forever) const
		{
			ER_UINT ercd = Stub::stub_cal_por(objid_.id(), calptn, msg, cmsgsz);
			return handle_error(ercd);
		}
		///	ǥ֤θƽФʥॢȻ
		ER_UINT call(RDVPTN calptn, void* msg, UINT cmsgsz, TMO tmout) const
		{
			ER_UINT ercd = Stub::stub_tcal_por(objid_.id(), calptn, msg, cmsgsz, tmout);
			return handle_error(ercd);
		}

		///	ǥ֤μ
		template <class Diagnostics2, class Stub2>
		ER_UINT accept(RDVPTN acpptn, rendezvous<Diagnostics2, Stub2>& rdvobj, void* msg, forever_tag = forever) const
		{
			RDVNO rdvno;
			ER_UINT ercd = Stub::stub_acp_por(objid_.id(), acpptn, &rdvno, msg);
			rdvobj.attach(rdvno);
			return handle_error(ercd);
		}
		///	ǥ֤μաʥݡ󥰡
		template <class Diagnostics2, class Stub2>
		ER_UINT accept(RDVPTN acpptn, rendezvous<Diagnostics2, Stub2>& rdvobj, void* msg, polling_tag) const
		{
			RDVNO rdvno;
			ER_UINT ercd = Stub::stub_pacp_por(objid_.id(), acpptn, &rdvno, msg);
			rdvobj.attach(rdvno);
			return handle_error(ercd);
		}
		///	ǥ֤μաʥॢȻ
		template <class Diagnostics2, class Stub2>
		ER_UINT accept(RDVPTN acpptn, rendezvous<Diagnostics2, Stub2>& rdvobj, void* msg, TMO tmout) const
		{
			RDVNO rdvno;
			ER_UINT ercd = Stub::stub_tacp_por(objid_.id(), acpptn, &rdvno, msg, tmout);
			rdvobj.attach(rdvno);
			return handle_error(ercd);
		}

		///	ǥ֤β
		template <class Diagnostics2, class Stub2>
		ER forward(RDVPTN calptn, rendezvous<Diagnostics2, Stub2>& rdvobj, const void* msg, UINT cmsgsz) const
		{
			ER ercd = Stub::stub_fwd_por(objid_.id(), calptn, rdvobj.no(), msg, cmsgsz);
			return handle_error(ercd);
		}

		//@}

		///	ǥ֥ݡIDֹμ
		friend ID get_unsafe_id(const rendezvousport<Id, Diagnostics, Stub>& rendezvousport)
		{
			return rendezvousport.objid_.id();
		}
	private:
		//	äƥݡ󥰻ǸƽФȤػߤ
		ER_UINT call(RDVPTN calptn, void* msg, UINT cmsgsz, polling_tag) const;
	};

}

#endif	// ! TOPPERS_RENDEZVOUS_HPP_
