/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: semaphore.hpp,v 1.3 2004/01/26 00:53:45 takagi-n Exp $
 */

/**
 *	@file	toppers/semaphore.hpp
 *	@brief	ޥե椹륯饹
 *
 *	 ΥإåեǤϰʲΥƥץ졼ȥ饹Ƥ롣
 *
 *	@code
 *	class semaphore<Id, Diagnostics, Stub>;
 *	@endcode
 */

#ifndef	TOPPERS_SEMAPHORE_HPP_
#define	TOPPERS_SEMAPHORE_HPP_

#include <toppers/object.hpp>

namespace toppers
{

	/**
	 *	@class	semaphore semaphore.hpp <toppers/semaphore.hpp>
	 *	@brief	ޥեεǽ򥫥ץ벽ƥץ졼ȥ饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 @e semaphore ƥץ졼ȥ饹ϡޥեεǽ򥫥ץ벽
	 *	ƥȤԵˡѥ᡼뤿Υ󥿥ե󶡤롣
	 *	Υ饹󶡤륤󥿥եϡ¾Ʊ֥ȥ饹
	 *	򴹲ǽˤʤäƤ롣
	 *
	 *	@see	lock recursive_lock
	 */
	template <	ID Id			= 0,
				class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB	>
	class semaphore : Diagnostics
	{
		typedef	object_controller<Id, obj_semaphore, Stub>	controller;
		object_id<Id> objid_;

	public:
		///	ѥåȷ
		typedef	typename controller::creation	creation;
		///	ֻȾѥåȷ
		typedef	typename controller::reference	reference;

		/**	@name	󥹥ȥ饯	*/
		//@{

		///	ǥեȥ󥹥ȥ饯
		semaphore() {}
		///	IDֹΥ󥹥ȥ饯
		explicit semaphore(ID id) : objid_(id) {}

		///	ƥץ졼Ȱ㤤Ѵ󥹥ȥ饯
		template <ID Id2, class Diagnostics2, class Stub2>
		semaphore(const semaphore<Id2, Diagnostics2, Stub2>& other)
			: objid_(get_unsafe_id(other))
		{
			TOPPERS_STATIC_ASSERT(Id == 0);
		}

		//@}

		/**	@name	Ⱥ	*/
		//@{

		//	ߴΤ¿
		ER create(creation* pk_cobj)
		{
			ER ercd = controller::create(objid_, pk_cobj);
			return handle_error(ercd);
		}
		///	ޥե
		ER create(const creation* pk_cobj)
		{
			ER ercd = controller::create(objid_, pk_cobj);
			return handle_error(ercd);
		}
		///	ޥեʸ̤Υեɻ
		ER create(ATR sematr = TA_TFIFO, UINT isemcnt = 1, UINT maxsem = 1)
		{
			creation packet;
			packet.sematr  = sematr;
			packet.isemcnt = isemcnt;
			packet.maxsem  = maxsem;
			return create(&packet);
		}
		///	ޥեκ
		ER destroy()
		{
			ER ercd = controller::destroy(objid_);
			return handle_error(ercd);
		}

		//@}

		/**	@name	ֻ	*/
		//@{

		///	ޥեξֻ
		ER refer(reference* pk_robj) const
		{
			ER ercd = controller::refer(objid_, pk_robj);
			return handle_error(ercd);
		}

		//@}

		/**	@name	ޥե񸻤γֵ	*/
		//@{

		///	ޥե񸻤ֵ
		ER signal(task_context_tag = task_context) const
		{
			ER ercd = Stub::stub_sig_sem(objid_.id());
			return handle_error(ercd);
		}
		///	ޥե񸻤ֵѡ󥿥ƥȡ
		ER signal(non_task_context_tag) const
		{
			ER ercd = Stub::stub_isig_sem(objid_.id());
			return handle_error(ercd);
		}
		///	ޥե񸻤ֵѡʥƥ¸
		ER signal(context_independent_tag) const
		{
			ER ercd;
			if (Stub::stub_sns_ctx())
				ercd = Stub::stub_isig_sem(objid_.id());
			else
				ercd = Stub::stub_sig_sem(objid_.id());
			return handle_error(ercd);
		}

		///	ޥե񸻤γ
		ER wait(forever_tag = forever) const
		{
			ER ercd = Stub::stub_wai_sem(objid_.id());
			return handle_error(ercd);
		}
		///	ޥե񸻤γʥݡ󥰡
		ER wait(polling_tag) const
		{
			ER ercd = Stub::stub_pol_sem(objid_.id());
			return handle_error(ercd);
		}
		///	ޥե񸻤γʥॢȻ
		ER wait(TMO tmout) const
		{
			ER ercd = Stub::stub_twai_sem(objid_.id(), tmout);
			return handle_error(ercd);
		}

		//@}

		///	ޥեIDֹμ
		friend ID get_unsafe_id(const semaphore<Id, Diagnostics, Stub>& semaphore)
		{
			return semaphore.objid_.id();
		}
	};

	namespace detail
	{

		template <bool SenseKernel, class LockObj> class lock_helper;

		template <bool SenseKernel, ID Id, class Diagnostics, class Stub>
		class lock_helper<SenseKernel, semaphore<Id, Diagnostics, Stub> >
		{
		public:
			typedef	semaphore<Id, Diagnostics, Stub>	sync_type;

			static ER lock(const sync_type& sync)
			{
				return sense_kernel<SenseKernel>() ? E_OK : sync.wait();
			}
			static ER unlock(const sync_type& sync)
			{
				return sense_kernel<SenseKernel>() ? E_OK : sync.signal();
			}
		};

	}

}

#endif	// ! TOPPERS_SEMAPHORE_HPP_
