/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: sync.hpp,v 1.3 2004/01/26 00:53:45 takagi-n Exp $
 */

/**
 *	@file	toppers/sync.hpp
 *	@brief	Ʊ˴ؤ륯饹
 *
 *	 ΥإåեǤϰʲΥƥץ졼ȥ饹ӥƥץ졼ȴؿƤ롣
 *
 *	@code
 *	class lock<LockObj, SenseKernel>;
 *	class recursive_lock<LockObj, SenseKernel>;
 *	T& sync_increment<LockObj, T>(T&);
 *	T& sync_decrement<LockObj, T>(T&);
 *	void sync_swap<LockObj, T>(T&, T&);
 *	@endcode
 */

#ifndef	TOPPERS_SYNC_HPP_
#define	TOPPERS_SYNC_HPP_

#include <toppers/kernel.hpp>
#include <toppers/assert.hpp>

namespace toppers
{

	namespace detail
	{
		template <bool SenseKernel, class LockObj> class lock_helper;
	}

	template <ID Id, class Diagnostics, class Stub> class semaphore;
	template <ID Id, class Diagnostics, class Stub> class mutex;

	/**
	 *	@class	lock sync.hpp <toppers/sync.hpp>
	 *	@brief	ƥ륻뤿Υƥץ졼ȥ饹
	 *	@ingroup	Syncronization
	 *
	 *	 㳰ʥƥ륻򡢻ꤷåѤ롣
	 *	Ѥ򤱤뤿ᡢΥ饹Ǥϥݡ󥰤䥿ॢȻϥݡȤʤ
	 *
	 *	 ƥץ졼Ȱ@e LockObj ˤϡ@e semaphore @e mutex ޤ@e cpulock
	 *	ꤹ뤳ȤǤ롣@e LockObj @e void ꤷˤϡ
	 *	ºݤˤϥƥ륻ʤ
	 *
	 *	 ƥץ졼Ȱ@e Sensekernel ϡƥ륻ˤꡢ
	 *	ͽᥫͥư֤@e vsns_ini ˤäƻȤ뤫ɤꤹ뤳ȤǤ롣
	 *	@e SenseKernel @e true ǤХͥư֤Ȥ롣
	 *
	 *	@attention	ǥեȤǤ@e SenseKernel @e false ˤʤäƤ뤿ᡢ
	 *				ͥ뤬ưƤɬפ롣
	 *	@see	recursive_lock
	 */
	template <class LockObj, bool SenseKernel = false>
	class lock
	{
		LockObj lock_;

	public:
		///	ǥեȥ󥹥ȥ饯
		lock()
		{
			detail::lock_helper<SenseKernel, LockObj>::lock(lock_);
		}
		///	ѥ᡼Υ󥹥ȥ饯
		template <typename T>
		explicit lock(T arg)
			: lock_(arg)
		{
			detail::lock_helper<SenseKernel, LockObj>::lock(lock_);
		}
		///	ǥȥ饯
		~lock() throw()
		{
			detail::lock_helper<SenseKernel, LockObj>::unlock(lock_);
		}
	};

	template <bool SenseKernel>
	class lock<void, SenseKernel>
	{
		lock()
		{
		}
		template <typename T>
		explicit lock(T arg)
		{
		}
	};

	/**
	 *	@class	recursive_lock sync.hpp <toppers/sync.hpp>
	 *	@brief	ͥȲǽʥƥ륻뤿Υƥץ졼ȥ饹
	 *	@ingroup	Syncronization
	 *
	 *	㳰ʥƥ륻򡢻ꤷåѤ롣
	 *	@ref lock ƥץ졼ȥ饹Ȥϰۤʤꡢܥ饹Ǥϥͥƥ󥰤ǽǤ롣
	 *	Ѥ򤱤뤿ᡢΥ饹Ǥϥݡ󥰤䥿ॢȻϥݡȤʤ
	 *
	 *	 ƥץ졼Ȱ@e LockObj ˤϡ@e semaphore @e mutex ޤ@e cpulock
	 *	ꤹ뤳ȤǤ롣@e LockObj @e void ꤷˤϡ
	 *	ºݤˤϥƥ륻ʤ
	 *
	 *	 ƥץ졼Ȱ@e Sensekernel ϡƥ륻ˤꡢ
	 *	ͽᥫͥư֤@e vsns_ini ˤäƻȤ뤫ɤꤹ뤳ȤǤ롣
	 *	@e SenseKernel @e true ǤХͥư֤Ȥ롣
	 *
	 *	@attention	ǥեȤǤ@e SenseKernel @e false ˤʤäƤ뤿ᡢ
	 *				ͥ뤬ưƤɬפ롣
	 *	@see	lock
	 */
	template <class LockObj, bool SenseKernel = false>
	class recursive_lock
	{
		bool state_;
		LockObj lock_;

	public:
		///	ǥեȥ󥹥ȥ饯
		recursive_lock()
		{
			state_ = detail::lock_helper<SenseKernel, LockObj>::sense(lock_);
			if (!state_)
				detail::lock_helper<SenseKernel, LockObj>::lock(lock_);
		}
		///	ѥ᡼Υ󥹥ȥ饯
		template <typename T>
		explicit recursive_lock(T arg)
			: lock_(arg)
		{
			state_ = detail::lock_helper<SenseKernel, LockObj>::sense(lock_);
			if (!state_)
				detail::lock_helper<SenseKernel, LockObj>::lock(lock_);
		}
		///	ǥȥ饯
		~recursive_lock() throw()
		{
			if (!state_)
				detail::lock_helper<SenseKernel, LockObj>::unlock(lock_);
		}
	};

	template <bool SenseKernel>
	class recursive_lock<void, SenseKernel>
	{
		recursive_lock()
		{
		}
		template <typename T>
		explicit recursive_lock(T arg)
		{
		}
	};

	namespace detail
	{

		template <class LockObj, ID Id, class Stub, bool SenseKernel>
		class recursive_lock_helper
		{
			TOPPERS_STATIC_ASSERT(Id > 0);
			LockObj lock_;
			static ID   holder_;
			static UINT counter_;

		public:
			recursive_lock_helper()
			{
				if (!sense_kernel<SenseKernel>() && !Stub::stub_sns_dsp())
				{
					ID tskid;
					Stub::stub_get_tid(&tskid);
					if (holder_ != tskid)
					{
						detail::lock_helper<false, LockObj>::lock(lock_);
						holder_ = tskid;
					}
					++counter_;
				}
			}
			~recursive_lock_helper() throw()
			{
				if (!sense_kernel<SenseKernel>() && !Stub::stub_sns_dsp())
				{
					if (--counter_ == 0)
					{
						holder_ = 0;
						detail::lock_helper<false, LockObj>::unlock(lock_);
					}
				}
			}
		};

		template <class LockObj, ID Id, class Stub, bool SenseKernel>
		ID	recursive_lock_helper<LockObj, Id, Stub, SenseKernel>::holder_ = 0;

		template <class LockObj, ID Id, class Stub, bool SenseKernel>
		UINT	recursive_lock_helper<LockObj, Id, Stub, SenseKernel>::counter_ = 0;

	}

	template <ID Id, class Diagnostics, class Stub, bool SenseKernel>
	class recursive_lock<semaphore<Id, Diagnostics, Stub>, SenseKernel>
		: detail::recursive_lock_helper<semaphore<Id, Diagnostics, Stub>, Id, Stub, SenseKernel>
	{
	};

	template <ID Id, class Diagnostics, class Stub, bool SenseKernel>
	class recursive_lock<mutex<Id, Diagnostics, Stub>, SenseKernel>
		: detail::recursive_lock_helper<mutex<Id, Diagnostics, Stub>, Id, Stub, SenseKernel>
	{
	};

	/**
	 *	@brief	ƱդΥ󥯥
	 *	@ingroup	Syncronization
	 *	@param	x:	󥯥Ȥ륪֥
	 *	@return	@e x ֤
	 *
	 *	 ƥץ졼Ȱ@e LockObj ǻꤷƱ֥ȡ@e semaphore  @e mutex 
	 *	@e cpulock ˤˤä줿ƥ륻ǡ@e x  ++
	 *	黻Ҥˤäƥ󥯥Ȥ롣@e LockObj ξܺ٤ˤĤƤ@ref lock 򻲾ȤΤȡ
	 *
	 *	@remarks	++ 黻Ҥ¿뤳Ȥǡñʥ󥯥Ȱʳư¸Ǥ롣
	 *	@attention	δؿϥͥư֤ǤϻѤǤʤ
	 *	@see	sync_decrement	sync_swap
	 */
	template <class LockObj, typename T>
	inline T& sync_increment(T& x)
	{
		lock<LockObj> loc;
		return ++x;
	}

	/**
	 *	@brief	ƱդΥǥ
	 *	@ingroup	Syncronization
	 *	@param	x:	ǥȤ륪֥
	 *	@return	@e x ֤
	 *
	 *	 ƥץ졼Ȱ@e LockObj ǻꤷƱ֥ȡ@e semaphore  @e mutex 
	 *	@e cpulock ˤˤä줿ƥ륻ǡ@e x  --
	 *	黻ҤˤäƥǥȤ롣@e LockObj ξܺ٤ˤĤƤ@ref lock 򻲾ȤΤȡ
	 *
	 *	@remarks	-- 黻Ҥ¿뤳ȤǡñʥǥȰʳư¸Ǥ롣
	 *	@attention	δؿϥͥư֤ǤϻѤǤʤ
	 *	@see	sync_increment	sync_swap
	 */
	template <class LockObj, typename T>
	inline T& sync_decrement(T& x)
	{
		lock<LockObj> loc;
		return --x;
	}

	/**
	 *	@brief	ƱդΥåסͤؤ
	 *	@ingroup	Syncronization
	 *	@param	x:	åפ뤹Υ֥
	 *	@param	y:	åפ뤹⤦Υ֥
	 *
	 *	 ƥץ졼Ȱ@e LockObj ǻꤷƱ֥ȡ@e semaphore  @e mutex 
	 *	@e cpulock ˤˤä줿ƥ륻ǡ@e x  @e y
	 *	ͤؤ롣@e LockObj ξܺ٤ˤĤƤ@ref lock 򻲾ȤΤȡ
	 *
	 *	@remarks	ԡ󥹥ȥ饯黻ҤѤƼƤ뤿ᡢ
	 *				Ǥϡñͤؤʳư¸Ǥ롣
	 *	@attention	δؿϥͥư֤ǤϻѤǤʤ
	 *	@see	sync_increment	sync_decrement
	 */
	template <class LockObj, typename T>
	inline void sync_swap(T& x, T& y)
	{
		lock<LockObj> loc;
		T t = x;
		x = y;
		y = t;
	}

}

#endif	// ! TOPPERS_SYNC_HPP_
