/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: task.hpp,v 1.3 2004/01/26 00:53:45 takagi-n Exp $
 */

/**
 *	@file	toppers/task.hpp
 *	@brief	椹뤿Υ饹
 *
 *	 ΥإåեǤϰʲΥƥץ졼ȥ饹ӥƥץ졼ȴؿƤ롣
 *
 *	@code
 *	class task<Id, Diagnostics, Stub>;
 *	class task_body<Diagnostics, Stub>;
 *	void task_entry<Body>(VP_INT);
 *	@endcode
 */

#ifndef	TOPPERS_TASK_HPP_
#define	TOPPERS_TASK_HPP_

#include <toppers/context.hpp>
#include <exception>

#ifdef	STACKSIZE
#define	TOPPERS_STACKSIZE	STACKSIZE
#else
#define	TOPPERS_STACKSIZE	1024
#endif

namespace toppers
{

	template <class Body> void task_entry(VP_INT);

	template <class Diagnostics, class Stub> class task_body;

	/**
	 *	@class	task task.hpp <toppers/task.hpp>
	 *	@brief	ǽ򥫥ץ벽ƥץ졼ȥ饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 @e task ƥץ졼ȥ饹ϡȤưۤʤ륿Ф򥫥ץ벽Ƥ롣
	 *	Фϡ@e task_body  @e taskexception_body ΥдؿѤΤȡ\n
	 *	ܳǰƥץ졼Ȱΰ̣ˤĤƤϡ@ref KernelObjectManager "ͥ륪֥ȴ"
	 *	򻲾ȤΤȡ
	 *
	 *	@see	task_body
	 */
	template <	ID Id			= 0,
				class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB	>
	class task : Diagnostics
	{
		typedef	object_controller<Id, obj_task, Stub>	controller;
		object_id<Id> objid_;

	public:
		///	ѥåȷ
		typedef	typename controller::creation	creation;
		///	ֻȾѥåȷ
		typedef	typename controller::reference	reference;
		///	ֻȾѥåȷʴʰǡ
		typedef	t_rtst	easy_reference;
		///	Ѥδ쥯饹
		typedef	task_body<Diagnostics, Stub>	body;

		/**	@name	󥹥ȥ饯	*/
		//@{

		///	ǥեȥ󥹥ȥ饯
		task() {}
		///	IDֹΥ󥹥ȥ饯
		explicit task(ID id) : objid_(id) {}

		///	ƥץ졼ȼ°㤤¾Υ֥ȤѴ󥹥ȥ饯
		template <ID Id2, class Diagnostics2, class Stub2>
		task(const task<Id2, Diagnostics2, Stub2>& other)
			: objid_(get_unsafe_id(other))
		{
			TOPPERS_STATIC_ASSERT(Id == 0);
		}

		//@}

		/**	@name	Ⱥ	*/
		//@{

		//	ߴΤ¿
		ER create(creation* pk_cobj)
		{
			ER ercd = controller::create(objid_, pk_cobj);
			return handle_error(ercd);
		}
		///	
		ER create(const creation* pk_cobj)
		{
			ER ercd = controller::create(objid_, pk_cobj);
			return handle_error(ercd);
		}
		///	ʸ̤Υեɻ
		ER create(ATR tskatr, VP_INT exinf, void (*task)(VP_INT), PRI itskpri = (TMIN_TPRI + TMAX_TPRI) / 2, SIZE stksz = TOPPERS_STACKSIZE, VP stk = 0)
		{
			creation packet;
			packet.tskatr  = tskatr;
			packet.exinf   = exinf;
			packet.task    = FP(task);
			packet.itskpri = itskpri;
			packet.stksz   = stksz;
			packet.stk     = stk;
			return create(&packet);
		}
		///	ʥܥǥ
		template <class Body>
		ER create(ATR tskatr = TA_ACT, VP_INT exinf = 0, PRI itskpri = (TMIN_TPRI + TMAX_TPRI) / 2, SIZE stksz = TOPPERS_STACKSIZE, VP stk = 0)
		{
			return create(tskatr & ~TA_ASM | TA_HLNG, exinf, &task_entry<Body>, itskpri, stksz, stk);
		}
		///	κ
		ER destroy()
		{
			ER ercd = controller::destroy(objid_);
			return handle_error(ercd);
		}

		//@}

		/**	@name	ֻ	*/
		//@{

		///	ξֻ
		ER refer(reference* pk_robj) const
		{
			ER ercd = controller::refer(objid_, pk_robj);
			return handle_error(ercd);
		}
		///	ξֻȡʴʰǡ
		ER refer(easy_reference* pk_robj) const
		{
			ER ercd = Stub::stub_ref_tst(objid_.id(), pk_robj);
			return handle_error(ercd);
		}

		//@}

		/**	@name	ǽ	*/
		//@{

		///	εư
		ER activate(task_context_tag = task_context) const
		{
			ER ercd = Stub::stub_act_tsk(objid_.id());
			return handle_error(ercd);
		}
		///	εư󥿥ƥȡ
		ER activate(non_task_context_tag) const
		{
			ER ercd = Stub::stub_iact_tsk(objid_.id());
			return handle_error(ercd);
		}
		///	εưʥƥ¸
		ER activate(context_independent_tag) const
		{
			ER ercd;
			if (Stub::stub_sns_ctx())
				ercd = Stub::stub_iact_tsk(objid_.id());
			else
				ercd = Stub::stub_act_tsk(objid_.id());
			return handle_error(ercd);
		}
		///	εưʵưɻ
		ER activate(VP_INT exinf) const
		{
			ER ercd = Stub::stub_sta_tsk(objid_.id(), exinf);
			return handle_error(ercd);
		}
		///	ư׵Υ󥻥
		ER_UINT cancel_activation() const
		{
			ER_UINT ercd = Stub::stub_can_act(objid_.id());
			return handle_error(ercd);
		}

		///	ζλ
		ER terminate() const
		{
			ER ercd = Stub::stub_ter_tsk(objid_.id());
			return handle_error(ercd);
		}

		///	ͥ٤ѹ
		ER change_priority(PRI tskpri) const
		{
			ER ercd = Stub::stub_chg_pri(objid_.id(), tskpri);
			return handle_error(ercd);
		}
		///	ͥ٤λ
		ER get_priority(PRI* p_tskpri) const
		{
			ER ercd = Stub::stub_get_pri(objid_.id(), p_tskpri);
			return handle_error(ercd);
		}

		//@}

		/**	@name	°Ʊǽ	*/
		//@{

		///	ε
		ER wakeup(task_context_tag = task_context) const
		{
			ER ercd = Stub::stub_wup_tsk(objid_.id());
			return handle_error(ercd);
		}
		///	ε󥿥ƥȡ
		ER wakeup(non_task_context_tag) const
		{
			ER ercd = Stub::stub_iwup_tsk(objid_.id());
			return handle_error(ercd);
		}
		///	εʥƥ¸
		ER wakeup(context_independent_tag) const
		{
			ER ercd;
			if (Stub::stub_sns_ctx())
				ercd = Stub::stub_iwup_tsk(objid_.id());
			else
				ercd = Stub::stub_wup_tsk(objid_.id());
			return handle_error(ercd);
		}
		///	׵Υ󥻥
		ER_UINT cancel_wakeup() const
		{
			ER_UINT ercd = Stub::stub_can_wup(objid_.id());
			return handle_error(ercd);
		}

		///	Ԥ֤ζ
		ER release_wait(task_context_tag = task_context) const
		{
			ER ercd = Stub::stub_rel_wai(objid_.id());
			return handle_error(ercd);
		}
		///	Ԥ֤ζ󥿥ƥȡ
		ER release_wait(non_task_context_tag) const
		{
			ER ercd = Stub::stub_irel_wai(objid_.id());
			return handle_error(ercd);
		}
		///	Ԥ֤ζʥƥ¸
		ER release_wait(context_independent_tag) const
		{
			ER ercd;
			if (Stub::stub_sns_ctx())
				ercd = Stub::stub_irel_wai(objid_.id());
			else
				ercd = Stub::stub_rel_wai(objid_.id());
			return handle_error(ercd);
		}

		///	Ԥ֤ؤΰܹ
		ER suspend() const
		{
			ER ercd = Stub::stub_sus_tsk(objid_.id());
			return handle_error(ercd);
		}
		///	Ԥ֤κƳ
		ER resume(normal_tag = normal) const
		{
			ER ercd = Stub::stub_rsm_tsk(objid_.id());
			return handle_error(ercd);
		}
		///	Ԥ֤ζƳ
		ER resume(forced_tag) const
		{
			ER ercd = Stub::stub_frsm_tsk(objid_.id());
			return handle_error(ercd);
		}

		//@}

		///	IDֹμ
		friend ID get_unsafe_id(const task<Id, Diagnostics, Stub>& task)
		{
			return task.objid_.id();
		}
	};

	/**
	 *	@class	task_body task.hpp <toppers/task.hpp>
	 *	@brief	ΤΥǡư쥯饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 硢@e task_body ƥץ졼ȥ饹 public Ѿ
	 *	饹η@e task_entry ƥץ졼ȴؿΥƥץ졼Ȱ
	 *	Ϥ
	 *
	 *	@include	task_body.h
	 *	@include	task_body.cpp
	 *	@include	task_body.cfg
	 *	@see	task task_entry task_body::terminator
	 */
	template <	class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB	>
	class task_body : public task_context_body<Diagnostics, Stub>
	{
		task<0, Diagnostics, Stub> task_;

	protected:
		///	ǥȥ饯
		~task_body() {}

	public:
		class terminator;

		///	ĥ륳󥹥ȥ饯
		explicit task_body(VP_INT exinf)
			: task_context_body<Diagnostics, Stub>(exinf), task_(get_task_id())
		{
		}

		///	֥Ȥλ
		const task<0, Diagnostics, Stub>& get_task() const
		{
			return task_;
		}

		/**
		 *	@brief	νλ
		 *
		 *	 λ롣
		 *	ư줿󥹥󥹤Υǥȥ饯μ¤˸ƽФᡢ
		 *	ľ@e ext_tsk ƽФΤǤϤʤ㳰򥹥Ƥ롣\n
		 *	 @e task_entry Ѥ㳰å뤬
		 *	ȥؿ򼫺ϴؿΥȥåץ٥㳰򥭥å
		 *	ɬפ롣
		 *
		 *	@throw	task_body::terminator
		 *	@see	task_entry
		 */
		static void exit()
		{
			terminator term(Stub::stub_ext_tsk);
			throw term;
		}
		/**
		 *	@brief	νλȺ
		 *
		 *	 λ塢롣
		 *	ư줿󥹥󥹤Υǥȥ饯μ¤˸ƽФᡢ
		 *	ľ@e exd_tsk ƽФΤǤϤʤ㳰򥹥Ƥ롣\n
		 *	 @e task_entry Ѥ㳰å뤬
		 *	ȥؿ򼫺ϴؿΥȥåץ٥㳰򥭥å
		 *	ɬפ롣
		 *
		 *	@throw	task_body::terminator
		 *	@see	task_entry
		 */
		static void exit_and_destroy()
		{
			terminator term(Stub::stub_exd_tsk);
			throw term;
		}
	};

	/**
	 *	@class	task_body<Diagnostics, Stub>::terminator task.hpp <toppers/task.hpp>
	 *	@brief	λ˥㳰饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 @e task_body::terminater 饹ϡ@e task_body::exit ޤ@e task_body::exit_and_destroy
	 *	дؿ饹㳰饹Ǥ롣
	 *	Υ饹Υ󥹥ȥ饯ǻꤵ줿λؿ㳰֥Ȥå줿˼¹Ԥ롣
	 *
	 *	@see	task_body::exit
	 */
	template <class Diagnostics, class Stub>
	class task_body<Diagnostics, Stub>::terminator
	{
	public:
		///	󥹥ȥ饯
		explicit terminator(void (*exit_proc)()) : exit_proc_(exit_proc) {}

		///	λؿλ
		void (*get_exit_proc())() const
		{
			return exit_proc_;
		}

	private:
		void (*exit_proc_)();
	};

#ifndef	TOPPERS_TASK_INITIALIZE
#define	TOPPERS_TASK_INITIALIZE()	((void)0)
#endif

	/**
	 *	@brief	εưϤȤƻꤹ뤿Υƥץ졼ȴؿ
	 *	@ingroup	KernelObjectManager
	 *
	 *	 ƥץ졼Ȱ@e Body Ȥƻꤷܥǥ饹ΤȤ륿롣
	 *	δؿ@e T_CTSK ¤Τ@e task եɤꤹ뤳ȤǤ롣
	 *
	 *	@attention	@e CRE_TSK Ū API ˤФƻѤϡC󥱡δؿǰöåԥ󥰤뤳ȡ
	 *	@see	task_body
	 */
	template <class Body>
	inline void task_entry(VP_INT exinf)
	{
		TOPPERS_TASK_INITIALIZE();
		void (*exit_proc)() = 0;
		try
		{
			Body body(exinf);
			body.run();
		}
		catch (typename Body::terminator& e)
		{
			exit_proc = e.get_exit_proc();
		}
		catch (...)
		{
			std::terminate();
		}
		if (exit_proc != 0)
			(*exit_proc)();
	}

}

#endif	// ! TOPPERS_TASK_HPP_
