/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: taskexception.hpp,v 1.3 2004/01/26 00:53:45 takagi-n Exp $
 */

/**
 *	@file	toppers/taskexception.hpp
 *	@brief	㳰椹륯饹
 *
 *	 ΥإåեǤϰʲΥƥץ졼ȥ饹ӥƥץ졼ȴؿƤ롣
 *
 *	@code
 *	class taskexception<Diagnostics, Stub>;
 *	class taskexception_body<Diagnostics, Stub>;
 *	void taskexception_entry<Body>(TEXPTN, VP_INT);
 *	@endcode
 */

#ifndef	TOPPERS_TASKEXCEPTION_HPP_
#define	TOPPERS_TASKEXCEPTION_HPP_

#include <toppers/context.hpp>

namespace toppers
{

	template <class Body> void taskexception_entry(TEXPTN texptn, VP_INT exinf);

	template <ID Id, class Diagnostics, class Stub> class task;
	template <class Diagnostics, class Stub> class taskexception_body;

	/**
	 *	@class	taskexception taskexception.hpp <toppers/taskexception.hpp>
	 *	@brief	㳰ǽ򥫥ץ벽ƥץ졼ȥ饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 @e taskexception ƥץ졼ȥ饹ϡITRON 4.0ͤΥ㳰ǽ򥫥ץ벽Ƥ롣
	 *	Υ饹ΥдؿŪдؿȤƼƤ롣
	 *	ޤۤȤɤΥдؿ@e task ƥץ졼ȥ饹ؤλȤȤϤѤΤΤȡ
	 *	@e task ؤλȤϤʤѤΤΤ롣
	 *
	 *	@warning	C++Ǥϥ㳰ɬǤϤʤѤ˺ݤƤϿŤ˸Ƥ뤳ȡ
	 *	@see	taskexception_body
	 */
	template <	class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB	>
	class taskexception : Diagnostics
	{
	public:
		///	ѥåȷ
		typedef	t_dtex	definition;
		///	ֻȾѥåȷ
		typedef	t_rtex	reference;
		///	ܥǥ饹
		typedef	taskexception_body<Diagnostics, Stub>	body;

		/**	@name	㳰롼	*/
		//@{

		//	֤ͥθߴΤ¿
		template <ID Id, class Diagnostics2, class Stub2>
		static ER define(const task<Id, Diagnostics2, Stub2>& host, definition* pk_dobj)
		{
			ER ercd = Stub::stub_def_tex(get_unsafe_id(host), pk_dobj);
			return static_handle_error(ercd);
		}
		///	㳰롼
		template <ID Id, class Diagnostics2, class Stub2>
		static ER define(const task<Id, Diagnostics2, Stub2>& host, const definition* pk_cobj)
		{
			ER ercd = Stub::stub_def_tex(get_unsafe_id(host), pk_dobj);
			return static_handle_error(ercd);
		}
		///	㳰롼ʸ̤Υեɻ
		template <ID Id, class Diagnostics2, class Stub2>
		static ER define(const task<Id, Diagnostics2, Stub2>& host, ATR texatr, void (*texrtn)(TEXPTN, VP_INT))
		{
			definition packet;
			packet.texatr = texatr;
			packet.texrtn = FP(texrtn);
			return define(host, &packet);
		}
		///	㳰롼ʥܥǥ
		template <class Body, ID Id, class Diagnostics2, class Stub2>
		static ER define(const task<Id, Diagnostics2, Stub2>& host, ATR texatr = 0)
		{
			return define(host, texatr & ~TA_ASM | TA_HLNG, &taskexception_entry<Body>);
		}

		//	Ф륫֤ͥθߴΤ¿
		static ER define(definition* pk_dobj)
		{
			ER ercd = Stub::stub_def_tex(TSK_SELF, pk_dobj);
			return static_handle_error(ercd);
		}
		///	Ф륿㳰롼
		static ER define(const definition* pk_cobj)
		{
			ER ercd = Stub::stub_def_tex(TSK_SELF, pk_dobj);
			return static_handle_error(ercd);
		}
		///	Ф륿㳰롼ʸ̤Υեɻ
		static ER define(ATR texatr, void (*texrtn)(TEXPTN, VP_INT))
		{
			definition packet;
			packet.texatr = texatr;
			packet.texrtn = FP(texrtn);
			return define(&packet);
		}
		///	Ф륿㳰롼ʥܥǥ
		template <class Body>
		static ER define(ATR texatr = 0)
		{
			return define(texatr & ~TA_ASM | TA_HLNG, &taskexception_entry<Body>);
		}

		///	㳰롼ä
		template <ID Id, class Diagnostics2, class Stub2>
		static ER undefine(const task<Id, Diagnostics2, Stub2>& host)
		{
			return define(host, static_cast<definition*>(0));
		}
		///	Ф륿㳰롼ä
		static ER undefine()
		{
			return define(static_cast<definition*>(0));
		}

		//@{

		/**	@name	ֻ	*/
		//@{

		///	㳰ξֻ
		template <ID Id, class Diagnostics2, class Stub2>
		static ER refer(const task<Id, Diagnostics2, Stub2>& host, reference* pk_robj)
		{
			ER ercd = Stub::stub_ref_tex(get_unsafe_id(host), pk_robj);
			return static_handle_error(ercd);
		}
		///	Ф륿㳰ξֻ
		static ER refer(reference* pk_robj)
		{
			ER ercd = Stub::stub_ref_tex(TSK_SELF, pk_robj);
			return static_handle_error(ercd);
		}

		//@}

		/**	@name	㳰׵	*/
		//@{

		///	㳰׵
		template <ID Id, class Diagnostics2, class Stub2>
		static ER raise(const task<Id, Diagnostics2, Stub2>& host, TEXPTN rasptn, task_context_tag = task_context)
		{
			ER ercd = Stub::stub_ras_tex(get_unsafe_id(host), rasptn);
			return static_handle_error(ercd);
		}
		///	㳰׵󥿥ƥȡ
		template <ID Id, class Diagnostics2, class Stub2>
		static ER raise(const task<Id, Diagnostics2, Stub2>& host, TEXPTN rasptn, non_task_context_tag)
		{
			ER ercd = Stub::stub_iras_tex(get_unsafe_id(host), rasptn);
			return static_handle_error(ercd);
		}
		///	㳰׵ʥƥ¸
		template <ID Id, class Diagnostics2, class Stub2>
		static ER raise(const task<Id, Diagnostics2, Stub2>& host, TEXPTN rasptn, context_independent_tag)
		{
			ER ercd;
			if (Stub::stub_sns_ctx())
				ercd = Stub::stub_iras_tex(get_unsafe_id(host), rasptn);
			else
				ercd = Stub::stub_ras_tex(get_unsafe_id(host), rasptn);
			return static_handle_error(ercd);
		}

		///	Ф륿㳰׵
		static ER raise(TEXPTN rasptn, task_context_tag = task_context)
		{
			ER ercd = Stub::stub_ras_tex(TSK_SELF, rasptn);
			return static_handle_error(ercd);
		}
		///	Ф륿㳰׵󥿥ƥȡ
		static ER raise(TEXPTN rasptn, non_task_context_tag)
		{
			ER ercd = Stub::stub_iras_tex(TSK_SELF, rasptn);
			return static_handle_error(ercd);
		}
		///	Ф륿㳰׵ʥƥ¸
		static ER raise(TEXPTN rasptn, context_independent_tag)
		{
			ER ercd;
			if (Stub::stub_sns_ctx())
				ercd = Stub::stub_iras_tex(TSK_SELF, rasptn);
			else
				ercd = Stub::stub_ras_tex(TSK_SELF, rasptn);
			return static_handle_error(ercd);
		}

		//@{

		/**	@name	ػߤȵ	*/
		//@{

		///	㳰ζػ
		static ER disable()
		{
			ER ercd = Stub::stub_dis_tex();
			return static_handle_error(ercd);
		}
		///	㳰ε
		static ER enable()
		{
			ER ercd = Stub::stub_ena_tex();
			return static_handle_error(ercd);
		}
		///	㳰ػ߾֤λ
		static bool sense()
		{
			return Stub::stub_sns_tex();
		}

		//@}
	};

	namespace detail
	{

		template <bool SenseKernel, class LockObj> class lock_helper;

		template <bool SenseKernel, class Diagnostics, class Stub>
		class lock_helper<SenseKernel, taskexception<Diagnostics, Stub> >
		{
		public:
			typedef	taskexception<Diagnostics, Stub>	sync_type;

			static bool sense(const sync_type& sync)
			{
				return sense_kernel<SenseKernel>() ? true : sync_type::sense();
			}
			static ER lock(const sync_type& sync)
			{
				return sense_kernel<SenseKernel>() ? E_OK : sync_type::disable();
			}
			static ER unlock(const sync_type& sync)
			{
				return sense_kernel<SenseKernel>() ? E_OK : sync_type::enable();
			}
		};

	}

	/**
	 *	@class	taskexception_body taskexception.hpp <toppers/taskexception.hpp>
	 *	@brief	㳰롼ư쥯饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 㳰롼硢@e taskexception_body ƥץ졼ȥ饹 public
	 *	Ѿ饹η@e taskexception_entry ƥץ졼ȴؿΥƥץ졼
	 *	Ϥ
	 *
	 *	@see	taskexception taskexception_entry
	 */
	template <	class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB	>
	class taskexception_body : public task_context_body<Diagnostics, Stub>
	{
		TOPPERS_STATIC_ASSERT(!Diagnostics::use_exception);
		TEXPTN texptn_;
		task<0, Diagnostics, Stub> task_;
		static TEXPTN texmask_;

	protected:
		///	ǥȥ饯
		~taskexception_body() {}

	public:
		///	󥹥ȥ饯
		taskexception_body(TEXPTN texptn, VP_INT exinf)
			: task_context_body<Diagnostics, Stub>(exinf), texptn_(texptn), task_(get_task_id())
		{
		}

		///	֥Ȥλ
		const task<0, Diagnostics, Stub>& get_task() const
		{
			return task_;
		}

		TEXPTN get_pattern() const
		{
			return texptn_;
		}

		///	㳰ޥˤե륿
		/**
		 *	㳰ΥޥǽȤʤϡ饹 filter 
		 *	@e true ֤褦ˤФ褤
		 */
		static bool filter(TEXPTN texptn)
		{
			return texmask_ & texptn;
		}
		///	㳰ޥѹ
		static ER change_mask(TEXPTN mask)
		{
			texmask_ = mask;
			return E_OK;
		}
		///	㳰ޥλ
		static ER get_mask(TEXPTN* p_mask)
		{
			if (p_mask == 0)
				return E_PAR;
			*p_mask = texmask_;
			return E_OK;
		}
	};

	template <class Diagnostics, class Stub>
	TEXPTN taskexception_body<Diagnostics, Stub>::texmask_ = ~TEXPTN(0);


	/**
	 *	@brief	㳰롼Υƥץ졼
	 *	@ingroup	KernelObjectManager
	 *
	 *	 ƥץ졼Ȱ@e Body Ȥƻꤷܥǥ饹ΤȤ륿㳰롼롣
	 *	δؿ@e T_DTEX ¤Τ@e texrtn եɤꤹ뤳ȤǤ롣
	 *
	 *	@attention	@e DEF_TEX Ū API ˤФƻѤϡC󥱡δؿǰöåԥ󥰤뤳ȡ
	 *	@see	taskexception_body
	 */
	template <class Body>
	inline void taskexception_entry(TEXPTN texptn, VP_INT exinf)
	{
		if (Body::filter(texptn))
		{
			Body body(texptn, exinf);
			body.run();
		}
	}

}

#endif	// ! TOPPERS_TASKEXCEPTION_HPP_
