/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: trace.hpp,v 1.3 2004/01/26 00:53:45 takagi-n Exp $
 */

/**
 *	@file	toppers/trace.hpp
 *	@brief	¹Իȥ졼˴ؤ
 *
 *	 ΥإåեǤϰʲΥƥץ졼ȥ饹ƥץ졼ȴؿӥޥƤ롣
 *
 *	@code
 *	class null_tracer;
 *	class syslog_tracer<Count, BufferSize, Diagnostics>;
*	Tracer& operator<<(Tracer&, T);
 *	TOPPERS_TYPENAME(type);
 *	@endcode
 */

#ifndef	TOPPERS_TRACE_HPP_
#define	TOPPERS_TRACE_HPP_

#include <toppers/diagnostics.hpp>
#include <toppers/kernelstatus.hpp>
#include <limits>
#include <typeinfo>

/**
 *	@def	TOPPERS_TYPENAME(type)
 *	@brief	̾ɽʸμ
 *	@ingroup	Diagnostics
 */
#ifdef	__GNUC__
#define	TOPPERS_TYPENAME(type)	toppers::type_name<__typeof__(type)>::get()
#else
#define	TOPPERS_TYPENAME(type)	toppers::type_name_helper(type)
#endif

namespace toppers
{

	/**
	 *	@class	null_tracer	trace.hpp	<toppers/trace.hpp>
	 *	@brief	Ϥʤǡȥ졼饹
	 *	@ingroup	Diagnostics
	 *
	 *	 @e null_tracer ϥǡȥ졼޻ߤ뤿Υ饹ȤƻѤ롣
	 *	¾Υǡȥ졼饹ѤƤ륳ɤФơǡȥ졼饹
	 *	@e null_tracer ѹǥǡȥ졼޻ߤ뤳ȤǤ롣
	 */
	class null_tracer
	{
	public:
		///	ߡϱ黻
		template <typename T>
		null_tracer& operator<<(const T& obj)
		{
			return *this;
		}
	};

	namespace detail
	{

		enum
		{
			boolalpha	= 0x0001,
			showbase	= 0x0002,
			uppercase	= 0x0004,
			oct			= 0x0030,
			hex			= 0x0050,
			basefield	= 0x0070
		};

		struct setpri_helper
		{
			UINT prio_;
		};

		struct setfill_helper
		{
			char fill_;
		};

		struct setwidth_helper
		{
			int width_;
		};

		template <typename Int, typename Putter, typename Dest>
		void convert(Int value, unsigned int base, bool uppercase, bool showbase,
					int width, bool minus, char fill, Putter putter, Dest dest)
		{
			typedef	std::numeric_limits<Int>	limits;
			TOPPERS_STATIC_ASSERT(limits::is_integer && !limits::is_signed);
			char	buf[33];
			int i = 0;
			Int t = value;
			do
			{
				static const char upper[] = "0123456789ABCDEF";
				static const char lower[] = "0123456789abcdef";
				int d = t % base;
				buf[i++] = uppercase ? upper[d] : lower[d];
				t /= base;
			} while (t != 0);

			if (minus)
				--width;
			if (minus && fill != '\0')
			{
				putter('-', dest);
			}
			if (value != 0 && showbase)
			{
				switch (base)
				{
				case 8:
					--width;
					putter('0', dest);
					break;
				case 16:
					width -= 2;
					putter('0', dest);
					putter(uppercase ? 'X' : 'x', dest);
					break;
				}
			}
			for (int j = i; j < width; j++)
			{
				putter(fill, dest);
			}
			if (minus && fill == '\0')
			{
				putter('-', dest);
			}
			while (i > 0)
			{
				putter(buf[--i], dest);
			}
		}

	}

	/**
	 *	@class	syslog_tracer	trace.hpp	<toppers/trace.hpp>
	 *	@brief	syslogѤǡȥ졼饹
	 *	@ingroup	Diagnostics
	 *
	 *	 @e syslog_tracer ƥץ졼ȥ饹ϡ TOPPERSͥΥƥѤǡȥ졼ǽǤꡢ
	 *	@e std::ostream Υ֥åȤȤƤεǽƤ롣\n
	 *	 ֤̾ΰ㤤̵뤹С << 黻Ҥȼʥޥ˥ԥ졼Ѥƥǥ󥰤뤳Ȥˤꡢ夫ưפ
	 *	@e std::ostream ֤뤳ȤǤ롣
	 */
	template <	std::size_t Count = 32,
				std::size_t BufferSize = 256,
				class Diagnostics = TOPPERS_DEFAULT_DIAGNOSTICS>
	class syslog_tracer : Diagnostics
	{
		TOPPERS_STATIC_ASSERT(TKERNEL_MAKER == 0x0118);
		UINT prio_;
		UINT flags_;
		int width_;
		char fill_;
		char* buf_, * ptr_;
		
		static char buffer_[Count][BufferSize];
		static std::size_t cur_;

		void get_buf();

	public:
		///	󥹥ȥ饯
		explicit syslog_tracer(UINT prio = 5u)
			: prio_(prio)
		{
			get_buf();
			init();
		}

		///	ν
		void init()
		{
			flags_ = 0;
			width_ = 0;
			fill_  = ' ';
		}

		///	ꤵƤե饰֤
		UINT flags() const
		{
			return flags_;
		}
		///	ե饰򿷤ꤷꤵƤե饰֤
		UINT flags(UINT fmtfl)
		{
			UINT prev = flags_;
			flags_ = fmtfl;
			return prev;
		}

		///	ե饰ɲäꤵƤե饰֤
		UINT setf(UINT fmtfl)
		{
			UINT prev = flags_;
			flags_ |= fmtfl;
			return prev;
		}
		///	mask ǻꤵ줿եɤΥե饰ɲäꤵƤե饰֤
		UINT setf(UINT fmtfl, UINT mask)
		{
			UINT prev = flags_;
			flags_ = (flags_ & ~mask) | fmtfl;
			return prev;
		}
		///	ե饰ꤵƤե饰֤
		UINT unsetf(UINT mask)
		{
			UINT prev = flags_;
			flags_ &= ~mask;
			return prev;
		}

		///	ꤵƤǾե֤
		int width() const
		{
			return width_;
		}
		///	ǾեꤷꤵƤǾե֤
		int width(int wide)
		{
			int prev = width_;
			width_ = wide >= 0 ? wide : 0;
			return prev;
		}

		///	ꤵƤ뽼Ŷʸ֤
		char fill() const
		{
			return fill_;
		}
		///	ŶʸꤷꤵƤŶʸ֤
		char fill(char c)
		{
			char prev = fill_;
			fill_ = c ? c : ' ';
			return prev;
		}

		///	ꤵƤ٤֤
		UINT priority() const
		{
			return prio_;
		}
		///	ȥ졼ν٤ꤷꤵƤ٤֤
		UINT priority(UINT prio)
		{
			UINT prev = prio_;
			prio_ = prio;
			return prev;
		}

		///	ȥ졼ХåեƤºݤ˽Ϥ롣
		syslog_tracer<Count, BufferSize, Diagnostics>& flush()
		{
			SYSLOG log;
			log.logtype = LOG_TYPE_COMMENT;
			log.loginfo[0] = (VP_INT)buf_;
			ER ercd = vwri_log(prio_, &log);
			Diagnostics::handle_error(ercd);
			get_buf();
			return *this;
		}

		///	ȥ졼Хåեؤ1ʸ񤭹
		syslog_tracer<Count, BufferSize, Diagnostics>& put(char c)
		{
			if (ptr_ - buf_ < Count)
				*ptr_++ = c;
			return *this;
		}
		///	ȥ졼Хåեؤʸ񤭹
		syslog_tracer<Count, BufferSize, Diagnostics>& put(const char* s)
		{
			while (*s != '\0' && ptr_ - buf_ < Count)
				*ptr_++ = *s++;
			*ptr_ = '\0';
			return *this;
		}

		/**
		 *	@brief	إѡؿΥХå1ʸ񤭹
		 *	@param	c:	񤭹ʸ
		 *	@param	p:	syslog_tracer<Count, BufferSize, Diagnostics>ؤΥݥ
		 *	@attention	ָΨΤᡢ@e p η@e void* ˤʤäƤ뤬
		 *				ºݤ˻ꤹɬΥСؿ°륯饹ؤ
		 *				ݥ󥿤ꤹʥƥץ졼Ȱޤǹפ뤳ȡˡ
		 */
		static void putter(char c, void* p)
		{
			static_cast<syslog_tracer<Count, BufferSize, Diagnostics>*>(p)->put(c);
		}
	};

	template <std::size_t Count, std::size_t BufferSize, class Diagnostics>
	char syslog_tracer<Count, BufferSize, Diagnostics>::buffer_[Count][BufferSize];

	template <std::size_t Count, std::size_t BufferSize, class Diagnostics>
	std::size_t syslog_tracer<Count, BufferSize, Diagnostics>::cur_;

	template <std::size_t Count, std::size_t BufferSize, class Diagnostics>
	void syslog_tracer<Count, BufferSize, Diagnostics>::get_buf()
	{
		bool locked = cpulock<Diagnostics>::sense();
		if (!locked)
			cpulock<Diagnostics>::lock(context_independent);

		buf_ = buffer_[cur_++];
		if (cur_ >= Count)
			cur_ = 0;

		if (!locked)
			cpulock<Diagnostics>::unlock(context_independent);

		ptr_ = buf_;
		*ptr_ = '\0';
	}

	///	ȥ졼ͥѥޥ˥ԥ졼
	detail::setpri_helper setpri(UINT prio)
	{
		detail::setpri_helper t;
		t.prio_ = prio;
		return t;
	}

	template <std::size_t Count, std::size_t BufferSize, class Diagnostics>
	syslog_tracer<Count, BufferSize, Diagnostics>& operator<<(syslog_tracer<Count, BufferSize, Diagnostics>& tr, const detail::setpri_helper& helper)
	{
		tr.priority(helper.prio_);
		return tr;
	}

	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const detail::setpri_helper& helper)
	{
		return tr;
	}

	///	Ԥӥեåѥޥ˥ԥ졼
	template <std::size_t Count, std::size_t BufferSize, class Diagnostics>
	syslog_tracer<Count, BufferSize, Diagnostics>& endl(syslog_tracer<Count, BufferSize, Diagnostics>& tr)
	{
		return tr.flush();
	}

	///	ʸѥޥ˥ԥ졼
	template <std::size_t Count, std::size_t BufferSize, class Diagnostics>
	syslog_tracer<Count, BufferSize, Diagnostics>& boolalpha(syslog_tracer<Count, BufferSize, Diagnostics>& tr)
	{
		tr.setf(detail::boolalpha);
		return tr;
	}

	///	ʸѥޥ˥ԥ졼
	template <std::size_t Count, std::size_t BufferSize, class Diagnostics>
	syslog_tracer<Count, BufferSize, Diagnostics>& unboolalpha(syslog_tracer<Count, BufferSize, Diagnostics>& tr)
	{
		tr.unsetf(detail::boolalpha);
		return tr;
	}

	///	Ƭղûѥޥ˥ԥ졼
	template <std::size_t Count, std::size_t BufferSize, class Diagnostics>
	syslog_tracer<Count, BufferSize, Diagnostics>& showbase(syslog_tracer<Count, BufferSize, Diagnostics>& tr)
	{
		tr.setf(detail::showbase);
		return tr;
	}

	///	Ƭղûѥޥ˥ԥ졼
	template <std::size_t Count, std::size_t BufferSize, class Diagnostics>
	syslog_tracer<Count, BufferSize, Diagnostics>& unshowbase(syslog_tracer<Count, BufferSize, Diagnostics>& tr)
	{
		tr.unsetf(detail::showbase);
		return tr;
	}

	///	ʸѥޥ˥ԥ졼
	template <std::size_t Count, std::size_t BufferSize, class Diagnostics>
	syslog_tracer<Count, BufferSize, Diagnostics>& uppercase(syslog_tracer<Count, BufferSize, Diagnostics>& tr)
	{
		tr.setf(detail::uppercase);
		return tr;
	}

	///	ʸѥޥ˥ԥ졼
	template <std::size_t Count, std::size_t BufferSize, class Diagnostics>
	syslog_tracer<Count, BufferSize, Diagnostics>& lowercase(syslog_tracer<Count, BufferSize, Diagnostics>& tr)
	{
		tr.unsetf(detail::uppercase);
		return tr;
	}

	///	10ʿѥޥ˥ԥ졼
	template <std::size_t Count, std::size_t BufferSize, class Diagnostics>
	syslog_tracer<Count, BufferSize, Diagnostics>& dec(syslog_tracer<Count, BufferSize, Diagnostics>& tr)
	{
		tr.unsetf(detail::basefield);
		return tr;
	}

	///	8ʿѥޥ˥ԥ졼
	template <std::size_t Count, std::size_t BufferSize, class Diagnostics>
	syslog_tracer<Count, BufferSize, Diagnostics>& oct(syslog_tracer<Count, BufferSize, Diagnostics>& tr)
	{
		tr.setf(detail::oct, detail::basefield);
		return tr;
	}

	///	16ʿѥޥ˥ԥ졼
	template <std::size_t Count, std::size_t BufferSize, class Diagnostics>
	syslog_tracer<Count, BufferSize, Diagnostics>& hex(syslog_tracer<Count, BufferSize, Diagnostics>& tr)
	{
		tr.setf(detail::hex, detail::basefield);
		return tr;
	}

	///	ʤޥ˥ԥ졼λ
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, Tracer& (*manip)(Tracer&))
	{
		return (*manip)(tr);
	}

	///	Ŷʸѥޥ˥ԥ졼
	detail::setfill_helper setfill(char c)
	{
		detail::setfill_helper t;
		t.fill_ = c;
		return t;
	}

	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const detail::setfill_helper& helper)
	{
		tr.fill(helper.fill_);
		return tr;
	}

	///	Ǿեѥޥ˥ԥ졼
	detail::setwidth_helper setw(int width)
	{
		detail::setwidth_helper t;
		t.width_ = width;
		return t;
	}

	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const detail::setwidth_helper& helper)
	{
		tr.width(helper.width_);
		return tr;
	}

	///	Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, bool x)
	{
		int width = tr.width();
		char fill = tr.fill();

		if (tr.flags() & detail::boolalpha)
		{
			for (int i = (x ? sizeof("true") : sizeof("false")) - 1; i < width; i++)
				tr.put(fill);
			tr.put(x ? "true" : "false");
		}
		else
		{
			for (int i = 1; i < width; i++)
				tr.put(fill);
			tr.put(x ? '1' : '0');
		}
		return tr;
	}

	///	ʸΥȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, char x)
	{
		int width = tr.width();
		char fill = tr.fill();

		for (int i = 1; i < width; i++)
			tr.put(fill);
		tr.put(x);
		return tr;
	}

	///	ʸΥȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const char* x)
	{
		int width = tr.width();
		if (width > 0)
		{
			char fill = tr.fill();
			const char* s;
			for (s = x; *s != '\0'; s++) {}
			for (int i = s - x; i < width; i++)
				tr.put(fill);
		}
		tr.put(x);
		return tr;
	}

	///	long Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, long x)
	{
		bool minus = x < 0;
		unsigned long t = static_cast<unsigned long>(minus ? -x : x);
		UINT flags = tr.flags();
		unsigned int base = flags & detail::basefield;

		if (base == detail::oct)
			base = 8;
		else if (base == detail::hex)
			base = 16;
		else
			base = 10;

		detail::convert(t, base, flags & detail::uppercase, flags & detail::showbase, tr.width(), minus, tr.fill(), tr.putter, (void*)&tr);
		return tr;
	}

	///	unsigned long Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, unsigned long x)
	{
		UINT flags = tr.flags();
		unsigned int base = flags & detail::basefield;

		if (base == detail::oct)
			base = 8;
		else if (base == detail::hex)
			base = 16;
		else
			base = 10;

		detail::convert(x, base, flags & detail::uppercase, flags & detail::showbase, tr.width(), false, tr.fill(), tr.putter, (void*)&tr);
		return tr;
	}

	///	int Υȥ졼
	template <class Tracer>
	inline Tracer& operator<<(Tracer& tr, int x)
	{
		return tr << static_cast<long>(x);
	}

	///	unsigned int Υȥ졼
	template <class Tracer>
	inline Tracer& operator<<(Tracer& tr, unsigned int x)
	{
		return tr << static_cast<unsigned long>(x);
	}

#ifdef	TOPPERS_LONG_LONG

	///	long long Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, TOPPERS_LONG_LONG x)
	{
		bool minus = x < 0;
		unsigned TOPPERS_LONG_LONG t = static_cast<unsigned TOPPERS_LONG_LONG>(minus ? -t : t);
		UINT flags = tr.flags();
		unsigned int base = flags & detail::basefield;

		if (base == detail::oct)
			base = 8;
		else if (base == detail::hex)
			base = 16;
		else
			base = 10;

		detail::convert(t, base, flags & detail::uppercase, flags & detail::showbase, tr.width(), minus, tr.fill(), tr.putter, (void*)&tr);
		return tr;
	}

	///	unsigned long long Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, unsigned TOPPERS_LONG_LONG x)
	{
		UINT flags = tr.flags();
		unsigned int base = flags & detail::basefield;

		if (base == detail::oct)
			base = 8;
		else if (base == detail::hex)
			base = 16;
		else
			base = 10;

		detail::convert(x, base, flags & detail::uppercase, flags & detail::showbase, tr.width(), false, tr.fill(), tr.putter, (void*)&tr);
		return tr;
	}

#endif

	///	ݥ󥿷Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const volatile void* x)
	{
		const int char_bits = std::numeric_limits<char>::digits;
		unsigned long t = (unsigned long)x;
		detail::convert(t, 16, false, true, (sizeof(x) * char_bits + 3) / 4, false, '0', tr.putter, (void*)&tr);
		return tr;
	}

	///	T_MSG Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_msg& x)
	{
		return tr << "{ " << (void*)x.next << " }";
	}

	///	T_MSG_PRI Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_msg_pri& x)
	{
		return tr << "{ " << x.msgque << ", " << x.msgpri << " }";
	}

	///	T_CTSK Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_ctsk& x)
	{
		return tr << "{ "
					<< x.tskatr << ", "
					<< x.exinf << ", "
					<< x.task << ", "
					<< x.itskpri << ", "
					<< x.stksz << ", "
					<< x.stk
				  << " }";
	}

	///	T_RTSK Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_rtsk& x)
	{
		return tr << "{ "
					<< x.tskstat << ", "
					<< x.tskpri << ", "
					<< x.tskwait << ", "
					<< x.wobjid << ", "
					<< x.lefttmo << ", "
					<< x.actcnt << ", "
					<< x.uwpcnt << ", "
					<< x.suscnt
				  << " }";
	}

	///	T_RTST Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_rtst& x)
	{
		return tr << "{ "
					<< x.tskstat << ", "
					<< x.tskwait
				  << " }";
	}

	///	T_DTEX Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_dtex& x)
	{
		return tr << "{ "
					<< x.texatr << ", "
					<< x.texrtn
				  << " }";
	}

	///	T_RTEX Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_rtex& x)
	{
		return tr << "{ "
					<< x.texstat << ", "
					<< x.pndptn
				  << " }";
	}

	///	T_CSEM Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_csem& x)
	{
		return tr << "{ "
					<< x.sematr << ", "
					<< x.isemcnt << ", "
					<< x.maxsem
				  << " }";
	}

	///	T_RSEM Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_rsem& x)
	{
		return tr << "{ "
					<< x.wtskid << ", "
					<< x.semcnt
				  << " }";
	}

	///	T_CFLG Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_cflg& x)
	{
		return tr << "{ "
					<< x.flgatr << ", "
					<< x.iflgptn
				  << " }";
	}

	///	T_RFLG Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_rflg& x)
	{
		return tr << "{ "
					<< x.wtskid << ", "
					<< x.flgptn
				  << " }";
	}

	///	T_CDTQ Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_cdtq& x)
	{
		return tr << "{ "
					<< x.dtqatr << ", "
					<< x.dtqcnt << ", "
					<< x.dtq
				  << " }";
	}

	///	T_RDTQ Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_rdtq& x)
	{
		return tr << "{ "
					<< x.stskid << ", "
					<< x.rtskid << ", "
					<< x.sdtqcnt
				  << " }";
	}

	///	T_CMBX Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_cmbx& x)
	{
		return tr << "{ "
					<< x.mbxatr << ", "
					<< x.maxmpri << ", "
					<< x.mprihd
				  << " }";
	}

	///	T_RMBX Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_rmbx& x)
	{
		return tr << "{ "
					<< x.wtskid << ", "
					<< x.pk_msg
				  << " }";
	}

	///	T_CMTX Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_cmtx& x)
	{
		return tr << "{ "
					<< x.mtxatr << ", "
					<< x.ceilpri
				  << " }";
	}

	///	T_RMTX Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_rmtx& x)
	{
		return tr << "{ "
					<< x.htskid << ", "
					<< x.wtskid
				  << " }";
	}

	///	T_CMBF Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_cmbf& x)
	{
		return tr << "{ "
					<< x.mbfatr << ", "
					<< x.maxmsz << ", "
					<< x.mbfsz << ", "
					<< x.mbf
				  << " }";
	}

	///	T_RMBF Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_rmbf& x)
	{
		return tr << "{ "
					<< x.stskid << ", "
					<< x.rtskid << ", "
					<< x.smsgcnt << ", "
					<< x.fmbfsz
				  << " }";
	}

	///	T_CPOR Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_cpor& x)
	{
		return tr << "{ "
					<< x.poratr << ", "
					<< x.maxcmsz << ", "
					<< x.maxrmsz
				  << " }";
	}

	///	T_RPOR Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_rpor& x)
	{
		return tr << "{ "
					<< x.ctskid << ", "
					<< x.atskid
				  << " }";
	}

	///	T_RRDV Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_rrdv& x)
	{
		return tr << "{ "
					<< x.wtskid
				  << " }";
	}

	///	T_CMPF Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_cmpf& x)
	{
		return tr << "{ "
					<< x.mpfatr << ", "
					<< x.blkcnt << ", "
					<< x.blksz << ", "
					<< x.mpf
				  << " }";
	}

	///	T_RMPF Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_rmpf& x)
	{
		return tr << "{ "
					<< x.wtskid << ", "
					<< x.fblkcnt
				  << " }";
	}

	///	T_CMPL Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_cmpl& x)
	{
		return tr << "{ "
					<< x.mplatr << ", "
					<< x.mplsz << ", "
					<< x.mpl
				  << " }";
	}

	///	T_RMPL Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_rmpl& x)
	{
		return tr << "{ "
					<< x.wtskid << ", "
					<< x.fmplsz << ", "
					<< x.fblksz
				  << " }";
	}

	///	T_CCYC Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_ccyc& x)
	{
		return tr << "{ "
					<< x.cycatr << ", "
					<< x.exinf << ", "
					<< x.cychdr << ", "
					<< x.cyctim << ", "
					<< x.cycphs
				  << " }";
	}

	///	T_RCYC Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_rcyc& x)
	{
		return tr << "{ "
					<< x.cycstat << ", "
					<< x.lefttim
				  << " }";
	}

	///	T_CALM Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_calm& x)
	{
		return tr << "{ "
					<< x.almatr << ", "
					<< x.exinf << ", "
					<< x.almhdr
				  << " }";
	}

	///	T_RALM Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_ralm& x)
	{
		return tr << "{ "
					<< x.almstat << ", "
					<< x.lefttim
				  << " }";
	}

	///	T_DOVR Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_dovr& x)
	{
		return tr << "{ "
					<< x.ovratr << ", "
					<< x.ovrhdr
				  << " }";
	}

	///	T_ROVR Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_rovr& x)
	{
		return tr << "{ "
					<< x.ovrstat << ", "
					<< x.leftotm
				  << " }";
	}

	///	T_RSYS Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_rsys& x)
	{
		return tr << "{ "
#if	TKERNEL_MAKER == 0x0118
#endif
				  << " }";
	}

	///	T_DINH Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_dinh& x)
	{
		return tr << "{ "
					<< x.inhatr << ", "
					<< x.inthdr
				  << " }";
	}

	///	T_CISR Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_cisr& x)
	{
		return tr << "{ "
					<< x.isratr << ", "
					<< x.exinf << ", "
					<< x.intno << ", "
					<< x.isr
				  << " }";
	}

	///	T_RISR Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_risr& x)
	{
		return tr << "{ "
				  << " }";
	}

	///	T_DSVC Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_dsvc& x)
	{
		return tr << "{ "
					<< x.svcatr << ", "
					<< x.svcrtn
				  << " }";
	}

	///	T_DEXC Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_dexc& x)
	{
		return tr << "{ "
					<< x.excatr << ", "
					<< x.exchdr
				  << " }";
	}

	///	T_RCFG Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_rcfg& x)
	{
		return tr << "{ "
				  << " }";
	}

	///	T_RVER Υȥ졼
	template <class Tracer>
	Tracer& operator<<(Tracer& tr, const t_rver& x)
	{
		return tr << "{ "
					<< x.maker << ", "
					<< x.prid << ", "
					<< x.spver << ", "
					<< x.pver << ", "
					<< x.pver << ", "
					<< "{ "
						<< x.prno[0] << ", "
						<< x.prno[1] << ", "
						<< x.prno[2] << ", "
						<< x.prno[3]
					<< " }"
				  << " }";
	}


	template <typename T>
	inline const char* type_name_helper(T&)
	{
		return typeid(T).name();
	}

#define	TOPPERS_DEFINE_TYPE_NAME(type)	\
	template <> inline const char* type_name<type>::get() { return #type; }

	template <typename T> 
	void _(char* name) throw()
	{
		const int offset = sizeof "void toppers::_(char*) [with T =";
		const char* first = __PRETTY_FUNCTION__ + offset;
		const char* last  = first + sizeof __PRETTY_FUNCTION__ - offset - sizeof "]";
		for (const char* s = first; s < last; s++, name++)
			*name = *s;
		*name = '\0';
	}

	template <typename T>
	struct type_name
	{
		static const char* get();
	};

	template <typename T>
	inline const char* type_name<T>::get()
	{
		static const char* name;
		if (name == 0)
		{
			int state = sns_dsp();
			if (!state)
				dis_dsp();
			if (name == 0)
			{
				static char s[sizeof __PRETTY_FUNCTION__ - 45 + 1];
				_<T>(s);
				name = s;
			}
			if (!state)
				ena_dsp();
		}
		return name;
	}

	TOPPERS_DEFINE_TYPE_NAME(char)
	TOPPERS_DEFINE_TYPE_NAME(signed char)
	TOPPERS_DEFINE_TYPE_NAME(unsigned char)
	TOPPERS_DEFINE_TYPE_NAME(short)
	TOPPERS_DEFINE_TYPE_NAME(unsigned short)
	TOPPERS_DEFINE_TYPE_NAME(int)
	TOPPERS_DEFINE_TYPE_NAME(unsigned int)
	TOPPERS_DEFINE_TYPE_NAME(long)
	TOPPERS_DEFINE_TYPE_NAME(unsigned long)
	TOPPERS_DEFINE_TYPE_NAME(long long)
	TOPPERS_DEFINE_TYPE_NAME(unsigned long long)
	TOPPERS_DEFINE_TYPE_NAME(float)
	TOPPERS_DEFINE_TYPE_NAME(double)
	TOPPERS_DEFINE_TYPE_NAME(long double)
	TOPPERS_DEFINE_TYPE_NAME(bool)
	TOPPERS_DEFINE_TYPE_NAME(wchar_t)

	TOPPERS_DEFINE_TYPE_NAME(char*)
	TOPPERS_DEFINE_TYPE_NAME(signed char*)
	TOPPERS_DEFINE_TYPE_NAME(unsigned char*)
	TOPPERS_DEFINE_TYPE_NAME(short*)
	TOPPERS_DEFINE_TYPE_NAME(unsigned short*)
	TOPPERS_DEFINE_TYPE_NAME(int*)
	TOPPERS_DEFINE_TYPE_NAME(unsigned int*)
	TOPPERS_DEFINE_TYPE_NAME(long*)
	TOPPERS_DEFINE_TYPE_NAME(unsigned long*)
	TOPPERS_DEFINE_TYPE_NAME(long long*)
	TOPPERS_DEFINE_TYPE_NAME(unsigned long long*)
	TOPPERS_DEFINE_TYPE_NAME(float*)
	TOPPERS_DEFINE_TYPE_NAME(double*)
	TOPPERS_DEFINE_TYPE_NAME(long double*)
	TOPPERS_DEFINE_TYPE_NAME(bool*)
	TOPPERS_DEFINE_TYPE_NAME(wchar_t*)

	TOPPERS_DEFINE_TYPE_NAME(const char*)
	TOPPERS_DEFINE_TYPE_NAME(const signed char*)
	TOPPERS_DEFINE_TYPE_NAME(const unsigned char*)
	TOPPERS_DEFINE_TYPE_NAME(const short*)
	TOPPERS_DEFINE_TYPE_NAME(const unsigned short*)
	TOPPERS_DEFINE_TYPE_NAME(const int*)
	TOPPERS_DEFINE_TYPE_NAME(const unsigned int*)
	TOPPERS_DEFINE_TYPE_NAME(const long*)
	TOPPERS_DEFINE_TYPE_NAME(const unsigned long*)
	TOPPERS_DEFINE_TYPE_NAME(const long long*)
	TOPPERS_DEFINE_TYPE_NAME(const unsigned long long*)
	TOPPERS_DEFINE_TYPE_NAME(const float*)
	TOPPERS_DEFINE_TYPE_NAME(const double*)
	TOPPERS_DEFINE_TYPE_NAME(const long double*)
	TOPPERS_DEFINE_TYPE_NAME(const bool*)
	TOPPERS_DEFINE_TYPE_NAME(const wchar_t*)

}

#endif	// ! TOPPERS_TRACE_HPP_
