/*
 *  TOPPERS/C++ Binding
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      C++ Binding
 *
 *  Copyright (C) 2004 by TAKAGI Nobuhisa
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: vmempool.hpp,v 1.3 2004/01/26 00:53:45 takagi-n Exp $
 */

/**
 *	@file	toppers/vmempool.hpp
 *	@brief	Ĺס椹륯饹
 *
 *	 ΥإåեǤϰʲΥƥץ졼ȥ饹Ƥ롣
 *
 *	@code
 *	class vmempool<Id, Diagnostics, Stub>;
 *	@endcode
 */

#ifndef	TOPPERS_VMEMPOOL_HPP_
#define	TOPPERS_VMEMPOOL_HPP_

#include <toppers/object.hpp>

namespace toppers
{

	/**
	 *	@class	vmempool vmempool.hpp <toppers/vmempool.hpp>
	 *	@brief	Ĺסεǽ򥫥ץ벽ƥץ졼ȥ饹
	 *	@ingroup	KernelObjectManager
	 *
	 *	 @e vmempool ƥץ졼ȥ饹ϡĹס򥫥ץ벽ȤȤˡ
	 *	¾Υסȸ򴹲ǽʥ󥿥ե󶡤Ƥ롣
	 *
	 *	@attention	Υƥץ졼ȥ饹ϳĥӥѤƤ뤿ᡢ
	 *				ɥץեΥͥǤϥѥ륨顼ˤʤ롣
	 *	@see	fmempool
	 */
	template <	ID Id			= 0,
				class Diagnostics	= TOPPERS_DEFAULT_DIAGNOSTICS,
				class Stub		= TOPPERS_DEFAULT_STUB	>
	class vmempool : Diagnostics
	{
		typedef	object_controller<Id, obj_vmempool, Stub>	controller;
		object_id<Id> objid_;

	public:
		typedef	typename controller::creation	creation;
		typedef	typename controller::reference	reference;

		/**	@name	󥹥ȥ饯	*/
		//@{

		///	ǥեȥ󥹥ȥ饯
		vmempool() {}
		///	IDֹΥ󥹥ȥ饯
		explicit vmempool(ID id) : objid_(id) {}

		///	ƥץ졼Ȱ㤤Ѵ󥹥ȥ饯
		template <ID Id2, class Diagnostics2, class Stub2>
		vmempool(const vmempool<Id2, Diagnostics2, Stub2>& other)
			: objid_(get_unsafe_id(other))
		{
			TOPPERS_STATIC_ASSERT(Id == 0);
		}

		//@}

		/**	@name	Ⱥ	*/
		//@{

		//	ߴΤ¿
		ER create(creation* pk_cobj)
		{
			ER ercd = controller::create(objid_, pk_cobj);
			return handle_error(ercd);
		}
		///	Ĺס
		ER create(const creation* pk_cobj)
		{
			ER ercd = controller::create(objid_, pk_cobj);
			return handle_error(ercd);
		}
		///	Ĺסʸ̤Υեɻ
		ER create(ATR mplatr = TA_TFIFO, UINT mplsz = 1024, VP mpl = 0)
		{
			creation packet;
			packet.mplatr = mplatr;
			packet.mplsz  = mplsz;
			packet.mpl    = mpl;
			return create(&packet);
		}
		///	Ĺסκ
		ER destroy()
		{
			ER ercd = controller::destroy(objid_);
			return handle_error(ercd);
		}

		//@}

		/**	@name	ֻ	*/
		//@{

		///	Ĺסξֻ
		ER refer(reference* pk_robj) const
		{
			ER ercd = controller::refer(objid_, pk_robj);
			return handle_error(ercd);
		}

		//@}

		/**	@name	֥åγȲ	*/
		//@{

		///	Ĺ֥åγ
		ER get(UINT blksz, VP* p_blk, forever_tag = forever) const
		{
			ER ercd = Stub::stub_get_mpl(objid_.id(), blksz, p_blk);
			return handle_error(ercd);
		}
		///	Ĺ֥åγʥݡ󥰡
		ER get(UINT blksz, VP* p_blk, polling_tag) const
		{
			ER ercd = Stub::stub_pget_mpl(objid_.id(), blksz, p_blk);
			return handle_error(ercd);
		}
		///	Ĺ֥åγʥॢȻ
		ER get(UINT blksz, VP* p_blk, TMO tmout) const
		{
			ER ercd = Stub::stub_tget_mpl(objid_.id(), blksz, p_blk, tmout);
			return handle_error(ercd);
		}

		///	Ĺ֥åβ
		ER release(VP blk) const
		{
			ER ercd = Stub::stub_rel_mpl(objid_.id(), blk);
			return handle_error(ercd);
		}

		//@}

		///	ĹסIDֹμ
		friend ID get_unsafe_id(const vmempool<Id, Diagnostics, Stub>& vmempool)
		{
			return vmempool.objid_.id();
		}
	};

}

#endif	// ! TOPPERS_VMEMPOOL_HPP_
